        PROGRAM TEMPDEQC
C
C
C**** *TEMPDEQC*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         TEMP DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *READIN ( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1U( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
c	   Ultima alteracao e correcao em 10.2000
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comrec.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
c
c
      character*15 cstop
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
c
C
      CALL INITVAR( IERR )

C
C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='temp.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN',organization='relative',recl=2560)
C     ----------------------------------------------------------------

C*          2.   READ IN BULLETIN.
C                -----------------
 200  CONTINUE
c
      ierr = 0
c
C     ------------------------------------------------------------------
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
C     ------------------------------------------------------------------
C*          3.   FORMAT BULLETIN.
C                ----------------
 300  CONTINUE
C
      CALL PROCRFB( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(IERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          4.   DECODE BULLETIN HEADER.
C                -----------------------
 400  CONTINUE
C
      CALL PROCHDR( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          5.   CHECK TEXT OF BULLETIN.
C                -----------------------
 500  CONTINUE
C
      CALL PROCTXT( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C
C     ------------------------------------------------------------------
C*          6.   CALL APPROPRIATE ROUTINE TO DECODE TEMP DATA.
C                ---------------------------------------------
 600  CONTINUE
C
      CALL PROCT1U( IERR )
C
C
      GO TO 200
C
C     ------------------------------------------------------------------
 1000 CONTINUE
C
C 
      close(unit=99)
c
c----|-----------------------------------------------------------------|-------|
c		Criar uma estatistica do processamento das  
c               mensagens Serao incluida no arquivo cabecalho.dat.
c               
c             ________________________________________________
c             | VARIAVEL   |        DESCRICAO                |
C             |============|=================================|
c	      |	numbull    |   Numero de boletins lidos,     |
C             |------------|---------------------------------|
c             | numbullerr |   Numero de boletins com erro,  |
C             |------------|---------------------------------|
c             | numreport  |   Numero de mensagens lidas,    |
C             |------------|---------------------------------|
c	      |	numreperr  |   Numero de mensagens com erro, |
C             |------------|---------------------------------|
c    	      | irecswriten|   Numero de mensagens gravadas, |
C             |------------|---------------------------------|
c	      | irepetida  |   Numero de mensagens repetidas |
C             |------------|---------------------------------|
c             | inil       |   Numero de mensagens ignoradas |
c             |______________________________________________|
c               
c------------------------------------------------------------------------------

      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(91,file='mesg_err.dat',status='old',access='append')
c
c------------------------------------------------------------------------------

      write(91,20)
      write(91,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida,inil
 10   format('| TEMP      |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |'
     c       ,I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |')
      write(91,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|')
c
c------------------------------------------------------------------------------
      close(91)
c
      stop
      END
      
      SUBROUTINE READIN( IERR )
C
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
 
      CHARACTER*16384 YCHAR
      Character*16384 buff_aux
      Character*4 four_chars
      Character*4 endmsg
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
      DATA NSKIP/0/
c     Data aux/'03010D0D'Z/       ! ^C^A^M^M (separador de mensagens)
      Data aux/'0D0D0103'Z/       ! ^C^A^M^M (separador de mensagens)
C
 
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR= 0
      NWPT= 1
      NBPT= 0
      NSUB= 0
C
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
      IERR=0
C
      OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE='temp.dat',
     1     STATUS='OLD')
 
C
      Write(endmsg,10) aux     ! ^C^A^M^M (separador de mensagens)
 10   Format(a4)
 110  CONTINUE
      index = 1
      ilen = 1
      four_chars = char(0) // char(0) // char(0) // char(0)
c     
      Do While(four_chars .ne. endmsg)
      READ (3,'(Q,A)',ERR=200,END=300,IOSTAT=IOS) ILEN,YCHAR
      buff_aux(index:index+ilen-1) = ychar(1:ilen)
c     ------------------------------------------------------------------
c      Alteracao (Gamb) para cobrir problema do fortran v3.8. 
c       Na leitura do arquivo stream_LF,tem como final de registro um LF e CR,
c       sendo que este ultimo faz parte da mensagem, e por isso foi novamente 
c       acrescentado. 
c
c            A T E N C A O - checar as novas versoes do fortran/OSF.
c
c                    Rosangela.  04.07.96
c     ------------------------------------------------------------------
      index = index + ilen
      ilen = ilen + 1   
      buff_aux(index:index) = char(13)  ! O CR nao vem na leitura
      ychar(ilen:ilen) = char(13)
      four_chars = ychar(ilen-3:ilen)
c
      end do
c
      ilen = index - 1
      ychar(1:ilen) = buff_aux(1:ilen)
c
C
      if(ilen.gt.4) NUMBULL=NUMBULL + 1
C
C*          1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C*          1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.LE.NSKIP) GO TO 100
C
C*          1.4  TRANSFER BULLETIN TO 'KCHAR', ONE CHARACTER PER WORD
C                -----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
      RETURN
C     -----------------------------------------------------------------
 200  CONTINUE
C
      IERR=1
      WRITE(*,9901) IOS
      PRINT*,'READIN: ILEN=',ILEN
      RETURN
C     -----------------------------------------------------------------
 300  CONTINUE
C
      IEOF=1
      PRINT*,'READIN: END OF FILE IEOF=',IEOF
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ----------------------------------------------------------------
 9901 FORMAT(1H0,'+ + + ERROR IN READING BULLETIN FILE. IOSTAT=',
     C I6,' DECIMAL')
 9902 FORMAT(1H ,'BULLETIN NUMBER IS ',I6)
 9903 FORMAT(1H0,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=',
     C I6,' DECIMAL')
C     ----------------------------------------------------------------
      END
      
      SUBROUTINE PROCRFB ( IERR )
C**** *PROCRFB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO FORMAT BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCRFB(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C     ------------------------------------------------------------------
C*          1.   KEEP SOURCE OF DATA AND DATE/TIME OF ARRIVAL.
C                ---------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,3
C
      KHEAD(I)=MINDIC      ! THIS WILL BE CHANGED ACCORDING TO THE KEY.
C
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2.  DEFINE T1 AND T2 FROM ABBREVIATED HEADING.
C               ------------------------------------------
 200  CONTINUE

      DO 202 I=1,ILEN
C
      IF(KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 203
C
 202  CONTINUE
C
      IT1=27
      GO TO 210
C
 203  CONTINUE
C
      IT1=KCHAR(I  )-64
      IT2=KCHAR(I+1)-64
C
      IF(IT1.NE.21) THEN
                       IERR=1
                       IT1=27
                       RETURN
                    END IF
C
C     CHECK IF 'T2' CHARACTER IS LETTER.
C
      IF(IT2.LT.0.OR.IT2.GT.26) IT1=27
C
C*          2.1  LAST CHARACTER OF BULLETIN CAN BE IN ANY OF THE LAST
C                -----------------------------------------------------
C                5 WORDS. IF CHARACTER  IS 'ETX' REPLACE BY 'GS' .
C                -------------------------------------------------
C                IF NEITHER CAN BE FOUND INSERT 'GS' AS LAST CHARACTER.
C                ------------------------------------------------------
 210  CONTINUE
C
      IST=ILEN-5
C
      DO 211 I=1,ILEN
C
      IF (KCHAR(I).EQ.3.OR.KCHAR(I).EQ.29) THEN
                                              KCHAR(I)= 29
                                              IGS=I
                                              RETURN
                                           END IF
C
 211  CONTINUE
C
      I=I-1
      KCHAR(I)= 29
      IGS=I
C
      RETURN
      END
      
      SUBROUTINE PROCTXT ( IERR )
C
C**** *PROCTXT*
C
C
C     PURPOSE.
C     --------
C          CHECKS WHETHER BULLETIN CONTAINS USEFUL DATA .
C          THE FOLLOWING BULLETINS ARE CONSIDERED TO CONTAIN
C          NO USEFUL DATA.
C                 1. TEXT OF 'NIL' , OR VARIANTS OF THIS.
C                 2. TEXT OF 'NO DATA AVAILABLE'.
C                 3. TEXT OF 'NO REPORTS AVAILABLE'.
C                      1. - 3.  ARE DETERMINED SIMPLY BY CHECKING
C                      THE LENGTH OF THE TEXT . IF IT IS LESS
C                      THAN 26 THERE CANT BE ANY USEFUL DATA IN IT
C                 4. UK AND GERMAN DOMESTIC BULLETINS WHICH DO
C                    NOT CONFORM TO WMO CODES.
C
C          INPUT     : BULLETIN IN ARRAY 'KCHAR' ,
C                      ONE CHARACTER PER WORD.
C
C          OUTPUT    : KERR = 0 INDICATES BULLETIN CONTENTS REQUIRED.
C                           = 1 MEANS TEXT OF 'NIL' ETC.
C                           = 2 UK OR GERMAN DOMESTIC BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCTXT(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *SAVBULL(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR.
C                ----------------------
 100  CONTINUE
C
      KERR= 0
C
C
C*          1.1  CHECK IF BULLETIN IS TOO SHORT I.E. "NIL" BULLETIN.
C                ---------------------------------------------------
 110  CONTINUE
C
      ILE = IGS - IMI
      IF(ILE .LT. 26) THEN
                         KERR = 7
                         NUMBERR(7) = NUMBERR(7) + 1
                                KCHAR(IGS)=KCHAR(IGS).OR.128
C                               GO TO 900
                      END IF
C
C
C*          1.2  CHECK IF THE BULLETIN IS DOMESTIC FROM UK OR GERMANY.
C                -----------------------------------------------------
C                THIS IS DONE BY CHECKING IF THE BULLETIN HAS
C                --------------------------------------------
C                CCCC OF (EG--,ED--) OTHER THAN (EGRR,EDZW).
C                -------------------------------------------
 120  CONTINUE
C
      IPT=IAH+4
      CALL NEXTLET(IPT,JAH)
C
C     IF BULLETINS HAVE 'CCCC' NOT 'ED--' OR 'EG--' , RETURN.
C
      IF ( KCHAR(IPT).NE.69 ) RETURN
      IF ( KCHAR(IPT+1).NE.71.AND.KCHAR(IPT+1).NE.68 ) RETURN
C
C        FIRST UK
C
             IF (KCHAR(IPT+1).EQ.71)
     C                      THEN
                                 IF(KCHAR(IPT+2) .NE. 82 .OR.
     1                              KCHAR(IPT+3) .NE. 82)
     2                                   KERR = 8
                            ELSE
C
C        THEN GERMANY
C
                                 IF(KCHAR(IPT+2) .NE. 90 .OR.
     1                              KCHAR(IPT+3) .NE. 87)
     2                                   KERR = 8
                            END IF
C
C     MARK CCCC GROUP IF REQUIRED.
C
      IF ( KERR.EQ.8 ) THEN
                              KCHAR(IPT+4) = KCHAR(IPT+4).OR.128
                              NUMBERR(8) = NUMBERR(8) + 1
                          END IF
C
C           1.3 TREAT IN ACCORDANCE WITH DEFINED OPTIONS.
C               -----------------------------------------
 130  CONTINUE
C
C     RETURN IF NO ERROR.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
 900  CONTINUE
C
      N = KERR - 1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C           1.4  PRINT BULLETIN IF REQUIRED.
C                ---------------------------
 140  CONTINUE
C
      IF (N1.EQ.1) THEN
                       WRITE (*,9900) KERR
                       CALL PRTBULL (1,IGS)
                   END IF
C
C           1.5 WRITE TO ERROR FILE IF REQUIRED.
C               --------------------------------
 150  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
      RETURN
C     -----------------------------------------------------------------
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C     -----------------------------------------------------------------
      END
      
      SUBROUTINE PROCHDR ( IERR )
C
C**** *PROCHDR
C
C
C     PURPOSE.
C     --------
C         DEODE BULLETIN HEADER AND INSERT REQUIRED parameterS
C         IN DECODED REPORT HEADER.
C
C         LOCATES BEGINNING  AND END OF ABBREVIATED HEADER AND
C         'MIMIMJMJ' LINES.
C
C         INPUT     : BULLETIN IN KCHAR(1) - KCHAR(IGS)
C
C                     BULLETIN RECORD HEADER IN KINT(1) - KINT(5)
C
C                     'IT1' = 27 INDICATING BULLETIN HAS NOT BEEN
C                            IDENTIFIED FROM 'TT' OF ABBREVIATED HEADER.
C
C         OUTPUT    : KDEC(10) = DAY OF MONTH ( INTEGER ) . YY
C                     KDEC(11) = TIME OF BULLETIN - HOURS ( INTEGER ) . G
C                     KDEC(12) = TIME OF BULLETIN - MINS ( INTEGER ) . GG
C
C                     KDEC(14) = 0 IF ORIGIN OF REPORT IS FGGE.
C                                1  "   "     "    "    " BRACKNELL.
C                                2  "   "     "    "    " OFFENBACH.
C
C                     KDEC(21) =1 IF BULLETIN IS 'COR' , OTHERWISE
C                                    = 0 .
C
C                     KDEC(21) = 1 IF BULLERIN IS 'CCA'
C                     KDEC(21) = 2 IF BULLERIN IS 'CCB'
C                     KDEC(21) = 3 IF BULLERIN IS 'CCC'
C                     KDEC(21) = 4 IF BULLERIN IS 'CCD'
C                     .
C                     .
C
C                     KDEC(18) = DATE OF BULLETIN ARRIVAL ( ON VAX )
C                     KDEC(19) = TIME  "    "        "      "     "
C
C                     IAH =    "      " BEGINNING OF 'ABBREVIATED HEADER'
C                     JAH =    "      "     END   "       "         "
C
C                     IMI =    "      " BEGINNING OF 'MIMIMJMJ' LINE.
C                     JMI =    "      "     END   "       "       "
C
C                     KERR = 0 IF NO ERROR FATAL TO DECODING ENCOUNTERED.
C                         = 1 IF BULLETIN HAS LESS THAN 3 LINES.
C                         = 2 IF BULLETIN IS NOT RECOGNISED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCHDR( IERR )*
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I,N1,N2,N3,N4,N5,N,IRET)*
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *SAVBULL(IERR )*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION ILST(26)
      DATA ILST/65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     1          81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR AND SET REPORT HEADER AREA
C                ------------------------------------------------
C                TO MISSING DATA INDICATOR.
C                --------------------------
 100  CONTINUE
C
      KERR=0
C
      DO 101 I=1,24
C
      KDEC(I)= MINDIC
C
 101  CONTINUE
C
C*          1.1  FLAG FIELDS SET TO ZERO.
C                ------------------------
 110  CONTINUE
C
      KDEC(13)=0
      KDEC(15)=0
      KDEC(21)=0
C
C*          2.  LOCATE BEGINNING AND END OF 'STARTING LINE' ,
C               ---------------------------------------------
C               'ABBREVIATED HEADER' AND 'MIMIMJMJ LINE ' .
C               -------------------------------------------
C
      ISL= 1
      CALL NEXTPRT( ISL,IGS )
      JSL=ISL
      CALL NEXTEND ( JSL,IGS )
      IAH=JSL
      CALL NEXTPRT ( IAH,IGS )
      JAH=IAH
      CALL NEXTEND ( JAH,IGS )
      IMI = JAH
      CALL NEXTPRT ( IMI,IGS )
      JMI = IMI
      CALL NEXTEND ( JMI,IGS )
C
C*          2.1 IF THESE 3 LINES CANNOT BE LOCATED , BULLETIN CONSISTS
C               ------------------------------------------------------
C               OF LESS THAN 3 LINES.
C               ---------------------
 210  CONTINUE
C
      IF ( JMI.GT.IGS ) THEN
C
C                           SET ERROR NUMBER AND MARK ERROR.
C
                            KERR = 1
                            KCHAR(IGS)=KCHAR(IGS).OR.128
                            NUMBERR(1) = NUMBERR(1) + 1
                            GO TO 300
                        END IF
C
C
C
C*          2.2  BULLETIN CANNOT BE IDENTIFIED FROM 'TT' .
C                -----------------------------------------
 220  CONTINUE
C
      IF ( IT1.EQ.27 ) THEN
C
C                          SET ERROR NUMBER AND MARK ERROR.
C
                           KERR = 2
                           KCHAR(IAH+2)=KCHAR(IAH+2).OR.128
                           NUMBERR(2) = NUMBERR(2) + 1
                           GO TO 300
                       END IF
C
C
C*          2.3  NO CHECKS ARE MADE ON TTAAII OR CCCC GROUPS.
C                --------------------------------------------
 230  CONTINUE
C
C
C
C*          2.4  LOCATE AND DECODE 'YYGGGG' GROUP .
C                ----------------------------------
 240  CONTINUE
C
C     SCAN 'KCHAR' FOR FIRST FIGURE AFTER 'II' FIGURES.
C
      IPT = IAH + 6
      CALL NEXTFIG ( IPT,JAH )
      IF ( IPT.GE.JAH ) THEN
                          KERR = 5
                        ELSE
C
C                         EXTRACT YY,GG AND GG AND CONVERT TO INTEGERS
C                         IN WORDS 10-12 OF 'KINT' .
C
                          CALL EXTGRP( IPT,2,2,2,0,0,10,IRET )
                          IPT = IABS(IPT)
C
C                         TEST VALIDITY OF YY,GG AND GG.
C                         THIS TEST MAKES CHECKING RETURN CODE 'IRET'
C                         UNNECESSARY.
C
                          IF ( KINT(10).LT.1.OR.KINT(10).GT.31 )
     C                             THEN
                                        KERR = 5
                                        KINT(10) = MINDIC
                                   END IF
C
                          IF ( KINT(11).LT.0.OR.KINT(11).GT.23 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
                          IF ( KINT(12).LT.0.OR.KINT(12).GT.59 )
     C                             THEN
                                        KERR = 5
                                        KINT(11) = MINDIC
                                   END IF
C
C
C                                  COPY TO DECODED REPORT HEADER AREA
C                                  AND RESET WORDS IN 'KINT'.
C
                                   DO 241 I=10,12
                                          KDEC(I) = KINT(I)
                                          KINT(I) = MINDIC
  241                              CONTINUE
C
                        END IF
C
C     MARK ERROR IN YYGGGG GROUP.
C
      IF ( KERR.EQ.5 ) THEN
                              KCHAR(IPT)=KCHAR(IPT).OR.128
                              NUMBERR(5) = NUMBERR(5) + 1
                          END IF
C
C
C
C
C*          2.5 THE ONLY CHECK ON 'BBB' IS FOR 'COR'.
C               -------------------------------------
 250  CONTINUE
C
C     FIND NEXT LETTER IN ABBREVIATED HEADER LINE AND CHECK IF 'C' (67)
C
      CALL NEXTLET ( IPT,JAH )
C
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.79) THEN
                                                       KDEC(21)=1
                                                       GO TO 260
                                                    END IF
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.67)
     1     THEN
              DO 251 IJ=1,26
              IF(KCHAR(IPT+2).EQ.ILST(IJ)) THEN
                                              KDEC(21)=IJ
                                              GO TO 260
                                           END IF
C
 251          CONTINUE
C
           END IF
C
C
C
C*          2.6 INSERT ORIGIN AND DATE/TIME OF ARRIVAL OF BULLETIN.
C               ---------------------------------------------------
 260  CONTINUE
C
C     ORIGIN IS DERIVED FROM KEY . BRACKNELL FILE
C     NAMES START WITH 'B' AND OFFENBACH WITH 'C'. THIS FILENAME IS
C     IN ASCCI CODE       ( 'B' =66 , 'C' = 67)
C
      KDEC(14) = MINDIC    !    ORIGIN WILL BE DEFINED FROM KEY.
C
C
      KDEC(18) = MINDIC               ! DATE AND TIME OF ARRIVAL
      KDEC(19) = MINDIC               !
C
C
C
C*          2.7 TREAT ERROR BULLETIN IN ACCORDANCE WITH DEFINED OPTIONS.
C               --------------------------------------------------------
 270  CONTINUE
C
C     RETURN IF NO ERRORS FOUND.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
C*          3. HANDLE ERROR BULLETIN.
C              ----------------------
 300  CONTINUE
C
      N = KERR-1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C*          3.1 PRINT BULLETIN IF REQUIRED.
C               ---------------------------
 310  CONTINUE
C
      IF ( N1.EQ.1 ) THEN
                         WRITE (*,9900) KERR
                         CALL PRTBULL ( 1,IGS)
                     END IF
C
C*          3.2 WRITE BULLETIN TO ERROR FILE IF REQUIRED.
C               -----------------------------------------
 320  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
C
C*          3.3  ONLY ERRORS 1 AND 2 ARE FATAL TO DECODING , SO CLEAR
C                -----------------------------------------------------
C                ERROR INDICATOR BEFORE RETURNING.
C                ---------------------------------
 330  CONTINUE

c     IF ( KERR.GT.2 ) KERR = 0
      if(kerr.gt.2) then
        kerr = 0
c        ierr = 0
      end if
c
C
C
      RETURN
C
C
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C
C
      END
      
      SUBROUTINE PROCT1U ( IERR )
C
C**** *PROCT1U*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING UPPER AIR
C         DATA ( BULLETINS WITH 'T1' OF 'U' )
C
C         INPUT    : IERR IS NOT USED ON INPUT.
C
C                    IT2  = 1-26 CORRESPONDING TO 'T2' OF A-Z.
C
C         OUTPUT   : IERR IS UNALTERED UNLESS A FATAL ERROR OCCURRS ,
C                     WHEN IT IS SET TO 1.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCT1U(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *BULLUA(IERR)*
c
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		NONE.
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  CALL APPROPRIATE ROUTINE, 'IT2' CONTAINS AN INTEGER IN THE
C                ---------------------------------------------------------
C               RANGE 1-26, CORRESPONDING TO 'T2' OF ABBREVIATED HEADER.
C                -------------------------------------------------------
 100  CONTINUE
C
C
      GOTO ( 110,120,130,140,150,160,170,180,190,200,210,220,230,
     C       240,250,260,270,280,290,300,310,320,330,340,350,360) IT2
C
C     -----------------------------------------------------------------
C*              1.1  BULLETINS WITH 'TT' = 'UA'.  AIRCRAFT REPORTS.
C                    ----------------------------------------------
 110  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.2  BULLETINS WITH 'TT' = 'UB'.
C                    ---------------------------
 120  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.3  BULLETINS WITH 'TT' = 'UC'.
C                    ---------------------------
  130 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.4  BULLETINS WITH 'TT' = 'UD'.
C                    ---------------------------
  140 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.5  BULLETINS WITH 'TT' = 'UE'.  TEMP PART D.
C                    ----------------------------
  150 CONTINUE
      CALL BULLUE( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.6  BULLETINS WITH 'TT' = 'UF'.  TEMP PARTS C AND D.
C                    ---------------------------
  160 CONTINUE
      CALL BULLUF( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.7  BULLETINS WITH 'TT' = 'UG'.
C                    ----------------------------
  170 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.8  BULLETINS WITH 'TT' = 'UH'.
C                    ---------------------------
  180 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.9  BULLETINS WITH 'TT' = 'UI'.
C
  190 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.0  BULLETINS WITH 'TT' = 'UJ'.
C                    ---------------------------
 200  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.1  BULLETINS WITH 'TT' = 'UK'.   TEMP PART B.
C                    ---------------------------
 210  CONTINUE
      CALL BULLUK( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.2  BULLETINS WITH 'TT' = 'UL'.   TEMP PART C.
C                    ---------------------------
 220  CONTINUE
      CALL BULLUL( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.3  BULLETINS WITH 'TT' = 'UM'.   TEMP PARTS A AND B.
C                    ---------------------------
 230  CONTINUE
      CALL BULLUM( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              2.4  BULLETINS WITH 'TT' = 'UN'.
C                    ---------------------------
 240  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.5  BULLETINS WITH 'TT' = 'UO'.
C                    ---------------------------
 250  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.6  BULLETINS WITH 'TT' = 'UP'.
C                    ---------------------------
 260  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.7  BULLETINS WITH 'TT' = 'UQ'.
C                    ---------------------------
 270  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.8  BULLETINS WITH 'TT' = 'UR'.
C                    ---------------------------
 280  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.9  BULLETINS WITH 'TT' = 'US'.  TEMP PART A.
C                    ---------------------------
 290  CONTINUE
      CALL BULLUS( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              3.0  BULLETINS WITH 'TT' = 'UT'.
C                    ---------------------------
 300  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.1  BULLETINS WITH 'TT' = 'UU'.
C
 310  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.2  BULLETINS WITH 'TT' = 'UV'.
C
 320  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.3  BULLETINS WITH 'TT' = 'UW'.
C
 330  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.4  BULLETINS WITH 'TT' = 'UX'.
C
 340  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.5  BULLETINS WITH 'TT' = 'UY'.
C
 350  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.6  BULLETINS WITH 'TT' = 'UZ'.  TEMP DROP.
C
 360  CONTINUE
      CALL BULLUZ(IERR)
      RETURN
C
      END
      
      SUBROUTINE BULLUE ( IERR )
C
C**** *BULLUE*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF TEMP REPORTS.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLUE( IERR )*
C
C         INPUT    : BULLETIN IN CCITT 5 CHARACTER , 1 CHARACTER PER
C                    WORD IN 'KCHAR'.
C
C                    POINTERS TO BEGINNING AND END OF 'STARTING LINE',
C                    'ABBREVIATED HEADING','MIMIMJMJ LINE' AND END OF
C                    BULLETIN.
C
C                    IERR NOT USED.
C
C         OUTPUT   : DECODED REPORTS WRITTEN TO FILE AND ERROR REPORTS
C                    TO ERROR FILE.
C
C                    IERR = 1 , IF ANY FILE HANDLING ERROR.
C
C     METHOD.
C     -------
C
C         THIS ROUTINE HAS MULTIPLE ENTRY POINTS , ONE FOR
C         EACH OF THE POSSIBLE 'TT' CODES USED IN TEMP
C         BULLETIN HEADINGS . THIS ROUTINE CALLS THE APPROPRIATE
C         DECODING ROUTINES FOR EACH PART OF THE REPORTS BY
C         EXAMINING EACH 'MIMIMJMJ' GROUP.
C
C         THIS APPROACH HAS BEEN ADOPTED BECAUSE OF THE
C         FREQUENCY WITH WHICH INCORRECT BULLETINS ARE
C         RECEIVED (E.G. ALL PARTS OF A TEMP IN 1 BULLETIN)
C         AND MAINTAINS THE SUBROUTINE NAMING CONVENTIONS
C         USED.
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      ENTRY BULLUF ( IERR )
      ENTRY BULLUK ( IERR )
      ENTRY BULLUL ( IERR )
      ENTRY BULLUM ( IERR )
      ENTRY BULLUS ( IERR )
      ENTRY BULLUZ ( IERR )
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'printre.h'
c
      common /reperr/ numreperr
      common /inil/ inil
C
C
      DATA IBLOCKS/10*-1/
      DATA IDONEA /200*-1/
      DATA IDONEB /200*-1/
      DATA IDONEC /200*-1/
      DATA IDONED /200*-1/
      DATA IPRLIM /50/
C
      DATA ISTASA/
     C   100*-1/
      DATA ISTASB/
     C   100*-1/
      DATA ISTASC/
     C   100*-1/
      DATA ISTASD/
     C   100*-1/
      DATA IERSHIP / 0 /
      DATA IERALLA /0/
      DATA IERALLB /0/
      DATA IERALLC /0/
      DATA IERALLD /0/
C
C     ------------------------------------------------------------------
C*          1.   SET FLAGS,INDICATORS AND WORKING POINTERS.
C                -------------------------------------------
 100  CONTINUE
C
      ITIM = -1
C
      IF(ITIM .GE. 0)
     C   THEN
            ITIMES(1) = ITIM - 3
            IF(ITIMES(1) .LT. 0) ITIMES(1) = 21
            ITIMES(2) = ITIM + 2
         ELSE
            ITIMES(1) = 0
            ITIMES(2) = 24
         END IF
C
C-----PRINT INPUT BULLETINS OF TEMP REPORTS
C      CALL PRTBULL ( 1,IGS )
C-----PRINT INPUT BULLETINS OF TEMP REPORTS
C
C     SET FLAGS AND WORKING POINTER.
C     WORKING POINTER IS SET TO START OF 'MIMIMJMJ' LINE.
C
      IPT = IMI
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN TO
C     ERROR FILE.
C
      IHEAD = 0
C
C     SET DATA BASE REPORT TYPE INDICATORS IN DECODED REPORT HEADER
C     AND PART OF REPORT INDICATOR.
C
C     DATA BASE REPORT TYPE  : 35 = TEMP
C                              36 = TEMP SHIP
C                             135 = TEMP DROP
C                             137 = TEMP MOBILE
C
C     PART INDICATOR         : 1 = PART A
C                              2 = PART B
C                              3 = PART C
C                              4 = PART D
C
  101 CONTINUE
C
      K = IPT + 20
C
C*          1.1 CHECK IF LAND STATION ( 'MIMI' = TT ).
C               --------------------------------------
 110  CONTINUE
C
      DO 111 I = IPT,K
         IF ( KCHAR(I).EQ.84.AND.KCHAR(I+1).EQ.84)
     C        THEN
                  KDEC(4) = 35
                  IPT = I
                  GO TO 200
              END IF
  111 CONTINUE
C
C
C*          1.2 CHECK IF SHIP REPORT ( 'MIMI' = UU ), ALSO CHECK IF THIS
C               IS SHIP WITH NAME STARTING UU (LIKE UUQR), BY CHECKING
C               IF THERE IS AN OTHER GROUP UU--.
C               ALSO 'MIMI' = UM IS SHIP, WHERE PARTS A & B
C               ARE IN SAME BULLETIN
 120  CONTINUE
C
      DO 121 II = IPT,K
         IF( KCHAR(II) .EQ. 85 .AND. (KCHAR(II+1) .EQ. 85 .OR.
     C                                KCHAR(II+1) .EQ. 77) )
     C        THEN
                 if(kchar(ii+2).eq.65.and.kchar(ii+3).eq.65) go to 311
                 if(kchar(ii+2).eq.66.and.kchar(ii+3).eq.66) go to 311
                 if(kchar(ii+2).eq.67.and.kchar(ii+3).eq.67) go to 311
                 if(kchar(ii+2).eq.68.and.kchar(ii+3).eq.68) go to 311
C
                  DO 122 J=II+2,K
                  IF ( KCHAR(J).EQ.85.AND.KCHAR(J+1).EQ.85)
     C               THEN
c                       
                 if(kchar( j+2).eq.65.and.kchar( j+3).eq.65) go to 312
                 if(kchar( j+2).eq.66.and.kchar( j+3).eq.66) go to 312
                 if(kchar( j+2).eq.67.and.kchar( j+3).eq.67) go to 312
                 if(kchar( j+2).eq.68.and.kchar( j+3).eq.68) go to 312
                     END IF
c
 122             CONTINUE
c
                 go to 121
c
 312             continue
c
                 KDEC(4) = 36
                 IPT = J
                 I = J
                 GO TO 200
C
 311              continue
c
                  KDEC(4) = 36
                  IPT = II
                  I = II
                  GO TO 200
              END IF
121   CONTINUE
C
C*          1.3  CHECK IF DROP SONDE ( 'MIMI' = XX ).
C                ------------------------------------
 130  CONTINUE
C
      DO 131 I = IPT,K
         IF ( KCHAR(I).EQ.88.AND.KCHAR(I+1).EQ.88)
     C        THEN
                  KDEC(4) = 135
                  IPT=I
                  GO TO 200
              END IF
  131 CONTINUE
C
C*          1.4  CHECK IF TEMP MOBILE ( 'MIMI' = II ).
C                ------------------------------------
 140  CONTINUE
C
      DO 141 I = IPT,K
         IF ( KCHAR(I).EQ.73.AND.KCHAR(I+1).EQ.73) THEN
              KDEC(4) = 137
              IPT=I
              GO TO 200
         END IF
  141 CONTINUE
C
C*          1.5 INVALID 'MIMI'.WRITE REPORT TO ERROR FILE.
C               -------------------------------------------
 150  CONTINUE
C
      KCHAR(IPT) = KCHAR(IPT).OR.128
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
      IF(IEQ .GT. IGS) RETURN
C
C     SEE IF REPORT TOO SHORT
C
      ILN = IEQ - IPT
      IF(ILN .LT. 21) GO TO 700
C
      KDEC(4) = 35
      CALL SAVREP ( IHEAD,IERR )
c
       isaverr = ierr
       numrep(3) = numrep(3) + 1
c
      GO TO 700
C
C     -----------------------------------------------------------------
C*          2. IDENTIFY PART OF REPORT.
C              ------------------------
 200  CONTINUE
C
C
      KDEC(23) = 0
      IF (KCHAR(I+2).EQ.65.OR.KCHAR(I+3).EQ.65) KDEC(23) = 1
      IF (KCHAR(I+2).EQ.66.OR.KCHAR(I+3).EQ.66) KDEC(23) = 2
      IF (KCHAR(I+2).EQ.67.OR.KCHAR(I+3).EQ.67) KDEC(23) = 3
      IF (KCHAR(I+2).EQ.68.OR.KCHAR(I+3).EQ.68) KDEC(23) = 4
C
      K = KDEC(23) + 1
C
C
C*          2.1  LOCATE END OF REPORT AND INCREMENT COUNT.
C                -----------------------------------------
 210  CONTINUE
C
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
      IF(IEQ .GT. IGS) THEN
         print*,'End of report missing'
      END IF
C
C     CHECK IF = - SIGN WAS MISSING BY TRYING TO FIND THE NEXT
C     TTAA, TTBB, TTCC OR TTDD -GROUP.
C
      CALL NEXTMI(IPT,IEQ,IIPT)
      IF(IIPT .LT. IEQ) IEQ = IIPT
C
C
C     SEE IF REPORT TOO SHORT
C
      ILN = IEQ - IPT
      IF(ILN .LT. 21) GO TO 700
C
       NUMREP(K+1) = NUMREP(K+1) + 1
C
C
      GO TO (140,300,400,500,600) K
C
C     ------------------------------------------------------------------
C*          3. DECODE TEMP REPORT PART A.
C              --------------------------
 300  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL USINT(IHEAD,IERR)
c
      isaverr = ierr
      if (Kerr .ne. 0) inil = inil + 1
c
C
      IF(KERR .NE. 0) GO TO 700
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL USDEC(IHEAD,IERR)
      GO TO 700
C
C     ------------------------------------------------------------------
C*          4. DECODE TEMP REPORT PART B.
C              --------------------------
 400  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UKINT ( IHEAD,IERR )
c
      isaverr = ierr
      if (Kerr .ne. 0) inil = inil + 1
      IF ( KERR.NE.0 ) GO TO 700
C
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UKDEC ( IHEAD,IERR )
      GO TO 700
C
C     -----------------------------------------------------------------
C*          5. DECODE TEMP REPORT PART C.
C              --------------------------
 500  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL ULINT ( IHEAD,IERR )
c
      isaverr = ierr
      if (Kerr .ne. 0) inil = inil + 1
      IF ( KERR.NE.0 ) GO TO 700
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL ULDEC ( IHEAD,IERR )
      GO TO 700
C
C     -----------------------------------------------------------------
C*          6. DECODE TEMP REPORT PART D.
C              ---------------------------
 600  CONTINUE
C
C     CONVERT TO INTERMEDIATE FORMAT.
C
      CALL UEINT ( IHEAD,IERR )
c
      isaverr = ierr
      if (Kerr .ne. 0) inil = inil + 1
c
C
      IF ( KERR.NE.0 ) GO TO 700
C
C     CONVERT INTERMEDIATE FORMAT TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      CALL UEDEC ( IHEAD,IERR )
      GO TO 700
C
C
C     ----------------------------------------------------------------
C*          7. LOCATE START OF NEXT REPORT.
C              ----------------------------
 700  CONTINUE
C
c
      if(isaverr.ne.0) numreperr = numreperr + 1
      kerr = 0
      ierr = 0
      isaverr = 0
c
      IPT = IEQ + 1
      CALL NEXTPRT ( IPT,IGS )
C
C
C
C*          7.1 CHECK FOR END OF BULLETIN.
C               ---------------------------
 710  CONTINUE
C
      IF ( IPT.GE.IGS )
     C    THEN
C             END OF BULLETIN , SO IF ANY REPORT HAS BEEN WRITTEN TO
C             ERROR FILE , ADD 'GS' CHARACTER BEFORE RETURNING.
C
              IF ( IHEAD.EQ.0 ) RETURN
              IHEAD = 2
              CALL SAVREP ( IHEAD,IERR )
C
C-----        PRINT TEMP DATA WRITTEN TO ERROR FILE
C-----
c              CALL PRTBULL ( 1,IGS )
C-----
C-----        PRINT TEMP DATA WRITTEN TO ERROR FILE
C
              RETURN
          END IF
C
C
C*          7.2 RESET REPORTS DATA BASE TYPE AND REPORT PART INDICATORS.
C               --------------------------------------------------------
 720  CONTINUE
C
      KDEC(23) = 0
      KDEC(4) = 0
C
C     SEARCH THE BEGINNING OF NEXT REPORT AND CHANGE THE POINTER IMI
C
      NPT = IEQ
      CALL NEXTLET(NPT,IGS)
      IF(NPT .GE. IGS) RETURN
      IMI = NPT
      CALL NEXTEND(NPT,IGS)
      IF(NPT .GE. IGS) RETURN
      JMI = NPT
C
      GO TO 101
C
      END
      
      SUBROUTINE UEDEC ( IHEAD,IERR )
C
C**** *UEDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TEMP REPORT PART D FROM INTERMEDIATE FORMAT
C         TO FULL DECODED FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UEDEC(IHEAD,IERR)*
C
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU /0/
      DATA IPRNUM /0/
C
C
C     ------------------------------------------------------------------
C*          1.   DECODE TO FULLY DECODED FORMAT.
C                -------------------------------
 100  CONTINUE
C
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 101 I=25,700
      KDEC(I)=MINDIC
101   CONTINUE
C     -----------------------------------------------------------------
C*          2.  SECTION 1.
C               ----------
 200  CONTINUE
C
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C*           2.1 DAY AND TIME.
C                -------------
 210  CONTINUE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C*           2.2 CHECK IF SHIP OR DROP TEMP.
C                ---------------------------
 220  CONTINUE
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
C
C        LAT & LONG
C
         CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1   KDEC(5),KDEC(6))
C
         IF(KDEC(5).EQ.MINDIC) RETURN
         IF(KDEC(6).EQ.MINDIC) RETURN   
C
C        ALTIT=0, FOR SEA STATION
C
         IF(KDEC(4) .EQ. 36) KDEC(8)=0
C
      END IF
C
C
C*          2.3 IDENT   STATION/SHIP/AIRCRAFTIDENTIFICATION
C               --------------------------------------------
C
 230  CONTINUE
C
      KDEC(7)=88
C
      IF(KDEC(4).EQ.137) THEN
         IF(KINT(699).NE.MINDIC.AND.KINT(700).NE.MINDIC) THEN
            IF(KINT(700).GE.1.AND.KINT(700).LE.4) KDEC(8)=KINT(699)
            IF(KINT(700).GE.5.AND.KINT(700).LE.8) THEN
               KDEC(8)=NINT(KINT(699)*.3)
            END IF
         END IF
      END IF
C
 233  CONTINUE
C
C
C
C*          2.4 REPORT LENGTH .
C               ---------------
 240  CONTINUE
C
      KDEC(24)=426
C
C
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LT. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 800
C
      IROU = IROU +1
C
C     ----------------------------------------------------------------
C*          3. SECTION 5 (SIGNIFICANT LEVELS WITH RESPECT TO
C              ----------------------------------------------
C              TEMPERATURE AND/OR RELATIVE HUMIDITY).
C              --------------------------------------
 300  CONTINUE
C
      LEVNUM = 0
C
      DO 301 I=1,60
C
C
      IND = 17 + (I-1)*5
      IF(KINT(IND) .EQ. -999999) GO TO 302
      IF(KINT(IND+1) .EQ. MINDIC) GO TO 301
C
      LEVNUM = LEVNUM + 1
      IND2 = 25 + (LEVNUM - 1) * 3
C
C     NINI PIPIPI    PRESSURE AT THE LEVEL
C
      KDEC(IND2) = KINT(IND+1)
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IND2) .GE. KDEC(IND2-3) .AND.
     C               KDEC(IND2-3) .NE. MINDIC)
     C               THEN
                        KDEC(IND2) = MINDIC
                        LEVNUM = LEVNUM - 1
                        GO TO 301
                     END IF
               END IF
C
C     TITI     TEMPERATURE AT THE LEVEL
C
      CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C
C
C     TDTD     DEW-POINT TEMPERATURE AT THE LEVEL
C
      CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))

 301  CONTINUE
C
C
 302  CONTINUE
C
C     ----------------------------------------------------------------
C*          4. SECTION 6 (SIGNIFICANT LEVELS WITH RESPECT TO WIND).
C              ----------------------------------------------------
 400  CONTINUE
C
C     CHECK IF THIS SECTION EXISTS
C
      IF(KINT(317) .EQ. MINDIC) GO TO 402
C
      LEVNUM = 0
C
      DO 401 I=1,60
C
            IND = 318 + (I-1)*4
C
C
C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. -999999) GO TO 402
            IF(KINT(IND+1) .EQ. MINDIC) GO TO 401
C
C     NINI PIPIPI     PRESSURE AT THE LEVEL
C
C
            LEVNUM = LEVNUM + 1
            IND2 = 206 + (LEVNUM - 1) * 3
            KDEC(IND2) = KINT(IND+1)
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IND2) .GE. KDEC(IND2-3) .AND.
     C               KDEC(IND2-3) .NE. MINDIC)
     C               THEN
                        KDEC(IND2) = MINDIC
                        LEVNUM = LEVNUM - 1
                        GO TO 401
                     END IF
               END IF
C
C
C     DTDT FTFTFT   WINDS AT TROPOPAUSE
C
            CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     1                 KDEC(IND2+1),KDEC(IND2+2))
C
 401  CONTINUE
C
C
 402  CONTINUE
C
C     ----------------------------------------------------------------
C*          5. SECTION 9  (REGIONAL DATA).
C              ---------------------------
 500  CONTINUE
C
C     ----------------------------------------------------------------
C*          6. SECTION 10 (NATIONAL DATA) .              *
C              ----------------------------
 600  CONTINUE
C
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 601 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 601
      NIL2 = 0
      GO TO 602
601   CONTINUE
C
602   CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 800
         END IF
C     -----------------------------------------------------------------
C*          7. PRINTING OF ERRORS & REPORTS & KINT & KDEC.
C              -------------------------------------------
 700  CONTINUE
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 701 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
701   CONTINUE
C
      DO 702 I=1,100
      IF(ISTA .EQ. ISTASD(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
702   CONTINUE
C
C
C*          7.1 PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED.
C               --------------------------------------------------------
 710  CONTINUE
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLD .GT. 0) IPRI = 1
C
      IF(KDEC(2) .LT. ITIMES(1) .AND. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
C
      IF(IPRI .GT. 0)
     C   THEN
            DO 711 I=1,IPRLIM
711         CONTINUE
            IPRNUM=IPRNUM+1
            IF(IPRNUM .LE. IPRLIM) IDONED(IPRNUM) = KINT(4)
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(///)
20000 FORMAT(//2X,' PART D  NUMBER =',I5,/)
30000 FORMAT(2X,' PART D  NUMBER =',I4,1X,2(I10,1X),5X,A5,
     C       2(I10,1X),2(A10,1X))

 800  CONTINUE
C
c      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
       CALL TEMPEXP(4,IERR)
       CALL MRGTEM (IERR)
       CALL QCTEMP (KDEC(4),IERR)
       CALL BUFRENC(IERR)
c
 900  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE UEINT ( IHEAD,IERR ) 
C**** *UEINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT TEMP REPORTS PART D FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UEINT(IHEAD,IERR)*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C                     IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE.
C                           = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                     IERR NOT USED ON INPUT.
C
C         OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                     DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C     METHOD.
C     -------
C
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         WILL CONTINUE FROM THAT POINT.
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF TEMP).
C                 FOR THIS PURPOSE TWO VARIABLES ARE USED
C                 NUMERR = NUMBER OF NON-FATAL ERRORS
C                 IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      include 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              --------------------------------------------------------
C              CHARACTER OF REPORT.
C              ---------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR=0
      IREMPOS = 17
C
C
C
C     CHECK FOR 'NIL' REPORT.
C
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.26 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(6,0,IFIRST,NUMERR)
         END IF
C
C      SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C
      DO 102 I=1,700
         KINT(I) = MINDIC
  102 CONTINUE
C
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP/AIRCRAFT IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 103 I=12,14
         KINT(I) = 88
  103 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C     CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C
      DO 104 I=1,3
         KDEC(I) = MINDIC
  104 CONTINUE
C
      DO 105 I=5,9
         KDEC(I) = MINDIC
  105 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = 0
C
      KDEC(17) = MINDIC
      KDEC(22) = MINDIC
C
      KDEC(23)=4
C     -----------------------------------------------------------------
C*          2. SECTION 1  (IDENTIFICATION AND POSITION, THIS IS
C              -------------------------------------------------
C              DIFFERENT FOR LAND STATIONS AND SHIP/AIRCRAFT REPORTS).
C              -------------------------------------------------------
1000  CONTINUE
C
C               YY GG /
C               -- -- -
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*25000)
                CALL NEXPRT2(IPT,IEQ,*25000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1             .AND. (KCHAR(IPT) .LE. 56))
     2              CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
C
                JPT = IPT
C
C
C
C
       
  700 IF ( KDEC(4).EQ.35 )
     C      THEN
C
C               LAND STATION
c
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*25000)
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
                
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .eq. 0)
     C              THEN
                       IF(NIL .EQ. 1)
     C                    THEN
                             KDEC(20)=1                  
                             RETURN
                          END IF
                    END IF
C
                
                IF ( IRET.EQ.1 ) THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(6,0,IFIRST,NUMERR)
C
c                       PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1                FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                        WRITE (55,9901) KINT(4)
                        CLOSE(55)
                        WRITE (*,9901) KINT(4)
 9901                   FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
c                        CALL PRTBULL(1,IGS)
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
C
                        RETURN
                END IF
C
                IF ( IRET.EQ.2 ) THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2
C
C                       RETURN IF REPORT CAN'T CONTAIN IDENT
C
                        IF( (KPT+5) .GE. IEQ) RETURN
C
                        CALL ERRSTA(6,2,IFIRST,NUMERR)
                        RETURN
                 END IF
C
C
                 IF(IRET .EQ. 3) THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
C
                        IF ( IFIRST.EQ.0 )
     C                     THEN
                              NOER(6,KERR) = NOER(6,KERR) + 1
c                              KERBIT = SHIFT(KDEC(20),1-KERR) .AND. 1
c                              IF(KERBIT .EQ. 0)
c     C                              KDEC(20) = KDEC(20) + 2**(KERR-1)
                           END IF
C
                      RETURN
                 END IF
C
                IF ( IRET.EQ.4 ) THEN
C
C                   STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                   ENTRY , FOR THAT OBSERVATION TYPE. 
C
c                   PRINT IIIII WITH NO MASTER FILE ENTRY
                   OPEN(UNIT=55,
     1             FILE='unknown_temp_station.dat',
     2                  ACCESS='APPEND',
     3                  CARRIAGECONTROL='LIST',
     4                  FORM='FORMATTED',
     5                  STATUS='UNKNOWN'        )
C                        
                    WRITE (55,9991) KINT(4)
                    CLOSE(55)
                    WRITE (*,9991) KINT(4)
 9991               FORMAT (1H ,'WRONG TYPE OF STATION  - ',I5)
c                    CALL PRTBULL(1,IGS)
C-----              PRINT IIIII WITH NO MASTER FILE ENTRY
C
                END IF
C
            ELSE
C
C                TEMP SHIP OR TEMP DROP
C
                 IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137)
     1              THEN
C
                        KINT(4)=0

C              RETAIN POINTER TO STATION IDENTIFIER .
C
               KPT=IMI
C
C
C              CHECK THE CALL SIGN
C
               IBUOY = 0
               K = IMI
               J = K + 4
C
               DO 750 I=K,J
                    IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750          CONTINUE
C
C
C              IF A LETTER GROUP IS FOUND CHECK THAT THIS IS NOT
C              MIMIMJMJ GROUP 'UUDD'. IN THIS CASE THE SHIP CALL
C              SIGN GROUP IS PRESUMED MISSING.
C
               IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85) .AND.
     C            (KCHAR(K+2) .EQ. 68) .AND. (KCHAR(K+3) .EQ. 68))
     C                   THEN
                             IBUOY = 2
                        END IF
C
               IF((KCHAR(K) .EQ. 73) .AND. (KCHAR(K+1) .EQ. 73) .AND.
     C            (KCHAR(K+2) .EQ. 68) .AND. (KCHAR(K+3) .EQ. 68))
     C                   THEN
                             IBUOY = 2
                         END IF
C
               IF((KCHAR(K) .EQ. 88) .AND. (KCHAR(K+1) .EQ. 88) .AND.
     C            (KCHAR(K+2) .EQ. 68) .AND. (KCHAR(K+3) .EQ. 68))
     C                   THEN
                             IBUOY = 2
                         END IF
C
C
               IF ( IBUOY.NE.0 )
     C             THEN
C
C                      SHIP,RIG OR PLATFORM. IDENTIFIER NO. SET TO 0
C
                         ID=0
                       KINT(4) = 0
C
                       IF (IBUOY.EQ.1)
     C                    THEN
C
C                             MOVE POINTER PAST CALL SIGN . THE FIRST
C                             CHARACTER OF THE NEXT GROUP IS
C                             LOCATED AS SOME SHIPS USE THE FULL NAME
C                             ( WHICH CAN CONSIST OF 2 WORDS ) INSTEAD
C                             OF CALL SIGN. SO IF THE NEXT GROUP DOESN'T
C                             START WITH 'UU' (WHICH IS THE BEGINNING
C                             OF MIMIMJMJ GOUP) IT MUST BE PART OF THE
C                             SHIP'S NAME USED INSTEAD OF CALL SIGN.
C
                              IIPT=K
                              CALL NEXSEP2(IIPT,IEQ,*25000)
                              ID = IIPT - KPT
                              CALL NEXTLET (IIPT,IEQ)
C
                              IF(KCHAR(IIPT) .NE. 85 .OR. KCHAR(IIPT+1)
     C                           .NE. 85)
     C                                THEN
                                         CALL NEXSEP2(IIPT,IEQ,*25000)
                                         ID = IIPT - K
                                      END IF
C
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*25000)
                             CALL NEXPRT2(IIPT,IEQ,*25000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*25000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*25000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*25000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*25000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR = 4
                              CALL ERRSTA(6,1,IFIRST,NUMERR)
                              GO TO 25000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*25000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
C
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR = 4
                              CALL ERRSTA(6,1,IFIRST,NUMERR)
                              GO TO 25000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*25000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                              kdec(5),kdec(6))
C
                        IF(KDEC(5).EQ.MINDIC) RETURN
                        IF(KDEC(6).EQ.MINDIC) RETURN   
C
                        CALL MARDSEN(kdec(5),kdec(6),KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1            
                                 RETURN
                              END IF
C
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
                               KERR = 4
                               CALL ERRSTA(6,1,IFIRST,NUMERR)
                              GO TO 25000
C
                            END IF
C
C                       hohohohoim ( heigth of mobile platform)
C                       ---------------------------------------
C                         HOHOHOHO - KINT(699)
C                         IM       - KINT(700)
C
                        IF(KDEC(4).EQ.137) THEN
                           CALL NEXTPRT(IPT,IEQ)
                           CALL EXTGRP(IPT,4,1,0,0,0,699,IRET)
                        END IF
C
                    ELSE
C
C                       THIS IS NOT A TEMP REPORT
C
C
C                       CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                        IF(NIL .EQ. 1) THEN
                           KDEC(20)=1 
                           RETURN
                        END IF 
C
                        KERR = 3
                        NOER(6,KERR) = NOER(6,KERR)+1
                              GO TO 25000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
C
C                  IF LETTER ENCOUNTERED FOR LAND STATION CONVERT
C                  IT TO FIGURE (NOT FOR SHIP'S CALL SIGN)
C
                   IF(KDEC(4) .EQ. 35) CALL LETFIG(KCHAR(J))
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4).GE.35 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
C
C                      CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                       IF(NIL .EQ. 1 ) THEN
                          KDEC(20)=1
                          RETURN
                       END IF
C
                       KERR = 3
                       CALL ERRSTA(6,1,IFIRST,NUMERR)
                       GO TO 25000
C
                   END IF
           END IF
C      ----------------------------------------------------------------
C*          3. SECTION 5 (SIGNIFICANT LEVELS WITH RESPECT TO
C              -----------------------------------------------
C              TEMPERATURE AND/OR RELATIVE HUMIDITY).
C              --------------------------------------
 5000 CONTINUE
C
C
C     GET THE POINTER TO THE FIRST LEVEL
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      LPT = IPT
C
C
C
      LEVNUM=0
      LEVPRE=99999
      ITRY = 0
C
5100  CONTINUE
C
C     TRY TO FIND WIND DATA IF ALREADY FIVE ERRORS DETECTED
C
      IF(NUMERR .GE. 5) GO TO 5900
C
C
C     NINI PIPIPI
C     ---- ------
C
      CALL NEXTNI(5,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     1           *6000,*9000,*9000,*10000,*25000,*5900,*5200,*25000)
C
C
5200  CONTINUE
C
      LEVNUM=LEVNUM+1
      IPOS=17+(LEVNUM-1)*5
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
      IF(IRET .NE. 0)
     1   THEN
            KERR = 5
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            CALL NEXSEP2(IPT,IEQ,*25000)
            CALL NEXPRT2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 5100
         END IF
C
C
      IF(KINT(IPOS+1) .EQ. MINDIC)
     1   THEN
            KERR = 5
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            KINT(IPOS) = MINDIC
            CALL NEXPRT2(IPT,IEQ,*25000)
            CALL NEXSEP2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 5100
         END IF
C
C
5600  CONTINUE
C
C
C     TITI TAI DIDI
C     ---- --- ----
C
      CALL NEXPRT2(IPT,IEQ,*5800)
      CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
      IF(IRET .NE. 0)
     1   THEN
            KERR = 6
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            KINT(IPOS) = MINDIC
            KINT(IPOS+1) = MINDIC
            CALL NEXSEP2(IPT,IEQ,*25000)
            GO TO 5100
         END IF
C
C
C     REJECT IF THE TEMPERATURE IS POSITIVE
C
      IF(IRET .EQ. 0)
     C   THEN
            ISIGN = 2*(KINT(IPOS+3)/2)
            IF(ISIGN .EQ. KINT(IPOS+3))
     C         THEN
                  KERR = 6
                  CALL ERRSTA(6,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
                     DO 5700 I = IPOS,IPOS+4
                     KINT(I) = MINDIC
5700                 CONTINUE
                  GO TO 5100
               END IF
         END IF
C
C
      LEVPRE = KINT(IPOS+1)
      KINT(IPOS+5) = -999999
C
C
      GO TO 5100
C
5800  CONTINUE
      KINT(IPOS  ) = MINDIC
      KINT(IPOS+1) = MINDIC
      GO TO 25000
C
C
 5900 CONTINUE
C
C     SEARCH FOR THE NEXT SECTION
C     ====== === === ==== =======
C
C     DON'T CONTINUE IF ALREADY SIX ERRORS DETECTED
C
      IF(NUMERR .GT. 6) GO TO 25000
      CALL NEXPRT2(IPT,IEQ,*25000)
      CALL EXTVAL(IPT,5,IVAL)
C
      IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C   (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C   (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C   (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C   (IVAL .EQ. 59595)) GO TO 9000
C
      IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C   (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C   (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C   (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C   (IVAL .EQ. 69696)) GO TO 10000
C
      CALL NEXSEP2(IPT,IEQ,*25000)
      GO TO 5900
C
C      ----------------------------------------------------------------
C*          4. SECTION 6 (SIGNIFICANT LEVELS WITH RESPECT TO WIND).
C              ----------------------------------------------------
 6000 CONTINUE
C
C     21212
C     -----
C     CHECK IF VALUE 21212 HAS ALREADY BEEN INSERTED ( MAY
C     HAPPEN IN CASE OF CORRUPTED '21212'-GROUP).
C
      IF(KINT(317) .EQ. 21212)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*25000)
            CALL NEXPRT2(IPT,IEQ,*25000)
            GO TO 6050
         END IF
C
      CALL EXTGRP(IPT,5,0,0,0,0,317,IRET)
C
      IF(IRET .NE. 0)
     C   THEN
            KERR = 10
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = 317
            CALL NEXSEP2(IPT,IEQ,*25000)
         END IF
C
 6050 CONTINUE
C
      LEVPRE=99999
      LEVNUM=0
      ITRY = 0
C
 6100 CONTINUE
C
C     DON'T CONTINUE IF ALREADY SIX ERRORS DETECTED
C
      IF(NUMERR .GT. 6) GO TO 25000
C
C     NINI PIPIPI
C     ---- ------
      CALL NEXTNI(4,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     1           *6000,*9000,*9000,*10000,*25000,*5900,*6150,*25000)
C
 6150 CONTINUE
C
      LEVNUM=LEVNUM+1
      IPOS = 318 + (LEVNUM-1) * 4
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
      IF(IRET .NE. 0)
     1   THEN
            KERR = 5
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            CALL NEXSEP2(IPT,IEQ,*25000)
            CALL NEXPRT2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 6100
         END IF
C
      IF(KINT(IPOS+1) .EQ. MINDIC)
     1   THEN
            KERR = 5
            CALL ERRSTA(6,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            KINT(IPOS) = MINDIC
            CALL NEXPRT2(IPT,IEQ,*25000)
            CALL NEXSEP2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 6100
         END IF
C
 6400 CONTINUE
C
C     DIDI FIFIFI
C     ---- ------
      CALL NEXPRT2(IPT,IEQ,*6200)
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C         THEN
                  KERR = 7
                  CALL ERRSTA(6,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  DO 6500 I = IPOS,IPOS+3
                  KINT(I) = MINDIC
 6500             CONTINUE
                  CALL NEXSEP2(IPT,IEQ,*25000)
               END IF
C
      LEVPRE = KINT(IPOS+1)
      KINT(IPOS+4) = -999999
C
      GO TO 6100
C
 6200 CONTINUE
      KINT(IPOS  ) = MINDIC
      KINT(IPOS+1) = MINDIC
      GO TO 25000
C     ---------------------------------------------------------------
C*          5. SECTION 9 (REGIONAL GROUPS).
C              ----------------------------
 9000 CONTINUE
C
C     NO REGIONAL DATA FOR PART D
C     ---------------------------------------------------------------
C*          6. SECTION 10 (NATIONAL GROUPS).
C              -----------------------------
10000 CONTINUE
C
C
C     NO NATIONAL DATA FOR PART D
C
C
25000 CONTINUE

C     ERROR CHECKING AND HANDLING
C
C     RETURN IF NO ERRORS IN REPORT
C
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
                             IPT=KEEP
                             CALL FIXUS
                             IFIRST=1
                             NUMRERR(6) = NUMRERR(6) + 1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                             DO 25500 I=KEEP,IGS
                             KCHAR(I) = KCHAR(I) .AND. 127
25500                        CONTINUE
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 26000 I = IREMPOS,700
                                   KINT(I) = MINDIC
26000                              CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR=0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                              end if
c
                             RETURN
                          END IF
C
C
      END
      
      SUBROUTINE UKDEC ( IHEAD,IERR )
C
C**** *UKDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TEMP REPORT PART B FROM INTERMEDIATE FORMAT
C         TO FULL DECODED FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UKDEC(IHEAD,IERR)*
C
C         INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C         OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU /0/
      DATA IPRNUM /0/
C     ------------------------------------------------------------------
C*          1.   SET FLAGS AND INDICATORS.
C                -------------------------
 100  CONTINUE
C
C      CALL PRTKINT(KINT,1,700,MINDIC)
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
      IREGPRI = 0
C
C     CLEAR ERROR INDICATOR
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
C
      DO 101 I=25,700
      KDEC(I)=MINDIC
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2. SECTION 1.
C              ----------
 200  CONTINUE
C
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C*          2.1  DAY AND TIME.
C                -------------
 210  CONTINUE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C
C*          2.2  CHECK IF SHIP OR DROP TEMP.
C                ---------------------------
 220  CONTINUE
C
      IF(KDEC(4) .EQ. 36 .OR. KDEC(4) .EQ. 135.OR.KDEC(4).EQ.137)
     1           THEN
C
C                   LAT & LONG
C
                    CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1                          KDEC(5),KDEC(6))
C
                    IF(KDEC(5).EQ.MINDIC) RETURN
                    IF(KDEC(6).EQ.MINDIC) RETURN   
C
C                   ALTIT=0, FOR SEA STATION
C
                    IF(KDEC(4) .EQ. 36) KDEC(8)=0
C
                 END IF
C
C
C*          2.3 IDENT   STATION/SHIP/AIRCRAFTIDENTIFICATION .
C               ---------------------------------------------
 230  CONTINUE
C
      KDEC(7)=88
C
      IF(KDEC(4).EQ.137) THEN
         IF(KINT(699).NE.MINDIC.AND.KINT(700).NE.MINDIC) THEN
            IF(KINT(700).GE.1.AND.KINT(700).LE.4) KDEC(8)=KINT(699)
            IF(KINT(700).GE.5.AND.KINT(700).LE.8) THEN
                KDEC(8)=NINT(KINT(699)*.3)
            END IF
         END IF
      END IF
C
 233  CONTINUE
C
C
C*          2.4 REPORT LENGTH  .
C               ----------------
 240  CONTINUE
C
      KDEC(24)=426
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LT. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
      IROU = IROU + 1
C     ---------------------------------------------------------------
C*          3. SECTION 5 (SIGNIFICANT LEVELS WITH RESPECT TO
C              ----------------------------------------------
C              TEMPERATURE AND/OR RELATIVE HUMIDITY).
C              --------------------------------------
 300  CONTINUE
C
C
      LEVNUM=0
C
      DO 301 I=1,60
C
      IND = 17 + (I-1)*5
      IF(KINT(IND) .EQ. -999999) GO TO 302
      IF(KINT(IND+1) .EQ. MINDIC) GO TO 301
C
      LEVNUM=LEVNUM+1
      
      IND2 = 25 + (LEVNUM-1)*3
     
C
C
C     NINI PIPIPI    PRESSURE AT THE LEVEL
C
      KDEC(IND2) = KINT(IND+1)*10
C
C     CHECK IF THOUSAND DIGIT OMITTED
C
            IF(KDEC(IND2) .LE. 2000)
     C         THEN
                  IF(LEVNUM .EQ. 1) KDEC(IND2) = KDEC(IND2) + 10000
C
                  IF(LEVNUM .GT. 1 .AND. LEVNUM .LE. 4)
     C               THEN
C
C                   CHECK IF THE PREVIOUS LEVEL IS > 1000MB,
C                   AND IF IT WAS LOWER THAN THIS.
C
                    IF(KDEC(IND2-3) .GT. 10000)
     C                 THEN
C
C                         CHECK IF PREVIOUS LEVEL IS HIGHER THAN THIS
C
                          IF( (KDEC(IND2-3) - 10000) .GT. KDEC(IND2))
     C                         KDEC(IND2) = KDEC(IND2) + 10000
                       END IF
                     END IF
               END IF
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IND2) .GE. KDEC(IND2-3) .AND.
     C               KDEC(IND2-3) .NE. MINDIC)
     C         THEN
                  KDEC(IND2) = MINDIC
                  LEVNUM = LEVNUM - 1
                  GO TO 301
               END IF
         END IF
C
C     TITI     TEMPERATURE AT THE LEVEL
C
      
      CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C     TDTD     DEW-POINT TEMPERATURE AT THE LEVEL
C
      CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))
C
 301  CONTINUE
C
 302  CONTINUE
C     ---------------------------------------------------------------
C*          4. SECTION 6 (SIGNIFICANT LEVELS WITH RESPECT TO WIND).
c              ----------------------------------------------------
 400  CONTINUE
C
C     CHECK IF THIS SECTION EXISTS
C
      IF(KINT(317) .EQ. MINDIC) GO TO 402
C
C
      LEVNUM=0
C
      DO 401 I=1,60
C
            IND = 318 + (I-1)*4

C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. -999999) GO TO 402
            IF(KINT(IND+1) .EQ. MINDIC) GO TO 401
C
            LEVNUM=LEVNUM+1
            IND2 = 206 + (LEVNUM-1)*3
C
C           NINI PIPIPI     PRESSURE AT THE LEVEL
C
            KDEC(IND2) = KINT(IND+1) * 10
C
C           CHECK IF THOUSAND DIGIT OMITTED
C
            IF(KDEC(IND2) .LE. 2000)
     C         THEN
                  IF(LEVNUM .EQ. 1) KDEC(IND2) = KDEC(IND2) + 10000
C
                  IF(LEVNUM .GT. 1 .AND. LEVNUM .LE. 4)
     C               THEN
C
C                   CHECK IF THE PREVIOUS LEVEL IS > 1000MB,
C                   AND IF IT WAS LOWER THAN THIS.
C
                    IF(KDEC(IND2-3) .GT. 10000)
     C                 THEN
C
C                         CHECK IF PREVIOUS LEVEL IS HIGHER THAN THIS
C
                          IF( (KDEC(IND2-3) - 10000) .GT. KDEC(IND2))
     C                         KDEC(IND2) = KDEC(IND2) + 10000
                       END IF
                     END IF
               END IF
C
C
C           REJECT IF LEVEL LOWER THAN PREVIOUS
C
            IF(LEVNUM .GT. 1)
     C         THEN
                  IF(KDEC(IND2) .GE. KDEC(IND2-3) .AND.
     C               KDEC(IND2-3) .NE. MINDIC)
     C               THEN
                        KDEC(IND2) = MINDIC
                        LEVNUM = LEVNUM - 1
                        GO TO 401
                     END IF
               END IF
C
C
C           DTDT FTFTFT   WINDS AT TROPOPAUSE
C
            CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     1                 KDEC(IND2+1),KDEC(IND2+2))
C
 401        CONTINUE
C
C
 402  CONTINUE
C
C
C     ---------------------------------------------------------------
C           5. DATA ON SEA SURFACE AND SOUNDING SYSTEM.
C              -----------------------------------------
 500  CONTINUE
C
      KDEC(422)=MINDIC
      KDEC(423)=MINDIC

      IF(KINT(600).NE.MINDIC) THEN
C
C        Sr   OLD CODE
C
         IF(KINT(605).NE.MINDIC) KDEC(422)=KINT(605)
C
C        RaRa
C
         IF(KINT(604).NE.MINDIC) KDEC(423)=KINT(604)

      ELSE
C
C        Sr     NEW CODE (AFTER 1.11.1991)
C
         KDEC(422)=MINDIC
         IF(KINT(611).NE.MINDIC) KDEC(422)=KINT(611)
C
C        RaRa
C
         KDEC(423)=MINDIC
         IF(KINT(612).NE.MINDIC) KDEC(423)=KINT(612)
      END IF
C
C     ---------------------------------------------------------------
C*          5.1  SECTION 8 (CLOUD DATA).
C                -----------------------
 510  CONTINUE
C
      IF(KINT(558) .NE. MINDIC)
     C   THEN
C
C           NH      TOTAL LOW CLOUDS
C
            IF(KINT(559) .NE. MINDIC) KDEC(386)=KINT(559)
C
C           CL CM CH  TYPE OF MEDIUM AND HIGH CLOUDS
C
            IF(KINT(560) .NE. MINDIC) KDEC(387)=KINT(560)
            IF(KINT(562) .NE. MINDIC) KDEC(389)=KINT(562)
            IF(KINT(563) .NE. MINDIC) KDEC(390)=KINT(563)
C
C           H       HEIGHT OF THE BASE OF THE LOWEST CLOUD
C
            LOWEST = MINDIC
C
c           fix 18.3.94
c
            if(kint(563).ne.mindic) lowest=2
            if(kint(562).ne.mindic) lowest=1
            if(kint(560).ne.mindic) lowest=0
c
c            DO 511 I=563,560,-1
c            IF(I .EQ. 561) GO TO 511
c            IF(KINT(I) .NE. MINDIC) LOWEST = I-560
c511         CONTINUE
C
            CALL IC1600(KINT(561),LOWEST,MINDIC,KDEC(388))
C
         END IF
C
C*          6. SECTION 9 (REGIONAL DATA).
C              --------------------------
 600  CONTINUE
C
C     REGION I
C     ------ -
C
      IF(KDEC(17) .EQ. 1)
     C   THEN
            IF(KINT(564) .EQ. MINDIC) GO TO 700
C
C           LOOP OVER THREE POSSIBLE SPECIAL LEVELS
C           (925HPA, 775HPA AND 600HPA)
C
               LEVNUM = 0
C
               DO 601 I=1,3
               IND = 565 + (I-1)*7
C
               IF(KINT(IND) .EQ. MINDIC) GO TO 601
C
               LEVNUM = LEVNUM + 1
               IND2 = 392 + (LEVNUM-1)*6
C
C              PPP     PRESSURE AT THE LEVEL
C
               IF(I .EQ. 1) KDEC(IND2)=9250
               IF(I .EQ. 2) KDEC(IND2)=7750
               IF(I .EQ. 3) KDEC(IND2)=6000
C
C              HIHIHI    GEOPOTENTIAL AT THE LEVEL
C
C
               LEVIN = KDEC(IND2) / 10
               CALL GEOPOTE(LEVIN,KINT(IND+1),MINDIC,KDEC(IND2+1))
C
C
C              TITI      TEMPERATURE AT THE LEVEL
C
C
               CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+2))
C
C
C              TDITDI    DEW POINT TEMPERATURE AT THE LEVEL
C
               CALL IC0777(KINT(IND+4),KDEC(IND2+2),MINDIC,KDEC(IND2+3))
C
C
C              DIDI FIFIFI  WIND AT THE LEVEL
C
               CALL DDFFF(KINT(IND+5),KINT(IND+6),IWW,K,MINDIC,
     C                     KDEC(IND2+4),KDEC(IND2+5))
C
C
 601           CONTINUE
               GO TO 700
         END IF
C
C     REGION II
C     ------ --
C
C     IN REGION II THERE MAY BE REGIONAL DATA IN FORMS
C
C        92H9H9H9  T9T9TA9D9D9  D9D9F9F9F9
C                   OR
C        11PPP DDFFF  22800 DDFFF  33600 DDFFF
C
C
      IF(KDEC(17) .EQ. 2)
     C   THEN
C
C           92H9H9H9  T9T9TA9D9D9  D9D9F9F9F9
C
            IF(KINT(564) .EQ. MINDIC) GO TO 602
            IF(KINT(565) .NE. 92) GO TO 602
            IREGPRI = 1
C
C           PPP       PRESSURE AT 925HPA
C
            KDEC(392) = 9250
C
C           HHH       GEOPOTENTIAL AT 925HPA
C
            LEVIN = KDEC(392) / 10
            CALL GEOPOTE(LEVIN,KINT(566),MINDIC,KDEC(393))
C
C           TTT       TEMPERATURE AT 925HPA
C
            if(kint(567).eq.mindic) then
               inttemp=mindic
               idetemp=mindic
            else
               INTTEMP = KINT(567)/10
               IDETEMP = KINT(567) - 10*INTTEMP
            end if 
C
            CALL IC3931(IDETEMP,INTTEMP,MINDIC,KDEC(394))
C
C           TDTDTD    DEW POINT TEMPERATURE AT 925HPA
C
            CALL IC0777(KINT(568),KDEC(394),MINDIC,KDEC(395))
C
C           DD FFF    WINDS AT 925HPA
C
            CALL DDFFF(KINT(569),KINT(570),IWW,K,MINDIC,KDEC(396),
     C                  KDEC(397))
C
C
 602        CONTINUE
C
C           11PPP DDFFF  22800 DDFFF  33600 DDFFF
C
C
      LEVNUM = 0
C
            DO 603 I=1,3
            IND = 573 + (I-1)*4
C
            IF(KINT(IND) .EQ. MINDIC) GO TO 603
C
            IREGPRI = 1
            LEVNUM = LEVNUM + 1
            IND2 = 392 + (LEVNUM-1)*6
C
C           PPP     PRESSURE AT THE LEVEL
C
            KDEC(IND2) = KINT(IND+1) * 10

C
C
C           DIDI FIFIFI  WIND AT THE LEVEL
C
            CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     C                 KDEC(IND2+4),KDEC(IND2+5))
C
C
 603        CONTINUE
C
            GO TO 700
C
         END IF
C
 604  CONTINUE
C
C     REGION VI
C     ------ --
C
      IF(KDEC(17) .EQ. 2 .OR. KDEC(17) .EQ. 6)
     C   THEN
            IND2 = 392
            IF(KINT(564) .EQ. MINDIC) GO TO 605
            IF(KINT(566) .EQ. MINDIC) GO TO 605
C
C           PRESSURE AND WINDS AT 900 OR 1000 METRES
C
            IF(KINT(565) .EQ. 11)
     C         THEN
C
                  KDEC(IND2) = KINT(566)*10
c
                  CALL DDFFF(KINT(567),KINT(568),IWW,K,MINDIC,
     C                       KDEC(IND2+4),KDEC(IND2+5))
                  IND2 = IND2+6
C
                END IF
C
C           WINDS AT 800 HPA
C
            IF(KINT(569) .EQ. 22800)
     C         THEN
C
                  KDEC(IND2) = 8000
C
                  CALL DDFFF(KINT(570),KINT(571),IWW,K,MINDIC,
     C                       KDEC(IND2+4),KDEC(IND2+5))
                  IND2 = IND2+6
C
                END IF
C
C
C
C           WINDS AT 600 HPA
C
            IF(KINT(572) .EQ. 33600)
     C         THEN
C
                  KDEC(IND2) = 6000
C
                  CALL DDFFF(KINT(573),KINT(574),IWW,K,MINDIC,
     C                       KDEC(IND2+4),KDEC(IND2+5))
                  IND2 = IND2+6
C
                END IF
C
C
 605        CONTINUE
C
C           CHECK IF THERE ARE DATA FOR 925HPA
C
            IF(KINT(575) .EQ. MINDIC) GO TO 700
C
            IF(KINT(576) .EQ. 92)
     C         THEN
C
C
C                 HHH    GEOPOTENTIAL AT 925HPA
C
                  KDEC(IND2) = 9250
                  KDEC(IND2+1) = KINT(577)
C
C                 TTT    TEMPERATURE AT 925HPA
C
                  CALL IC3931(KINT(579),KINT(578),MINDIC,KDEC(IND2+2))
C
C                 TDTDTD    DEW POINT TEMPERATURE AT 925HPA
C
                  CALL IC0777(KINT(580),KDEC(IND2+2),MINDIC,
     C                        KDEC(IND2+3))
C
C                 DIDI FIFIFI     WIND AT 925HPA
C
                  CALL DDFFF(KINT(581),KINT(582),IWW,K,MINDIC,
     C                       KDEC(IND2+4),KDEC(IND2+5))
     
C
               END IF
C
         END IF
C     ----------------------------------------------------------------
C*          7. SECTION 10   (NATIONAL DATA).
C              -----------------------------
 700  CONTINUE
C
C ===== NOT PROSESSED FOR TIME BEING =====
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 701 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 701
      NIL2 = 0
      GO TO 702
701   CONTINUE
C
702   CONTINUE
C
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF
C
C     ---------------------------------------------------------------
C*          8.  PRINTING OF ERRORS & REPORTS & KINT & KDEC.
C               -------------------------------------------
 800  CONTINUE
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 801 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
801   CONTINUE
C
      DO 802 I=1,100
      IF(ISTA .EQ. ISTASB(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
 802  CONTINUE
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
C
      IF(IERALLB .GT. 0) IPRI = 1
C
C
      IF(KDEC(2) .LT. ITIMES(1) .AND. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
C
      IF(IPRI .GT. 0)
     C   THEN
            DO 803 I=1,IPRLIM
C===        IF(KINT(4) .EQ. IDONEB(I)) GO TO 99800
803         CONTINUE
            IPRNUM=IPRNUM+1
            IF(IPRNUM .LE. IPRLIM) IDONEB(IPRNUM) = KINT(4)
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
10000 FORMAT(//)
20000 FORMAT(//2X,' PART B  NUMBER =',I5,/)
30000 FORMAT(2X,' PART B  NUMBER =',I4,1X,2(I10,1X),5X,A5,
     C       2(I10,1X),2(A10,1X))
C
C
99800 CONTINUE
C
C     CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL TEMPEXP(2,IERR)
      CALL MRGTEM(IERR)
      CALL QCTEMP(KDEC(4),IERR)
      CALL BUFRENC(IERR)
C
99900 CONTINUE
      RETURN
      END
      
      SUBROUTINE UKINT ( IHEAD,IERR )
C
C**** *UKINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT TEMP REPORTS PART B FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UKINT(IHEAD,IERR)*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                      IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                                WRITTEN TO ERROR FILE.
C                       = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                 IERR NOT USED ON INPUT.
C
C          OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                      DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF TEMP).
C                 FOR THIS PURPOSE TWO VARIABLES ARE USED
C                 NUMERR = NUMBER OF NON-FATAL ERRORS
C                 IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              --------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      IREMPOS = 17
C
C     CHECK FOR 'NIL' REPORT.
C
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.26 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(4,0,IFIRST,NUMERR)
         END IF
C
C      SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C
      DO 102 I=1,700
         KINT(I) = MINDIC
  102 CONTINUE
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP/AIRCRAFT IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 103 I=12,14
         KINT(I) = 88
  103 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C
C     CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C
      DO 104 I=1,3
         KDEC(I) = MINDIC
  104 CONTINUE
C
      DO 105 I=5,9
         KDEC(I) = MINDIC
  105 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = 0
C
      KDEC(17) = MINDIC
      KDEC(22) = MINDIC
C     ---------------------------------------------------------------
C*          2. SECTION  (IDENTIFICATION AND POSITION,
C              THIS IS DIFFERENT FOR LAND STATIONS AND
C              SHIP/AIRCRAFT REPORTS)
1000  CONTINUE
C
C               YY GG /
C               -- -- -
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*25000)
                CALL NEXPRT2(IPT,IEQ,*25000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1                .AND. (KCHAR(IPT) .LE. 56))
     2                 CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
C
                JPT = IPT
C
C
C
C
  700 IF ( KDEC(4).EQ.35 )
     C      THEN
C
C               LAND STATION
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
C
                CALL NEXPRT2( IPT,IEQ,*25000)
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
c                print*,kint(4)
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .EQ. 0) THEN
                       IF(NIL .EQ. 1) THEN
                          KDEC(20)=1 
                          RETURN
                       END IF
                END IF
C
                IF ( IRET.EQ.1 ) THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(4,1,IFIRST,NUMERR)
C
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
                        WRITE (*,9901) KINT(4)
                        OPEN(UNIT=55,
     1                 FILE='unknown_temp_station.dat',
     2                  ACCESS='APPEND',
     3                  CARRIAGECONTROL='LIST',
     4                  FORM='FORMATTED',
     5                  STATUS='UNKNOWN'        )
C                        
                        WRITE (55,9901) KINT(4)
                        CLOSE(55)
 9901                   FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
c                        CALL PRTBULL(1,IGS)
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
C
                        RETURN
                    END IF
C
                IF ( IRET.EQ.2 ) THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2
C
C                       RETURN IF REPORT CAN'T CONTAIN IDENT
C
                        IF( (KPT+5) .GE. IEQ) RETURN
C

                        CALL ERRSTA(4,2,IFIRST,NUMERR)
C
                        RETURN
                    END IF
C
                 IF(IRET .EQ. 3) THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
                      CALL ERRSTA(4,2,IFIRST,NUMERR)
C
                      RETURN
                 END IF
C 
                 IF ( IRET.EQ.4 ) THEN
C
C                   STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                   ENTRY , FOR THAT OBSERVATION TYPE. 
C
c                   PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1                FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                    WRITE (55,9991) KINT(4)
                    CLOSE(55)
                    WRITE (*,9991) KINT(4)
 9991               FORMAT (1H ,'WRONG TYPE OF STATION  - ',I5)
c                    CALL PRTBULL(1,IGS)
C-----              PRINT IIIII WITH NO MASTER FILE ENTRY
                 END IF 
C
            ELSE
C
C                TEMP SHIP OR TEMP DROP
C
                 IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137)
     1              THEN
C
                        KINT(4)=0
C
C              RETAIN POINTER TO STATION IDENTIFIER .
C
               KPT=IMI
C
C
C              CHECK THE CALL SIGN
C
               IBUOY = 0
               K = IMI
               J = K + 4
C
               DO 750 I=K,J
                    IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750          CONTINUE
C
C              IF A LETTER GROUP IS FOUND CHECK THAT THIS IS NOT
C              MIMIMJMJ GROUP 'UUBB'. IN THIS CASE THE SHIP CALL
C              SIGN GROUP IS PRESUMED MISSING.
C
               IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85) .AND.
     C            (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                   THEN
                             IBUOY = 2
                        END IF
C
               IF((KCHAR(K) .EQ. 73) .AND. (KCHAR(K+1) .EQ. 73) .AND.
     C            (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                   THEN
                             IBUOY = 2
                         END IF
C
               IF((KCHAR(K) .EQ. 88) .AND. (KCHAR(K+1) .EQ. 88) .AND.
     C            (KCHAR(K+2) .EQ. 66) .AND. (KCHAR(K+3) .EQ. 66))
     C                   THEN
                             IBUOY = 2
                         END IF
C
C
               IF ( IBUOY.NE.0 )
     C             THEN
C
C                      SHIP,RIG OR PLATFORM. IDENTIFIER NO. SET TO 0
C
                         ID=0
                       KINT(4) = 0
C
                       IF (IBUOY.EQ.1)
     C                    THEN
C
C                             MOVE POINTER PAST CALL SIGN . THE FIRST
C                             CHARACTER OF THE NEXT GROUP IS
C                             LOCATED AS SOME SHIPS USE THE FULL NAME
C                             ( WHICH CAN CONSIST OF 2 WORDS ) INSTEAD
C                             OF CALL SIGN. SO IF THE NEXT GROUP DOESN'T
C                             START WITH 'UU' (WHICH IS THE BEGINNING
C                             OF MIMIMJMJ GOUP) IT MUST BE PART OF THE
C                             SHIP'S NAME USED INSTEAD OF CALL SIGN.
C
                              IIPT=K
                              CALL NEXSEP2(IIPT,IEQ,*25000)
                              ID = IIPT - KPT
                              CALL NEXTLET (IIPT,IEQ)
C
                              IF(KCHAR(IIPT) .NE. 85 .OR. KCHAR(IIPT+1)
     C                           .NE. 85)
     C                                THEN
                                         CALL NEXSEP2(IIPT,IEQ,*25000)
                                         ID = IIPT - K
                                      END IF
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*25000)
                             CALL NEXPRT2(IIPT,IEQ,*25000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*25000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*25000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*25000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C                       99 LALALA
C                       -- ------
                        CALL NEXPRT2( IPT,IEQ,*25000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1  
                                 RETURN
                              END IF
C
                              KERR = 4
                              CALL ERRSTA(4,1,IFIRST,NUMERR)
                              GO TO 25000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*25000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR=4
                              IF (IFIRST.EQ.0)
     C                           THEN
                                    CALL ERRSTA(4,2,IFIRST,NUMERR)
                                 END IF
                              GO TO 25000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*25000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                              kdec(5),kdec(6))
                        IF(KDEC(5).EQ.MINDIC) RETURN
                        IF(KDEC(6).EQ.MINDIC) RETURN   
                        CALL MARDSEN(kdec(5),kdec(6),KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
                               KERR = 4
                               CALL ERRSTA(4,1,IFIRST,NUMERR)
C
                              GO TO 25000
C
                            END IF
C
C                      hohohohoim ( height of mobile platform)
C                      ---------------------------------------
C                        HOHOHOHO - KINT(699)
C                        IM       - KINT(700)
C
                       IF(KDEC(4).EQ.137) THEN
                          CALL NEXTPRT(IPT,IEQ)
                          CALL EXTGRP(IPT,4,1,0,0,0,699,IRET)
                       END IF
C
                    ELSE
C
C                       THIS IS NOT A TEMP REPORT
C
                            KERR = 3
                            NOER(4,KERR) = NOER(4,KERR)+1
C
                              GO TO 25000
                END IF
             END IF
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
C
C                  IF LETTER ENCOUNTERED FOR LAND STATION CONVERT
C                  IT TO FIGURE (NOT FOR SHIP'S CALL SIGN)
C
                   IF(KDEC(4) .EQ. 35) CALL LETFIG(KCHAR(J))
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4).GE.35 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                       JPT=IABS(JPT)
                       KCHAR(JPT)=KCHAR(JPT).OR.128
                       KERR = 3
                       CALL ERRSTA(4,1,IFIRST,NUMERR)
                       GO TO 25000
C
                   END IF
           END IF
C
C      -------------------------------------------------------------
C*          3. SECTION 5 (SIGNIFICANT LEVELS WITH RESPECT TO
C              ---------------------------------------------
C              TEMPERATURE AND/OR RELATIVE HUMIDITY).
C              --------------------------------------
C
5000  CONTINUE
C
C     'NIL' REPORTS ARE NOT PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
C
C     GET THE POINTER TO THE FIRST LEVEL
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      LPT = IPT
C
      LEVNUM=0
      LEVPRE=99999
      ITRY = 0
C
5100  CONTINUE
C
C     TRY TO FIND WIND DATA IF ALREADY FIVE ERRORS DETECTED
C
      IF(NUMERR .GE. 5) GO TO 5900
C
C     NINI PIPIPI
C     ---- ------
      CALL NEXTNI(5,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     C           *6000,*8000,*9000,*10000,*25000,*5900,*5200,*7000)
C
5200  CONTINUE
C
      LEVNUM = LEVNUM+1
      IPOS=17+(LEVNUM-1)*5
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
      IF(IRET .NE. 0)
     1   THEN
            KERR = 5
            CALL ERRSTA(4,2,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
            CALL NEXSEP2(IPT,IEQ,*25000)
            CALL NEXPRT2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 5100
         END IF
C
      IF(KINT(IPOS+1) .EQ. MINDIC)
     1   THEN
            KERR = 5
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            KINT(IPOS) = MINDIC
            CALL NEXPRT2(IPT,IEQ,*25000)
            CALL NEXSEP2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 5100
         END IF
C
5400  CONTINUE
C
C     TITI TAI DIDI
C     ---- --- ----
C
      CALL NEXPRT2(IPT,IEQ,*5800)
      LPT = IPT
      CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
                   IF(IRET .NE. 0 .OR. KINT(IPOS+2) .EQ. MINDIC)
     1                THEN
C
C                         SEE IF THE TEMPERATURE IS = /////
C
                          DO 5405 I=LPT,LPT+4
                          IF(KCHAR(I) .EQ. 47) GO TO 5405
                          GO TO 5406
5405                      CONTINUE
C
                          GO TO 5100
5406                      CONTINUE
                          KERR = 6
                          CALL ERRSTA(4,1,IFIRST,NUMERR)
                          IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                          DO 5410 I = IPOS,IPOS+4
                          KINT(I) = MINDIC
5410                      CONTINUE
                          CALL NEXSEP2(IPT,IEQ,*25000)
                          GO TO 5100
                      END IF
C
C
C     REJECT IF THE TEMPERATURE IS POSITIVE ABOVE 400 MB
C
            IF(KINT(IPOS+1) .LE. 400 .AND. LEVNUM .GT. 3)
     C         THEN
                  ISIGN = 2*(KINT(IPOS+3)/2)
                  IF(ISIGN .EQ. KINT(IPOS+3))
     C               THEN
                        KERR = 6
                        CALL ERRSTA(4,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS
                           DO 5500 I = IPOS,IPOS+4
                           KINT(I) = MINDIC
5500                       CONTINUE
                           CALL NEXPRT2(IPT,IEQ,*25000)
                           GO TO 5100
                      END IF
               END IF
C
      LEVPRE = KINT(IPOS+1)
      KINT(IPOS+5) = -999999
C
      GO TO 5100
C
5800  CONTINUE
      KINT(IPOS  ) = MINDIC
      KINT(IPOS+1) = MINDIC
      GO TO 25000
C
C
C
5900  CONTINUE
C
C
C     SEARCH FOR THE NEXT SECTION
C     ====== === === ==== =======
C
C
C     DON'T CONTINUE IF ALREADY SIX ERRORS DETECTED
C
      IF(NUMERR .GT. 6) GO TO 25000
C
C
      CALL NEXPRT2(IPT,IEQ,*25000)
C
      CALL EXTVAL(IPT,5,IVAL)
C
      IF(IVAL .EQ. 21212) GO TO 6000
C
      IF(IVAL.EQ.31313) GO TO 7000
C
      IF(IVAL .EQ. 41414) GO TO 8000
C
      IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C   (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C   (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C   (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C   (IVAL .EQ. 59595) .OR. (IVAL .EQ. 51525)) GO TO 9000
C
      IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C   (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C   (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C   (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C   (IVAL .EQ. 69696)) GO TO 10000
C
      CALL NEXSEP2(IPT,IEQ,*25000)
      GO TO 5900
C
C
C      -------------------------------------------------------------
C*          6. SECTION 6 (SIGNIFICAT LEVELS WITH RESPECT TO WIND).
C              ---------------------------------------------------
6000  CONTINUE
C
C
C     21212
C     -----
C     CHECK IF VALUE 21212 GAS ALREADY BEEN INSERTED ( MAY
C     HAPPEN IN CASE OF CORRUPTED '21212'-GROUP).
C
      IF(KINT(317) .EQ. 21212)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*25000)
            CALL NEXPRT2(IPT,IEQ,*25000)
            GO TO 6050
         END IF
C
C
      CALL EXTGRP(IPT,5,0,0,0,0,317,IRET)
C
      IF(IRET .NE. 0)
     C   THEN
            KERR = 10
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = 317
            CALL NEXSEP2(IPT,IEQ,*25000)
         END IF
C
C
6050  CONTINUE
C
      LEVPRE=99999
      LEVNUM=0
      ITRY = 0
C
6100  CONTINUE
C
C     DON'T CONTINUE IF ALREADY SIX ERRORS DETECTED
C
      IF(NUMERR .GT. 6) GO TO 25000
C
      CALL NEXTNI(4,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     C            *6000,*8000,*9000,*10000,*25000,*5900,*6200,*7000)
C
6200  CONTINUE
C
      LEVNUM=LEVNUM+1
      IPOS=318+(LEVNUM-1)*4
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
      IF(IRET .NE. 0) THEN
                          KERR = 5
                          CALL ERRSTA(4,2,IFIRST,NUMERR)
                          IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                          CALL NEXSEP2(IPT,IEQ,*25000)
                          CALL NEXPRT2(IPT,IEQ,*25000)
                          LEVNUM = LEVNUM - 1
                          GO TO 6100
                      END IF
C
      IF(KINT(IPOS+1) .EQ. MINDIC)
     1   THEN
            KERR = 5
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS
            KINT(IPOS) = MINDIC
            CALL NEXPRT2(IPT,IEQ,*25000)
            CALL NEXSEP2(IPT,IEQ,*25000)
            LEVNUM = LEVNUM - 1
            GO TO 6100
         END IF
C
6400  CONTINUE
C
C     DIDI FIFIFI
C     ---- ------
      CALL NEXPRT2(IPT,IEQ,*6800)
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
      IF ( (IRET .NE. 0)  .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C      KINT(IPOS+2) .NE. MINDIC) )
     C         THEN
                  KERR = 7
C
                  CALL ERRSTA(4,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  DO 6500 I = IPOS,IPOS+3
                  KINT(I) = MINDIC
6500              CONTINUE
                  CALL NEXSEP2(IPT,IEQ,*25000)
C
                  GO TO 6100
               END IF
C
      LEVPRE = KINT(IPOS+1)
      KINT(IPOS+4) = -999999
C
      GO TO 6100
C
C
6800  CONTINUE
      KINT(IPOS  ) = MINDIC
      KINT(IPOS+1) = MINDIC
      GO TO 25000
C
C     ---------------------------------------------------------------
C*          7. SECTION 7.
C              ----------
 7000 CONTINUE
C
C     CODE UP TO 1.11.1991. 
C
      IIPT=IPT 
      DO 7001 II=1,3
      CALL NEXPRT2(IIPT,IEQ,*25000)
      CALL NEXSEP2(IIPT,IEQ,*25000)
 7001 CONTINUE
C
      CALL NEXPRT2(IIPT,IEQ,*25000)

C---------------------------------------------------------------------- 
 7010 CONTINUE
C
C     WMO CODE AFTER 1.11.1991.
C 
      CALL EXTGRP(IPT,5,0,0,0,0,610,IRET)
C
C     SrRaRaSaSa GROUP
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      CALL EXTGRP(IPT,1,2,2,0,0,611,IRET)
      IF(IRET.NE.0)
     1   THEN
            KERR=7
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR.EQ.1) IREMPOS=611
            CALL NEXSEP2(IPT,IEQ,*25000)
         END IF
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL.EQ.41414) GO TO 5900
C
C     8GGgg GROUP
C
      CALL EXTGRP(IPT,1,2,2,0,0,614,IRET)
      IF(IRET.NE.0)
     1   THEN
            KERR=7
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR.EQ.1) IREMPOS=614
            CALL NEXSEP2(IPT,IEQ,*25000)
            GO TO 25000
         END IF
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL.EQ.41414) GO TO 5900
C
C     9SnTwTwTw GROUP
C
      CALL EXTGRP(IPT,1,1,3,0,0,617,IRET)
      IF(IRET.NE.0)
     1   THEN
            KERR=7
            CALL ERRSTA(4,1,IFIRST,NUMERR)
            IF(NUMERR.EQ.1) IREMPOS=604
            CALL NEXSEP2(IPT,IEQ,*25000)
            GO TO 25000
         END IF
C
      GO TO 5900
C
C     -----------------------------------------------------------------
C*          8. SECTION 8    (CLOUD DATA).
C              --------------------------
8000  CONTINUE
C
C
C     41414
C     -----
C
      CALL EXTGRP(IPT,5,0,0,0,0,558,IRET)
      IF(IRET .NE. 0)
     C    THEN
C
C            NOT CORRECT SECTION 8 TRY
C            TO LOCATE NEXT SECTION
C
             KERR = 9
             CALL ERRSTA(4,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = 558
             CALL NEXSEP2(IPT,IEQ,*25000)
             GO TO 5900
          END IF
C
C
C     NH CL H CM CH
C     -- -- - -- --
C
      CALL NEXPRT2(IPT,IEQ,*25000)
      CALL EXTGRP(IPT,1,1,1,1,1,559,IRET)
      IF(IRET .NE. 0)
     C    THEN
             KERR = 8
             CALL ERRSTA(4,1,IFIRST,NUMERR)
             IF(NUMERR .EQ. 1) IREMPOS = 558
             CALL NEXSEP2(IPT,IEQ,*25000)
          END IF
C
C     -----------------------------------------------------------------
C*          9. SECTION 9  (REGIONAL GROUPS).
C              -----------------------------
9000  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*25000)
C
C     THERE ARE REGIONAL DIFFERENCIES FOR REGIONS I,II,IV AND VI
C
      IF(KDEC(17) .EQ. 1) GO TO 9100
      IF(KDEC(17) .EQ. 2) GO TO 9200
      IF(KDEC(17) .EQ. 4) GO TO 9400
      IF(KDEC(17) .EQ. 6) GO TO 9600
C
      GO TO 10000
C
C
9100  CONTINUE
C
C     REGION I
C     ------ -
C     51515
C     -----
C
C     THERE MAY BE UP TO THREE SPECIAL LEVELS IN REGION I
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .NE. 51515)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*25000)
            GO TO 5900
         END IF
C
      CALL EXTGRP(IPT,5,0,0,0,0,564,IRET)
      IF(IRET .NE. 0)
     C      THEN
                KERR = 21
                CALL ERRSTA(4,1,IFIRST,NUMERR)
                IF(NUMERR .EQ. 1) IREMPOS = 564
                CALL NEXSEP2(IPT,IEQ,*25000)
                GO TO 5900
             END IF
C
9150  CONTINUE
C
      CALL NEXPRT2(IPT,IEQ,*25000)
C
C     CHECK THE LEVEL
C
      CALL EXTVAL(IPT,2,IVAL)
C
      IF(IVAL .EQ. 92)
     C   THEN
            IND=565
         ELSE
            IF(IVAL .EQ. 77)
     C         THEN
                  IND=572
               ELSE
                  IF(IVAL .EQ. 60)
     C               THEN
                        IND=579
                     ELSE
                        GO TO 5900
                     END IF
               END IF
         END IF
C
C     92 H9H9H9 , 77 H7H7H7 OR 60 H6H6H6  GEOPOTENTIAL AT THE LEVEL
C     -- ------   -- ------    -- ------
C
      CALL EXTGRP(IPT,2,3,0,0,0,IND,IRET)
      IF(IRET .NE. 0) THEN
                         KERR = 25
                         CALL ERRSTA(4,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IND
                         CALL NEXSEP2(IPT,IEQ,*25000)
                         GO TO 9170
                       END IF
C
C     TITI TAI DIDI    TEMPERATURE AND DEW-POINT TEMPERATURE
C     ---- --- ----
C
      CALL NEXPRT2(IPT,IEQ,*25000)
C
C     CHECK IF THIS ACTULLY IS THE BEGINNING OF NEXT LEVEL
C
      CALL EXTVAL(IPT,2,IVAL2)
      IF(IVAL .EQ. 92 .AND. IVAL2 .EQ. 77) GO TO 9150
      IF(IVAL .EQ. 77 .AND. IVAL2 .EQ. 60) GO TO 9150
C
      CALL EXTGRP(IPT,2,1,2,0,0,IND+2,IRET)
      IF(IRET .NE. 0) THEN
                         KERR = 26
                         CALL ERRSTA(4,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IND + 2
                         CALL NEXSEP2(IPT,IEQ,*25000)
                         GO TO 9170
                      END IF
C
C     DIDI FIFIFI      WINDS AT THE LEVEL
C     ---- ------
      CALL NEXPRT2(IPT,IEQ,*25000)
C
C     CHECK IF THIS ACTULLY IS THE BEGINNING OF NEXT LEVEL
C
      CALL EXTVAL(IPT,2,IVAL)
      IF(IVAL .EQ. 77 .OR. IVAL .EQ. 60) GO TO 9150
C
      CALL EXTGRP(IPT,2,3,0,0,0,IND+5,IRET)
      IF( IRET .NE. 0  .OR.  ( KINT(IND+5) .GT. 36 .AND.
     C                         KINT(IND+5) .NE. MINDIC) )
     C               THEN
                         KERR = 27
                         CALL ERRSTA(4,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IND + 5
                         CALL NEXSEP2(IPT,IEQ,*25000)
                      END IF
      GO TO 9150
C
C
9170  CONTINUE
C
      DO 9180 I=IND,IND+6
      KINT(IND) = MINDIC
9180  CONTINUE
      GO TO 5900
C
9200  CONTINUE
C
C     REGION II
C     ------ --
C
C          51525  52525
C          -----  -----
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 51525 .OR. IVAL .EQ. 52525)
     C   THEN
C
           IND = 564
C
           CALL EXTGRP(IPT,5,0,0,0,0,IND,IRET)
           IF(IRET .NE. 0)
     C        THEN
                 KERR = 21
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = IND
                 CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 9250
              END IF
C
C          92 H9H9H9
C          -- ------
C
           CALL NEXPRT2(IPT,IEQ,*25000)
C
C          TEST IF THE FIRST GROUP IS 92---
C
           CALL EXTVAL(IPT,2,IVAL)
           IF(IVAL .NE. 92) GO TO 5900
C
           CALL EXTGRP(IPT,2,3,0,0,0,IND+1,IRET)
           IF(IRET .NE. 0)
     C        THEN
                 KERR = 25
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = IND
                 CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 9250
              END IF
C
C          T9T9 TA9 D9D9
C          ---- --- ----
C
           CALL NEXPRT2(IPT,IEQ,*25000)
           CALL EXTGRP(IPT,3,2,0,0,0,IND+3,IRET)
           IF(IRET .NE. 0)
     C        THEN
                 KERR = 26
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = IND + 1
                 CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 9250
              END IF
C
C          D9D9 F9F9F9
C          ---- ------
C
           CALL NEXPRT2(IPT,IEQ,*25000)
           CALL EXTGRP(IPT,2,3,0,0,0,IND+5,IRET)
           IF(IRET .NE. 0 .OR. (KINT(IND+5) .GT. 36 .AND.
     C        KINT(IND+5) .NE. MINDIC))
     C        THEN
                 KERR = 27
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = IND + 5
                 CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 9250
              END IF
C
           GO TO 5900
C
        ELSE
           IF(IVAL .EQ. 51515)
     C        THEN
C
                 IND = 572
                 CALL EXTGRP(IPT,5,0,0,0,0,IND,IRET)
                 IF(IRET .NE. 0)
     C              THEN
                       KERR = 21
                       CALL ERRSTA(4,2,IFIRST,NUMERR)
                       IF(NUMERR .EQ. 1) IREMPOS = IND
                       CALL NEXSEP2(IPT,IEQ,*25000)
                       GO TO 5900
                    END IF
C
9210          CONTINUE
C
              CALL NEXPRT2(IPT,IEQ,*25000)
C
C             DETERMINE THE LEVEL
C
              CALL EXTVAL(IPT,2,IVAL)
C
              IF(IVAL .EQ. 11)
     C           THEN
                     IND = 573
                 ELSE
                    IF(IVAL .EQ. 22)
     C                 THEN
                           IND = 577
                       ELSE
                          IF(IVAL .EQ. 33)
     C                       THEN
                                 IND = 581
                             ELSE
                                GO TO 5900
                             END IF
                       END IF
                 END IF
C
C
C             11 PPP , 22 800 OR 33 600  SPECIAL WIND LEVEL
C             -- ---   -- ---    -- ---
C
              CALL EXTGRP(IPT,2,3,0,0,0,IND,IRET)
              IF(IRET .NE. 0)
     C           THEN
                    KERR = 25
                    CALL ERRSTA(4,2,IFIRST,NUMERR)
                    IF(NUMERR .EQ. 1) IREMPOS = IND + 1
                    CALL NEXSEP2(IPT,IEQ, *25000)
                    GO TO 5900
                 END IF
C
C                DD FFF  WIND AT THE LEVEL
C                -- ---
C
                 CALL NEXPRT2(IPT,IEQ,*25000)
                 CALL EXTGRP(IPT,2,3,0,0,0,IND+2,IRET)
                 IF(IRET .NE. 0 .OR. (KINT(IND+2) .GT. 36 .AND.
     C              KINT(IND+2) .NE. MINDIC))
     C                 THEN
                         KERR = 27
                         CALL ERRSTA(4,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IND + 5
                         CALL NEXSEP2(IPT,IEQ, *25000)
                         GO TO 5900
                     END IF
C
C                CHECK IF THERE IS SUPPOSED TO BE MORE LEVELS
C
                 IF(IVAL .EQ. 33) GO TO 5900
                 GO TO 9210
              END IF
           END IF
C
C
C
9250  CONTINUE
C
      DO 9260 I=564,569
      KINT(I) = MINDIC
9260  CONTINUE
      CALL NEXSEP2(IPT,IEQ,*25000)
      GO TO 5900

9400  CONTINUE
C
C     REGION IV
C     ------ --
C
C
C          51515, 52525, ...
C          -----  -----
C
           CALL EXTGRP(IPT,5,0,0,0,0,564,IRET)
           IF(IRET .NE. 0)
     C        THEN
                 KERR = 21
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = 564
                 CALL NEXSEP2(IPT,IEQ, *25000)
                 GO TO 5900
              END IF
C
           NUMADF=0
C
9450       CONTINUE
C
C          101 ADF ADF
C          --- --- ---
C
           CALL NEXPRT2(IPT,IEQ,*25000)
C
C          CHECK IF THIS GROUP STARTS WITH 101, OTHERWISE
C
           CALL EXTVAL(IPT,3,IVAL)
           IF(IVAL .NE. 101) GO TO 5900
C
           NUMADF = NUMADF+1
           IPOS = 565 + (NUMADF-1)*2
C
           CALL EXTGRP(IPT,3,2,0,0,0,IPOS,IRET)
           IF(IRET .NE. 0)
     C        THEN
                 KERR = 28
                 CALL ERRSTA(4,1,IFIRST,NUMERR)
                 IF(NUMERR .EQ. 1) IREMPOS = IPOS
                 CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 5900
              END IF
C
           GO TO 9450

9600  CONTINUE
C
C     REGION VI
C     ------ --
C
C          CHECK IF THIS IS THE SUBSECTION 51515 OR 52525
C
           CALL EXTVAL(IPT,5,IVAL)
           IF(IVAL .EQ. 51515)
     C        THEN
C
C             51515
C             -----
C
              CALL EXTGRP(IPT,5,0,0,0,0,564,IRET)
              IF(IRET .NE. 0)
     C           THEN
                    KERR = 21
                    CALL ERRSTA(4,1,IFIRST,NUMERR)
                    IF(NUMERR .EQ. 1) IREMPOS = 564
                    CALL NEXSEP2(IPT,IEQ,*25000)
                 GO TO 9700
              END IF
C
C             11 P1P1P1
C             -- ------
C
              CALL NEXPRT2(IPT,IEQ,*25000)
C
C             CHECK THE FIRST GROUP IS 11---
C
              CALL EXTVAL(IPT,2,IVAL)
              IF(IVAL .EQ. 11)
     C            THEN
                      CALL EXTGRP(IPT,2,3,0,0,0,565,IRET)
                      IF (IRET .NE. 0)
     C                   THEN
                            KERR = 25
                            CALL ERRSTA(4,1,IFIRST,NUMERR)
                            IF(NUMERR .EQ. 1) IREMPOS = 565
                            CALL NEXSEP2(IPT,IEQ,*25000)
                            GO TO 9700
                          END IF
                  ELSE
                      GO TO 9700
                  END IF
C
C             D1D1 F1F1F1
C             ---- ------
C
              CALL NEXPRT2(IPT,IEQ,*25000)
              CALL EXTGRP(IPT,2,3,0,0,0,567,IRET)
              IF(IRET .NE. 0 .OR. (KINT(567) .GT. 36 .AND.
     C                             KINT(567) .NE. MINDIC))
     C           THEN
                    KERR = 27
                    CALL ERRSTA(4,1,IFIRST,NUMERR)
                    IF(NUMERR .EQ. 1) IREMPOS = 567
                    CALL NEXSEP2(IPT,IEQ,*25000)
                    GO TO 9700
                 END IF
C
C
C
9700          CONTINUE
C
              CALL NEXPRT2(IPT,IEQ,*25000)
C
C
C             TRY TO FIND GROUP 22800 OR 33600 OR NEXT SECTION
C
              CALL EXTVAL(IPT,5,IVAL)
              IF(IVAL .EQ. 52525) GO TO 9750
              IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C           (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C           (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C           (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C           (IVAL .EQ. 69696)) GO TO 10000
C
C
              IF((IVAL .NE. 22800) .AND. (IVAL .NE. 33600))
     C            THEN
                     CALL NEXSEP2(IPT,IEQ,*25000)
                     CALL NEXPRT2(IPT,IEQ,*25000)
                     GO TO 9700
                  END IF
C
              IF(IVAL .EQ. 22800)
     C           THEN
C
C                    22800
C                    -----
C
                     CALL EXTGRP(IPT,5,0,0,0,0,569,IRET)
                     IF(IRET .NE. 0)
     C                  THEN
                           KERR = 21
                           CALL ERRSTA(4,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = 569
                           CALL NEXSEP2(IPT,IEQ,*25000)
                           GO TO 9700
                         END IF
C
C                    DD FFF
C                    -- ---
C
                     CALL NEXPRT2(IPT,IEQ,*25000)
                     CALL EXTGRP(IPT,2,3,0,0,0,570,IRET)
                     IF(IRET .NE. 0 .OR. (KINT(570) .GT. 36 .AND.
     C                  KINT(570) .NE. MINDIC))
     C                  THEN
                           KERR = 27
                           CALL ERRSTA(4,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = 569
                           KINT(569) = MINDIC
                           CALL NEXSEP2(IPT,IEQ,*25000)
                        END IF
C
C
                     CALL NEXPRT2(IPT,IEQ,*25000)
                     GO TO 9700
C
                 END IF
C
C
             IF(IVAL .EQ. 33600)
     C            THEN
C
C                    33600
C                    -----
C
                     CALL EXTGRP(IPT,5,0,0,0,0,572,IRET)
                     IF(IRET .NE. 0)
     C                  THEN
                           KERR = 21
                           CALL ERRSTA(4,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = 572
                           CALL NEXSEP2(IPT,IEQ,*25000)
                           GO TO 9700
                       END IF
C
C                    DD FFF
C                    -- ---
C
                     CALL NEXPRT2(IPT,IEQ,*25000)
                     CALL EXTGRP(IPT,2,3,0,0,0,573,IRET)
                     IF(IRET .NE. 0 .OR. (KINT(573) .GT. 36 .AND.
     C                  KINT(573) .NE. MINDIC))
     C                  THEN
                           KERR = 27
                           CALL ERRSTA(4,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = 572
                           CALL NEXSEP2(IPT,IEQ,*25000)
                           GO TO 9700
                        END IF
C
                  END IF
                  CALL EXTVAL(IPT,5,IVAL)
             END IF
C
C        END OF SUBSECTION 51515
C
9750  CONTINUE
C
C
           IF(IVAL .EQ. 52525)
     C        THEN
     
C             52525
C             -----
C
              CALL EXTGRP(IPT,5,0,0,0,0,575,IRET)
              IF(IRET .NE. 0)
     C             THEN
                      KERR = 21
                      CALL ERRSTA(4,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 574
                      CALL NEXSEP2(IPT,IEQ,*25000)
                      GO TO 9800
                   END IF
C
C             92 H9H9H9
C             -- ------
C
              CALL NEXPRT2(IPT,IEQ,*25000)
C
C             CHECK IF THE FIRST GROUP IS 92---
C
              CALL EXTVAL(IPT,2,IVAL)
              IF(IVAL .NE. 92) GO TO 5900
C
              CALL EXTGRP(IPT,2,3,0,0,0,576,IRET)
              IF(IRET .NE. 0)
     C             THEN
                      KERR = 25
                      CALL ERRSTA(4,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 576
                      CALL NEXSEP2(IPT,IEQ,*25000)
                      GO TO 9800
                   END IF
C
C
C             T9T9 TA9 D9D9
C             ---- --- ----
C
              CALL NEXPRT2(IPT,IEQ,*25000)
              CALL EXTGRP(IPT,2,1,2,0,0,578,IRET)
              IF(IRET .NE. 0)
     C             THEN
                      KERR = 26
                      CALL ERRSTA(4,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 578
                      CALL NEXSEP2(IPT,IEQ,*25000)
                      GO TO 9800
                   END IF
C
C             D9D9 F9F9F9
C             ---- ------
C
              CALL NEXPRT2(IPT,IEQ,*25000)
              CALL EXTGRP(IPT,2,3,0,0,0,581,IRET)
              IF(IRET .NE. 0 .OR. (KINT(581) .GT. 36 .AND.
     C           KINT(581) .NE. MINDIC))
     C             THEN
                      KERR = 27
                      CALL ERRSTA(4,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 581
                      CALL NEXSEP2(IPT,IEQ,*25000)
                      GO TO 9800
                   END IF
C
          END IF
C
      CALL NEXSEP2(IPT,IEQ,*25000)
      GO TO 5900
C
9800  CONTINUE
C
      DO 9810 I=575,582
      KINT(I) = MINDIC
9810  CONTINUE
      CALL NEXSEP2(IPT,IEQ,*25000)
      GO TO 5900
C
C     ----------------------------------------------------------------
C*          10. SECTION 10 (NATIONAL GROUPS).
C               -----------------------------
10000 CONTINUE
C
C     NO NATIONAL DATA DECODED AT THE MOMENT
C
25000 CONTINUE
C
C     ERROR CHECKING AND HANDLING
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR .EQ. 0) RETURN
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
C
C
                             IPT=KEEP
                             CALL FIXUS
                             IFIRST=1
                             NUMRERR(4) = NUMRERR(4) + 1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                             DO 25500 I=KEEP,IGS
                             KCHAR(I) = KCHAR(I) .AND. 127
25500                        CONTINUE
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 6 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 6)
     C                          THEN
                                   DO 26000 I = IREMPOS,700
                                   KINT(I) = MINDIC
26000                              CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR = 0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                              end if
c
                          END IF
C
C
C
C
      RETURN
      END
      
      SUBROUTINE ULDEC ( IHEAD,IERR )
C**** *ULDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TEMP REPORT PART C FROM INTERMEDIATE FORMAT
C         TO FULL DECODED FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ULDEC(IHEAD,IERR)*
C
C          INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C          OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU/0/
      DATA IPRNUM /0/
C
C     ------------------------------------------------------------------
C*          1.  SET FLAGS AND INDICATOES.
C                ------------------------
 100  CONTINUE
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C     CLEAR ERROR INDICATOR.
C
      KERR = 0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 101 I=25,421
      KDEC(I)=MINDIC
 101  CONTINUE
C       --------------------------------------------------------------
C*          2.  SECTION 1.
C               ----------
 200  CONTINUE
C
C
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C*          2.1  DAY AND TIME.
C                -------------
 210  CONTINUE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C
C*          2.2  CHECK IF SHIP OR DROP TEMP.
C                ---------------------------
 220  CONTINUE
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
C
C        LAT & LONG
C
         CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1               KDEC(5),KDEC(6))
         IF(KDEC(5).EQ.MINDIC) RETURN
         IF(KDEC(6).EQ.MINDIC) RETURN   
C
C        ALTIT=0, FOR SEA STATION
C
         IF(KDEC(4) .EQ. 36) KDEC(8)=0
C
      END IF
C
C
C
C*          2.3 IDENT   STATION/SHIP/AIRCRAFT IDENTIFICATION
C               --------------------------------------------
230   CONTINUE
c
      KDEC(7)=88
C
      IF(KDEC(4).EQ.137) THEN
         IF(KINT(699).NE.MINDIC.AND.KINT(700).NE.MINDIC) THEN
            IF(KINT(700).GE.1.AND.KINT(700).LE.4) KDEC(8)=KINT(699)
            IF(KINT(700).GE.5.AND.KINT(700).LE.8) THEN
               KDEC(8)=NINT(KINT(699)*.3)
            END IF
         END IF
      END IF
C
 233  CONTINUE
C
C
C
C*          2.4  REPORT LENGTH .
C                ---------------
 240  CONTINUE
C
      KDEC(24) = 426
C
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LT. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) GO TO 99800
C
      IROU = IROU + 1
C
C     ----------------------------------------------------------------
C*          3.  SECTION 2   PRESSURE LEVELS.
C               ----------------------------
 300  CONTINUE
C
      DO 301 I=1,14
C
      IND=(I-1)*7+17
      IND2=(I-1)*5+30
      IF(KINT(IND) .EQ. MINDIC) GO TO 301
C
C
C     PIPI HIHIHI    HEIGHT AT LEVEL I
C
      CALL GEOPOTE(KINT(IND),KINT(IND+1),MINDIC,KDEC(IND2))
C
C
C
C     TITI     TEMPERATURE AT LEVEL I
C
      CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C
C
C     TDTD     DEW-POINT TEMPERATURE AT LEVEL I
C
      CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))
C
C
C
C     DIDI FIFIFI    WIND DIRECTION & SPEED AT LEVEL I
C
      CALL DDFFF(KINT(IND+5),KINT(IND+6),IWW,K,MINDIC,KDEC(IND2+3),
     1            KDEC(IND2+4))
C
C
 301  CONTINUE
C
C     ---------------------------------------------------------------
C*          4. SECTION 3   TROPOPAUSE(S) .
C              ----------------------------
 400  CONTINUE
C
      DO 401 I=1,3
C
            IND =115 + (I-1)*7
            IND2=100 + (I-1)*5
C
C     88PTPTPT   PRESSURE AT TROPOPAUSE LEVEL
C
C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. MINDIC) GO TO 402
            IF(KINT(IND+1) .EQ. MINDIC .OR. KINT(IND+1) .EQ. 999)
     1          GO TO 401
            IF(KINT(IND+1) .EQ. 0 ) GO TO 401
C
            KDEC(IND2) = KINT(IND+1)
C
C     TTTT   TEMPERATURE AT TROPOPAUSE LEVEL
C
            CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C      TDTD   DEW-POINT TEMPERATURE AT TROPOPAUSE LEVEL
C
            CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))
C
C
C     DTDT FTFTFT   WINDS AT TROPOPAUSE
C
            CALL DDFFF(KINT(IND+5),KINT(IND+6),IWW,K,MINDIC,
     1                 KDEC(IND2+3),KDEC(IND2+4))
C
 401        CONTINUE
C
C
 402  CONTINUE
C
C
C     ----------------------------------------------------------------
C*          5. SECTION 4  MAX WIND LEVEL(S).
C              -----------------------------
 500  CONTINUE
C
      DO 501 I=1,3
C
            IND = 136 + (I-1)*7
            IND2= 115 + (I-1)*5
C
C     77PMPMPM OR 66PMPMPM   PRESSURE AT MAX. WIND LEVEL
C
C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. MINDIC) GO TO 502
            IF(KINT(IND+1) .EQ. MINDIC .OR. KINT(IND+1) .EQ. 999)
     1         GO TO 502
            IF(KINT(IND+1) .EQ. 0 ) GO TO 502
C
            KDEC(IND2) = KINT(IND+1)
C
C     DMDM FMFMFM   WIND AT MAX. WIND LEVEL
C
            CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     1                 KDEC(IND2+1),KDEC(IND2+2))
C
C     4VBVBVAVA   VERTICAL WIND SHEAR ASSOSIATED TO THIS MAX WIND LEVEL
C
            IF(KINT(IND+4) .EQ. MINDIC) GO TO 501
C
            IF(KINT(IND+5) .NE. MINDIC) KDEC(IND2+3) = KINT(IND+5)
            IF(KINT(IND+6) .NE. MINDIC) KDEC(IND2+4) = KINT(IND+6)
C
C           IF WIND SPEED IN KNOTS TRANSFER TO M/S
C
            IF(IWW .EQ. 1) THEN
                              IF(KDEC(IND2+3) .NE. MINDIC)
     C                           CALL KTOMPSI(KDEC(IND2+3))
                              IF(KDEC(IND2+4) .NE. MINDIC)
     C                           CALL KTOMPSI(KDEC(IND2+4))
                           END IF
C
 501        CONTINUE
C
C
 502  CONTINUE

C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT
C     (I.E. IF THERE ARE NO DATA AND NO CODING ERRORS)
C
         NIL2 = 1
         DO 503 I=25,KDEC(24)
         IF(KDEC(I) .EQ. MINDIC) GO TO 503
         NIL2 = 0
         GO TO 504
503      CONTINUE
C
504      CONTINUE
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF
C
C
C     ----------------------------------------------------------------
C*          6. PRINTING OF ERRORS & REPORTS & KINT & KDEC .
C              --------------------------------------------
 600  CONTINUE
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 601 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
601   CONTINUE
C
      DO 602 I=1,100
      IF(ISTA .EQ. ISTASC(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
 602  CONTINUE
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
      IF(IERALLC .GT. 0) IPRI = 1
C
C
C
      IF(KDEC(2) .LT. ITIMES(1) .AND. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
      IF(IPRI .GT. 0)
     C   THEN
            DO 603 I=1,IPRLIM
C===        IF(KINT(4) .EQ. IDONEC(I)) GO TO 99800
 603        CONTINUE
            IPRNUM=IPRNUM+1
            IF(IPRNUM .LE. IPRLIM) IDONEC(IPRNUM) = KINT(4)
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
C
10000 FORMAT(///)
20000 FORMAT(//2X,' PART C  NUMBER =',I5,/)
30000 FORMAT(2X,' PART C  NUMBER =',I4,1X,2(I10,1X),5X,A5,
     C       2(I10,1X),2(A10,1X))

99800 CONTINUE
C
C     CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL TEMPEXP(3,IERR)
      CALL MRGTEM(IERR)
      CALL QCTEMP(KDEC(4),IERR)
      CALL BUFRENC(IERR)
C
99900 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ULINT ( IHEAD,IERR )
C**** *ULINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT TEMP REPORTS PART C FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ULINT(IHEAD,IERR)*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                      IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                           WRITTEN TO ERROR FILE.
C                            = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                      IERR NOT USED ON INPUT.
C
C          OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                      DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         WILL CONTINUE FROM THAT POINT.
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF TEMP).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *ERRSTA()*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION IPLEV(14)
C
      DATA IPLEV/
     1   70,50,30,20,10,9,8,7,6,5,4,3,2,1/
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              -------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      IREMPOS = 17
C
C
C     CHECK FOR 'NIL' REPORT.
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.26 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(5,0,IFIRST,NUMERR)
         END IF
C
C      SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C
      DO 102 I=1,200
         KINT(I) = MINDIC
  102 CONTINUE
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP/AIRCRAFT IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 103 I=12,14
         KINT(I) = 88
  103 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C     CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C
      DO 104 I=1,3
         KDEC(I) = MINDIC
  104 CONTINUE
C
      DO 105 I=5,9
         KDEC(I) = MINDIC
  105 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = 0
C
      KDEC(17) = MINDIC
C
      KDEC(22) = MINDIC
C
C     -----------------------------------------------------------------
C*          2. SECTION 1 (IDENTIFICATION AND POSITION,
C              THIS IS DIFFERENT FOR LAND STATIONS AND
C              SHIP/AIRCRAFT REPORTS)
C
1000  CONTINUE
C
C               YY GG ID
C               -- -- --
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*5000)
                CALL NEXPRT2(IPT,IEQ,*5000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1             .AND. (KCHAR(IPT) .LE. 56))
     2             CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
C
                JPT = IPT
C
  700 IF ( KDEC(4).EQ.35 )
     C      THEN
C
C               LAND STATION
C
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
                CALL NEXPRT2( IPT,IEQ,*5000)
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .EQ. 0) THEN
                       IF(NIL .EQ. 1) THEN
                          KDEC(20)=1
                          RETURN
                       END IF
                END IF
C
                IF ( IRET.EQ.1 ) THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        CALL ERRSTA(5,0,IFIRST,NUMERR)
C
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1                FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                        WRITE (55,9901) KINT(4)
                        CLOSE(55)
                        WRITE (*,9901) KINT(4)
 9901                   FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
c                        CALL PRTBULL(1,IGS)
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
C
                        RETURN
                    END IF
C
                IF ( IRET.EQ.2 ) THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2
C
C                       RETURN IF REPORT CAN'T CONTAIN IDENT
C
                        IF( (KPT+5) .GE. IEQ) RETURN
C
                        CALL ERRSTA(5,2,IFIRST,NUMERR)
                        RETURN
                    END IF
C
C
                 IF(IRET .EQ. 3) THEN
C
C                     INVALID OBSERVATION TYPE
C
                      KERR = 3
C
                      CALL ERRSTA(5,0,IFIRST,NUMERR)
C
                      RETURN
                 END IF
C
                 IF ( IRET.EQ.4 ) THEN
C
C                   STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                   ENTRY , FOR THAT OBSERVATION TYPE. 
C
c                   PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1             FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                        WRITE (55,9991) KINT(4)
                        CLOSE(55)
                    WRITE (*,9991) KINT(4)
 9991               FORMAT (1H ,'WRONG TYPE OF STATION  - ',I5)
c                    CALL PRTBULL(1,IGS)
C-----              PRINT IIIII WITH NO MASTER FILE ENTRY
                 END IF
C
            ELSE
C
C                TEMP SHIP OR TEMP DROP
C
                 IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137)
     1              THEN
C
                        KINT(4)=0
C
C              RETAIN POINTER TO STATION IDENTIFIER .
C
               KPT=IMI
C
C              CHECK THE CALL SIGN
C
               IBUOY = 0
               K = IMI
               J = K + 4
C
               DO 750 I=K,J
                    IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750          CONTINUE
C
C              IF A LETTER GROUP IS FOUND CHECK THAT THIS IS NOT
C              MIMIMJMJ GROUP 'UUCC'. IN THIS CASE THE SHIP CALL
C              SIGN GROUP IS PRESUMED MISSING.
C
               IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85) .AND.
     C            (KCHAR(K+2) .EQ. 67) .AND. (KCHAR(K+3) .EQ. 67))
     C                   THEN
                             IBUOY = 2
                        END IF
C
               IF((KCHAR(K) .EQ. 73) .AND. (KCHAR(K+1) .EQ. 73) .AND.
     C            (KCHAR(K+2) .EQ. 67) .AND. (KCHAR(K+3) .EQ. 67))
     C                   THEN
                             IBUOY = 2
                         END IF
C
               IF((KCHAR(K) .EQ. 88) .AND. (KCHAR(K+1) .EQ. 88) .AND.
     C            (KCHAR(K+2) .EQ. 67) .AND. (KCHAR(K+3) .EQ. 67))
     C                   THEN
                             IBUOY = 2
                         END IF
C
C
               IF ( IBUOY.NE.0 )
     C             THEN
C
C                      SHIP,RIG OR PLATFORM. IDENTIFIER NO. SET TO 0
C
                         ID=0
                       KINT(4) = 0
C
                       IF (IBUOY.EQ.1)
     C                    THEN
C
C                             MOVE POINTER PAST CALL SIGN . THE FIRST
C                             CHARACTER OF THE NEXT GROUP IS
C                             LOCATED AS SOME SHIPS USE THE FULL NAME
C                             ( WHICH CAN CONSIST OF 2 WORDS ) INSTEAD
C                             OF CALL SIGN. SO IF THE NEXT GROUP DOESN'T
C                             START WITH 'UU' (WHICH IS THE BEGINNING
C                             OF MIMIMJMJ GOUP) IT MUST BE PART OF THE
C                             SHIP'S NAME USED INSTEAD OF CALL SIGN.
C
                              IIPT=K
                              CALL NEXSEP2(IIPT,IEQ,*5000)
                              ID = IIPT - KPT
                              CALL NEXTLET (IIPT,IEQ)
C
                              IF(KCHAR(IIPT) .NE. 85 .OR. KCHAR(IIPT+1)
     C                           .NE. 85)
     C                                THEN
                                         CALL NEXSEP2(IIPT,IEQ,*5000)
                                         ID = IIPT - K
                                      END IF
C
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*5000)
                             CALL NEXPRT2(IIPT,IEQ,*5000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*5000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*5000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*5000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                   END IF
C
C                       99 LALALA
C                       -- ------
C
                        CALL NEXPRT2( IPT,IEQ,*5000)
                        CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                       CHECK VALIDITY OF LALALA
C
                        IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR = 4
                              CALL ERRSTA(5,1,IFIRST,NUMERR)
                              GO TO 5000
                           END IF
C
C                       QC LOLOLOLO
C                       -- --------
C
                        CALL NEXPRT2( IPT,IEQ,*5000)
                        CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                       CHECK VALIDITY OF LOLOLOLO
C
                        IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                          KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                        IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
                        IF (IRET.NE.0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR=4
                              CALL ERRSTA(5,1,IFIRST,NUMERR)
                              GO TO 5000
                           END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXPRT2(IPT,IEQ,*5000)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                              KDEC(5),KDEC(6))
                        IF(KDEC(5).EQ.MINDIC) RETURN
                        IF(KDEC(6).EQ.MINDIC) RETURN
C   
                        CALL MARDSEN(KDEC(5),KDEC(6),KINT(9),IRET)
C
                        IF(IRET .NE. 0)
     1                      THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) RETURN
C
C    --------------            WRONG CODE FOR MARSDEN SQUARE    ------
C
                               KERR = 4
                               CALL ERRSTA(5,1,IFIRST,NUMERR)
                              GO TO 5000
C
                            END IF
C
C                      hohohohoim ( height of mobile platform)
C                      ---------------------------------------
C                        HOHOHOHO - KINT(699)
C                        IM       - KINT(700)
C
                       IF(KDEC(4).EQ.137) THEN
                          CALL NEXTPRT(IPT,IEQ)
                          CALL EXTGRP(IPT,4,1,0,0,0,699,IRET)
                       END IF
C
                    ELSE
C
C                       THIS IS NOT A TEMP REPORT
C
                        KERR = 3
                        NOER(5,KERR) = NOER(5,KERR) + 1
                              GO TO 5000
                END IF
             END IF
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
C
C                  IF LETTER ENCOUNTERED FOR LAND STATION CONVERT
C                  IT TO FIGURE (NOT FOR SHIP'S CALL SIGN)
C
                   IF(KDEC(4) .EQ. 35) CALL LETFIG(KCHAR(J))
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C
C     CHECK VALUES OF YY GG FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4).GE.35 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
                      KERR = 3
                      CALL ERRSTA(5,1,IFIRST,NUMERR)
                      GO TO 5000
                   END IF
           END IF
C
C
C
C     -----------------------------------------------------------------
C*          3. SECTION 2  (STANDARD ISOBARIC SURFACES).
C              ----------------------------------------
2000  CONTINUE
C
C     'NIL' REPORTS WILL NOT BE PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
C     GET THE POINTER TO THE FIRST LEVEL
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      LPT = IPT
C
      LEVPRE=-1
      NOWIND=0
      NUMFIX = 0
C
2100  CONTINUE
C
C     PIPI HIHIHI
C     ---- ------
C
      LEVOLD = LEVPRE
C
      CALL NEXTPRT(IPT,IEQ)
      IF(IPT .GE. IEQ) GO TO 5000
C
      ILEV1 = KCHAR(IPT) - 48
      ILEV2 = KCHAR(IPT+1) - 48
C
      IF(ILEV2 .EQ. -12 .AND. LEVPRE .GE. 0)
     C   THEN
C
C           REJECT THE PREVIOUS LEVEL
C
            DO 2110 I = IPOS,IPOS+6
            KINT(I) = MINDIC
2110        CONTINUE
         END IF
C
C     CHECK IF THESE CHARACTERS ARE NOT FIGURES
C
      IF(ILEV1 .LT. 0 .OR. ILEV1 .GT. 9 .OR.
     C   ILEV2 .LT. 0 .OR. ILEV2 .GT. 9 )
     C      THEN
               ILEVP = -1
               GO TO 2120
            END IF
C
C     CHECK IF THIS IS THE BEGINNING OF SECTION
C     3 OR 4 (88---,77---, OR 66---)
C
      ILEV = 10*ILEV1 + ILEV2
      IF(ILEV .EQ. 88) GO TO 3000
      IF(ILEV .EQ. 77) GO TO 4000
      IF(ILEV .EQ. 66) GO TO 4000
C
C     CHECK IF THIS IS /////-GROUP (E.G. GROUP OF 'MISSING WIND')
C
      IF((KCHAR(IPT  ) .EQ. 47) .AND. (KCHAR(IPT+1) .EQ. 47) .AND.
     C   (KCHAR(IPT+2) .EQ. 47) .AND. (KCHAR(IPT+3) .EQ. 47) .AND.
     C   (KCHAR(IPT+4) .EQ. 47))
     C      THEN
               CALL NEXSEP2(IPT,IEQ,*5000)
               GO TO 2100
            END IF
C
C     SOME STATIONS ARE REPORTING AN EXTRA LEVELS  (NOT
C     STANDARD ISOBARIC SURFACES). THIS LEVEL DATA ARE ELIMINATED.
C
      IF(ILEV .LT. 10)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*5000)
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
C     SOME S. AFRICA STATIONS ARE REPORTING NON STANDARD LEVEL
C     OF 15 MB INFORMATION. SKIP GROUPS FOR THAT LEVEL.
C
      IF(ILEV .EQ. 15) THEN
            CALL NEXSEP2(IPT,IEQ,*5000)
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
C     DETERMINE THE LEVEL
C
      CALL DETLEV(3,ILEV,ILEVP)
C
C     ILEVP IS USED AS AN LEVEL-INDICATOR OF THE PARTICULAR
C     LEVEL THIS TIME ROUND.
C
C           ILEVP = 0  FOR 70MB
C                 = 1  FOR 50MB
C           ---------------------
C                 = 9  FOR  1MB
C                 < 0  IF THIS WASNT A PRESSURE GROUP
C
C     LEVPRE IS USED AS AN INDICATOR OF THE LEVEL REACHED
C     SO FAR BEFORE THIS LEVEL.
C
C        IF LEVELS ARE OUT OF SEQUENCE OR THERE IS SOME OTHER
C        FORMAL CODING ERROR, SO THAT THE NEXT PRESSURE/HEIGHT
C        GROUP WAS NOT FOUND, AN ATTEMPT IS MADE TO FIX THE
C        ERROR AND FIND CORRECT DATA LEVELS OR TROPOPAUSE
C        OR MAX. WIND.
C
2120  CONTINUE
C
      MORE = 0
C
C
      IF(ILEVP .LE. LEVPRE .OR. ILEVP .LT. 0)
     1       THEN
                KERR = 8
C
C
C               TRY TO FIX THE PHASE ERROR
C
                NUMFIX = NUMFIX + 1
                IF(NUMFIX .GT. 3) GO TO 5000
C
                CALL FIXPHAS(LEVPRE,NOWIND,MORE,IFIX,LEVFIX,*3000,*4000)
C
                IF(IFIX .GT. 0)
     C             THEN
                      CALL ERRSTA(5,2,IFIRST,NUMERR)
                      IPOS = 17 + LEVFIX*7
                      KINT(IPOS) = IFIX
                      CALL EXTGRP(IPT,3,0,0,0,0,IPOS+1,IRET)
c
c                     fix in case ilevp = -1
c
                      ilevp=levfix
c                      
                      GO TO 2300
                   END IF
C
                CALL ERRSTA(5,2,IFIRST,NUMERR)
C
                IF(NUMERR .EQ. 1)
     C             THEN
                      IF(LEVPRE .EQ. -1) IREMPOS = 17
                      IF(LEVPRE .NE. -1) IREMPOS = IPOS
                   END IF
C
                IF(MORE .GE. 2) GO TO 2100
C
C              IF NO FIX FOUND REJECT THE PREVIOUS LEVEL
C
               IF(LEVPRE .GE. 0 .AND. IPOS .GT. 17)
     C            THEN
                     DO 2150 J = IPOS , IPOS+6
                     KINT(J) = MINDIC
2150                 CONTINUE
                  END IF
C
                GO TO 5000
             END IF
C
      IPOS = 17 + ILEVP*7
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
                IF(IRET .NE. 0)
     1             THEN
                      KERR = 5
                      CALL ERRSTA(5,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = IPOS
                      CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                  END IF
C
2300  CONTINUE
C
C     TITI TAI DIDI
C     ---- --- ----
      CALL NEXTPRT(IPT,IEQ)
      IF(IPT .GE. IEQ) GO TO 5000
C
C     CHECK IF THE GROUP IS 88999, 77999 OR 66999
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 88999 .OR. IVAL .EQ. 77999 .OR. IVAL .EQ. 66999)
     C   GO TO 2100
C
      CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
      IF(IRET .NE. 0)
     1   THEN
            KERR = 6
            CALL ERRSTA(5,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
            DO 2250 I=IPOS,IPOS+6
            KINT(I) = MINDIC
2250        CONTINUE
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
C     REJECT IF THE TEMPERATURE IS POSITIVE
C
            ISIGN = 2*(KINT(IPOS+3)/2)
            IF(ISIGN .EQ. KINT(IPOS+3))
     C         THEN
                  KERR = 6
                  CALL ERRSTA(5,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
                     DO 2310 I = IPOS+2,IPOS+4
                     KINT(I) = MINDIC
2310                 CONTINUE
               END IF
C
C     DIDI FIFIFI
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*5000)
C
C     CHECK IF THE NEXT GROUP IS WIND OR PRESSURE/HEIGHT
C     OF NEXT LEVEL OR BEGINNING OF NEXT SECTION
C
      CALL WINDHEI(ILEVP,NOWIND,IWIND,ITROPO,MAXWIN,IEND)
C
      IF(IEND .EQ. 1) GO TO 5000
C
      IF(ITROPO .EQ. 1)
     1      THEN
C           ----- TROPOPAUSE SECTION FOUND  ----
               GO TO 3000
            END IF
C
      IF(MAXWIN .EQ. 1)
     1      THEN
C           ----- MAX.WIND SECTION FOUND  ----
               GO TO 4000
            END IF
C
      IF(NOWIND .GE. 2)
     C      THEN
               LEVPRE = ILEVP
               GO TO 2100
            END IF
C
      IF(IWIND .EQ. 1)
     1      THEN
C           ----- WIND GROUP FOUND  ----
               IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
               GO TO 2400
            END IF
C
      IF(IWIND .EQ. 0)
     1      THEN
C           ----- PRESSURE/HEIGHT GROUP FOUND  ----
               IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
               GO TO 2100
            END IF
C
      IF(IWIND .EQ. -1)
     1     THEN
C          -----CORRUPTED WIND GROUP FOUND  ----
              CALL NEXSEP2(IPT,IEQ,*5000)
              KERR = 7
              CALL ERRSTA(5,1,IFIRST,NUMERR)
              IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
              IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
              GO TO 2100
           END IF
C
C
      IF(IWIND .EQ. -2)
     1     THEN
C          ----- '/////' - WIND GROUP FOUND  ----
              CALL NEXSEP2(IPT,IEQ,*5000)
              IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
              GO TO 2100
           END IF
C
      IF(IWIND .EQ. -3)
     1     THEN
C          ----- FORMAL ERROR IN GROUP ----
              KERR=7
              CALL ERRSTA(5,1,IFIRST,NUMERR)
              IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
              DO 2370 I=IPOS,IPOS+6
              KINT(I) = MINDIC
2370          CONTINUE
              CALL NEXSEP2(IPT,IEQ,*5000)
              GO TO 2100
           END IF
C
C
            IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
C
      IF(NOWIND .GE. 2) GO TO 2100
C
C
2400  CONTINUE
C
C     EXTRACTING THE WIND GROUP
C
C     DONT EXTRACT IF THE PRESSURE GROUP IS MISSING
C
      IF(KINT(IPOS) .EQ. MINDIC)
     C   THEN
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+5,IRET)
      NOWIND=0
C
      IF(IRET .NE. 0) THEN
                          KERR = 7
                          CALL ERRSTA(5,1,IFIRST,NUMERR)
                          IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
                          CALL NEXSEP2(IPT,IEQ,*5000)
                      END IF
C
C     GO TO FIND THE NEXT LEVEL
C
      GO TO 2100
C
C
C
C
C     ----------------------------------------------------------------
C*          4. SECTION 3 (TROPOPAUSE LEVELS).
C              ------------------------------
3000  CONTINUE
C
C
      IPOS = 108
C
C     THREE POSSIBLE TROPOPAUSES
C     ----- -------- -----------
C
      DO 3500 I=1,3
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      IREMOVE = 0
      IPOS = IPOS + 7
C
3100  CONTINUE
C
C     CHECK IF THIS IS MAX WIND  (I.E. 77---, 66---)
C
      IF(((KCHAR(IPT) .EQ. 54) .AND. (KCHAR(IPT+1) .EQ. 54)) .OR.
     C  ((KCHAR(IPT) .EQ. 55) .AND. (KCHAR(IPT+1) .EQ. 55))) GO TO 4000
C
C     CHECK THAT THIS IS TROPOPAUSE  (I.E. 88---)
C
      IF(KCHAR(IPT) .EQ. 56 .AND. KCHAR(IPT+1) .EQ. 56)
     1   THEN
            CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 9
                  CALL ERRSTA(5,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
                  CALL NEXSEP2(IPT,IEQ,*5000)
                  GO TO 3300
                END IF
C
C           CHECK THAT GROUP WAS NOT 88999  ( = "NO TROPOPAUSE")
C
            IF(KINT(IPOS+1) .NE. 999)
     1         THEN
C
C                  TTTT TAT DTDT
C                  ---- --- ----
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
C
C                   CHECK IF THE NEXT GROUP IS 88999, 77999 OR 66999
C
                    CALL EXTVAL(IPT,5,IVAL)
                    IF(IVAL .EQ. 88999 .OR. IVAL .EQ. 77999 .OR.
     C                 IVAL .EQ. 66999) GO TO 3500
C
                   CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 10
                         CALL ERRSTA(5,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 3300
                      END IF
C
C                  REJECT IF THE TEMPERATURE IS POSITIVE
C
                         ISIGN = 2*(KINT(IPOS+3)/2)
                         IF(ISIGN .EQ. KINT(IPOS+3))
     C                      THEN
                               KERR = 10
                               CALL ERRSTA(5,1,IFIRST,NUMERR)
                               IF(NUMERR .EQ. 1) IREMPOS = IPOS
                               DO 3150 J = IPOS+2,IPOS+4
                               KINT(J) = MINDIC
3150                           CONTINUE
                            END IF
C
C                  DTDT FTFTFT
C                  ---- ------
C
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
C
C                  CHECK IF THIS IS NEXT TROPOPAUSE
C                  OR MAX. WIND LEVEL.
C
                   CALL EXTVAL(IPT,2,IVAL)
C
                   IF(IVAL .EQ. 88) GO TO 3500
C
                   IF(IVAL .EQ. 77 .OR. IVAL .EQ. 66) GO TO 4000
C
                   CALL EXTGRP(IPT,2,3,0,0,0,IPOS+5,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 11
                         CALL ERRSTA(5,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 3300
                      END IF
C
                       IF(KINT(IPOS+5) .GT. 36 .AND.
     C                    KINT(IPOS+5) .NE. MINDIC)
     1                    THEN
                             KERR = 11
                             CALL ERRSTA(5,1,IFIRST,NUMERR)
                             GO TO 3300
                          END IF
C
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
               ELSE
                   GO TO 3500
               END IF
         ELSE
            GO TO 3300
         END IF
C
      GO TO 3500
C
C
3300        CONTINUE
C
C           ERROR IN DATA ---  REMOVE THE PREVIOUS TROPOPAUSE BECAUSE
C                              IT MIGHT HAVE BEEN CORRUPTED
C
                            DO 3400 J=IPOS,IPOS+6
                            KINT(J) = MINDIC
3400                        CONTINUE
C
                            KERR = 9
                            CALL ERRSTA(5,1,IFIRST,NUMERR)
                            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                            CALL NEXSEP2(IPT,IEQ,*5000)
                            CALL NEXPRT2(IPT,IEQ,*5000)
C
                            GO TO 3100
C
3500  CONTINUE
C     ----------------------------------------------------------------
C*          5. SECTION 4 (MAX WIND LEVELS AND VERTICAL WIND SHEAR).    *
C              ----------------------------------------------------
4000  CONTINUE
C
C     THREE POSSIBLE MAX WIND LEVELS
C     ----- -------- --- ---- ------
C
      IPOS = 129
C
      DO 4500 I=1,3
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      IREMOVE = 0
      IPOS = IPOS + 7
C
4100  CONTINUE
C
C     CHECK THAT THIS IS MAX WIND (I.E. 77--- OR 66---)
C
      IF((KCHAR(IPT) .EQ. 55 .AND. KCHAR(IPT+1) .EQ. 55) .OR.
     1   (KCHAR(IPT) .EQ. 54 .AND. KCHAR(IPT+1) .EQ. 54))
     2     THEN
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 12
                         CALL ERRSTA(5,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 4300
                      END IF
C
C              CHECK THAT GROU IS NOT 77999 (='NO MAX WINDS)
C
               IF(KINT(IPOS+1) .EQ. 999) GO TO 5000
C
C              DMDM FMFMFM
C              ---- ------
C
               CALL NEXTPRT(IPT,IEQ)
               IF(IPT .GE. IEQ) GO TO 5000
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 13
                         CALL ERRSTA(5,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 4300
                      END IF
C
                   IF(KINT(IPOS+2) .GT. 36 .AND.
     C                KINT(IPOS+5) .NE. MINDIC)
     C                THEN
                         KERR = 13
                         CALL ERRSTA(5,1,IFIRST,NUMERR)
                         GO TO 4300
                      END IF
C
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
C
C              4 VBVBVAVA
C              - --------
C
C              CHECK IF THIS IS WIND SHEAR GROUP  (I.E. 4----)
C
               IF(KCHAR(IPT) .EQ. 52)
     1            THEN
                      CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
C
                      IF(IRET .NE. 0)
     C                   THEN
                           KERR = 14
                           CALL ERRSTA(5,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = IPOS + 4
                           CALL NEXSEP2(IPT,IEQ,*5000)
                           GO TO 4300
                         END IF
C
                      CALL NEXTPRT(IPT,IEQ)
                      IF(IPT .GE. IEQ) GO TO 5000
                  ELSE
C
C                     CHECK IF THIS IS THE BEGINNING
C                     OF NEXT MAX WIND
C
                      IF(((KCHAR(IPT)   .EQ. 54) .AND.
     1                    (KCHAR(IPT+1) .EQ. 54))
     2                  .OR.
     3                   ((KCHAR(IPT)   .NE. 55) .OR.
     4                    (KCHAR(IPT+1) .EQ. 55)))
     5                    GO TO 4500
                      GO TO 4300
                  END IF
          ELSE
                  GO TO 4300
          END IF
C
      IF(IPT .GE. IEQ) GO TO 5000
C
      GO TO 4500
C
C
4300        CONTINUE
C
C           ERROR IN DATA ---  REMOVE THE PREVIOUS MAX WIND BECAUSE
C                              IT MIGHT HAVE BEEN CORRUPTED
C
                            DO 4350 J=IPOS,IPOS+6
                            KINT(J) = MINDIC
4350                        CONTINUE
                            KERR = 12
                            CALL ERRSTA(5,1,IFIRST,NUMERR)
                            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                            CALL NEXSEP2(IPT,IEQ,*5000)
                            CALL NEXPRT2(IPT,IEQ,*5000)
C
                            GO TO 4100
C
4500  CONTINUE
C
C     ERROR IF NOT END OF REPORT
C
5000  CONTINUE
C
C     ERROR CHECKING AND HANDLING
C
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR .EQ. 0) RETURN
C
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
                             IPT=KEEP
                             CALL FIXUS
                             IFIRST=1
                             NUMRERR(5) = NUMRERR(5) + 1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                             DO 25500 I=KEEP,IGS
                             KCHAR(I) = KCHAR(I) .AND. 127
25500                        CONTINUE
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 5 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
                             IF(NUMERR .GT. 5)
     C                          THEN
                                   DO 26000 I = IREMPOS,700
                                   KINT(I) = MINDIC
26000                              CONTINUE
                                END IF
C
c                            IF(KERR .GT. 4) KERR=0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                             end if
c
                             RETURN
                          END IF
C
      END
      
      SUBROUTINE USDEC(IHEAD,IERR)
C**** *USDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TEMP REPORT PART A FROM INTERMEDIATE FORMAT
C         TO FULL DECODED FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *USDEC(IHEAD,IERR)*
C
C          INPUT    : REPORT IN INTERMEDIATE FORMAT IN 'KINT'.
C
C          OUTPUT   : REPORT WRITTEN TO DECODED REPORTS FILE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'printre.h'
C
      DATA IROU/0/
      DATA IPRNUM /0/
C
C
C     ------------------------------------------------------------------
C*          1.  SET FLAGS AND INDICATORS.
C                ------------------------
 100  CONTINUE
C
C      CALL PRTKINT(KINT,1,200,MINDIC)
C
C     DEFINE 'NIL' INDICATOR
C
      NIL = KDEC(20) .AND. 1
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C     SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 101 I=25,700
      KDEC(I)=MINDIC
 101  CONTINUE
C
C
C     -----------------------------------------------------------------
C*          2. SECTION 1.
C              -----------
 200  CONTINUE
C
C     REPORT HEADER
C
C     IN THIS SUBROUTINE ONLY THE FOLLOWING PARTS
C     OF THE HEADER WILL BE DECODED
C        - DAY OF THE MONTH
C        - TIME (HOUR & MIN) FROM REPORT
C        - IDENTIFIER
C        - LENGTH OF THE REPORT
C     AND IN CASE OF TEMP SHIP OR TEMP DROP
C        - LAT &LONG
C        - ALT = 0 (FOR SHIP)
C
C
C*          2.1 DAY AND TIME .
C               --------------
 210  CONTINUE
C
      KDEC(1)=KINT(1)
      KDEC(2)=KINT(2)
      KDEC(9)=0
C
C
C*          2.2 CHECK IF SHIP OR DROP TEMP.
C               ---------------------------
 220  CONTINUE
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
C
C        LAT & LONG
C
         CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     1               KDEC(5),KDEC(6))
         IF(KDEC(5).EQ.MINDIC) RETURN
         IF(KDEC(6).EQ.MINDIC) RETURN   
C        ALTIT=0, FOR SEA STATION
C
         IF(KDEC(4) .EQ. 36) KDEC(8)=0
C
      END IF
C
C
C     -----------------------------------------------------------------
C*          2.3 IDENT   STATION/SHIP/AIRCRAFTIDENTIFICATION.
C               --------------------------------------------
 230  CONTINUE
C
      KDEC(7)=88
C
      IF(KDEC(4).EQ.137) THEN
         IF(KINT(699).NE.MINDIC.AND.KINT(700).NE.MINDIC) THEN
            IF(KINT(700).GE.1.AND.KINT(700).LE.4) KDEC(8)=KINT(699)
            IF(KINT(700).GE.5.AND.KINT(700).LE.8) THEN
                KDEC(8)=NINT(KINT(699)*.3)
            END IF
         END IF
      END IF
C
 233  CONTINUE
C
C
C
C*          2.4 REPORT LENGTH.
C               --------------
      KDEC(24) = 426
C
      K=MINDIC
      IF(KDEC(4) .LT. 21) K=KDEC(17)*1000+KDEC(16)
C
C     CHECK IF WIND SPEED IS GIVEN IN KNOTS, IN
C     THIS CASE 50 HAS BEEN ADDED TO THE DATE YY.
C
      IWW=0
      IF(KDEC(1) .GT. 31 .AND. KDEC(1) .LE. 81)
     1             THEN
                      IWW=1
                      KDEC(1)=KDEC(1)-50
                   END IF
C
C     IF DATE INCORRECT REJECT THE REPORT BECAUSE
C     IT IS NOT KNOWN IF WIND IS IN M/S OR KNOTS
C
      IF(KDEC(1) .LT. 0 .OR. KDEC(1) .GT. 31) RETURN
C
C
C     'NIL'-REPORTS WILL NOT BE DECODED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
      IROU = IROU + 1
C
C     ---------------------------------------------------------------
C*          3.  SECTION 2   PRESSURE LEVELS.
C               ----------------------------
 300  CONTINUE
C
C     P0P0P0   PRESSURE AT STATION LEVEL IN TENTHS OF HECTOPASCAL
C
      IF(KINT(18) .NE. MINDIC)
     1                 THEN
                          KDEC(25) = KINT(18)*10
C
C                         CHECK IF THOUSAND-DIGIT IS OMITTED
C
                          IF(KDEC(25) .LT. 3000)
     1                       KDEC(25) = KDEC(25) + 10000
                        END IF
C
C     T0T0    TEMPERATURE AT STATION LEVEL IN TENTHS OF DEGREE
C
      CALL IC3931(KINT(20),KINT(19),MINDIC,KDEC(26))
C
C     TDTD   DEW-POINT TEMPERATURE AT STATION LEVEL
C
      IF(KDEC(26) .NE. MINDIC)
     1  CALL IC0777(KINT(21),KDEC(26),MINDIC,KDEC(27))
C
C     DD & FFF  WIND DIRECTION AND SPEED
C
C
      CALL DDFFF(KINT(22),KINT(23),IWW,K,MINDIC,KDEC(28),KDEC(29))
C
      LEVPRE = -999999
      INDPRE = 30
C
      DO 301 I=1,11
C
            IND=(I-1)*7+24
            IND2=(I-1)*5+30
            IF(KINT(IND) .EQ. MINDIC) GO TO 301
C
C           PIPI HIHIHI    HEIGHT AT LEVEL I
C
            LEV = KINT(IND) * 10
            IF(LEV.EQ.920) LEV=925
C
            CALL GEOPOTE(LEV,KINT(IND+1),MINDIC,KDEC(IND2))
C
            IF(KDEC(IND2) .EQ. MINDIC) GO TO 301
C
C           CHECK IF THIS LEVEL IS LOWER OR SAME AS PREVIOUS.
C           IF IT IS THE SAME REJECT THIS LEVEL,  IF IT IS
C           LOWER REJECT BOTH.
C
            IF(KDEC(IND2) .EQ. LEVPRE)
     C         THEN
                  KDEC(IND2) = MINDIC
                  GO TO 301
               END IF
C
            IF(KDEC(IND2) .LT. LEVPRE)
     C         THEN
                  DO 302 J=INDPRE,IND2
                  KDEC(J) = MINDIC
302               CONTINUE
                  GO TO 301
            END IF
C
            LEVPRE = KDEC(IND2)
            INDPRE = IND2
C
C           TITI     TEMPERATURE AT LEVEL I
C
            CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C
C           TDTD     DEW-POINT TEMPERATURE AT LEVEL I
C
            CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))
C
C           DIDI FIFIFI    WIND DIRECTION & SPEED AT LEVEL I
C
            CALL DDFFF(KINT(IND+5),KINT(IND+6),IWW,K,MINDIC,
     1                 KDEC(IND2+3),KDEC(IND2+4))
C
C
301         CONTINUE
C
C      ----------------------------------------------------------------
C*          4. SECTION 3   TROPOPAUSE(S).
C              --------------------------
 400  CONTINUE
C
C
      DO 401 I=1,3
C
            IND =101 + (I-1)*7
            IND2=100 + (I-1)*5
C
C
C           88PTPTPT   PRESSURE AT TROPOPAUSE LEVEL
C
C
C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. MINDIC) GO TO 402
            IF(KINT(IND+1) .EQ. MINDIC .OR. KINT(IND+1) .EQ. 999)
     1          GO TO 401
            IF(KINT(IND+1) .EQ. 0 ) GO TO 401
C
            KDEC(IND2) = KINT(IND+1)*10
C
C
C           TTTT   TEMPERATURE AT TROPOPAUSE LEVEL
C
            CALL IC3931(KINT(IND+3),KINT(IND+2),MINDIC,KDEC(IND2+1))
C
C
C           TDTD   DEW-POINT TEMPERATURE AT TROPOPAUSE LEVEL
C
            CALL IC0777(KINT(IND+4),KDEC(IND2+1),MINDIC,KDEC(IND2+2))
C
C
C           DTDT FTFTFT   WINDS AT TROPOPAUSE
C
            CALL DDFFF(KINT(IND+5),KINT(IND+6),IWW,K,MINDIC,
     1                 KDEC(IND2+3),KDEC(IND2+4))
C
401         CONTINUE
C
C
 402  CONTINUE
C
C
C     ---------------------------------------------------------------
C*          5. SECTION 4  MAX WIND LEVEL(S).
C              ------------------------------
 500  CONTINUE
C
C
C
      DO 501 I=1,3
C
            IND = 122 + (I-1)*7
            IND2= 115 + (I-1)*5
C
C
C     77PMPMPM OR 66PMPMPM   PRESSURE AT MAX. WIND LEVEL
C
C
C           CHECK FOR MISSING DATA
C
            IF(KINT(IND) .EQ. MINDIC) GO TO 502
            IF(KINT(IND+1) .EQ. MINDIC .OR. KINT(IND+1) .EQ. 999)
     1         GO TO 502
            IF(KINT(IND+1) .EQ. 0 ) GO TO 502
C
            KDEC(IND2) = KINT(IND+1)*10
C
C
C     DMDM FMFMFM   WIND AT MAX. WIND LEVEL
C
            CALL DDFFF(KINT(IND+2),KINT(IND+3),IWW,K,MINDIC,
     1                 KDEC(IND2+1),KDEC(IND2+2))
C
C
C     4VBVBVAVA   VERTICAL WIND SHEAR ASSOSIATED TO THIS MAX WIND LEVEL
C
            IF(KINT(IND+4) .EQ. MINDIC) GO TO 501
C
            IF(KINT(IND+5) .NE. MINDIC) THEN
              ISPD=KINT(IND+5)
              IF(IWW.EQ.1) CALL KTOMPSI(ISPD)
              KDEC(IND2+3) = ISPD
            END IF
C
            IF(KINT(IND+6) .NE. MINDIC) THEN
               ISPD=KINT(IND+6)
               IF(IWW.EQ.1) CALL KTOMPSI(ISPD)
               KDEC(IND2+4) = ISPD
            END IF
C
 501        CONTINUE
C
C
 502  CONTINUE
C
C
C
C     FLAG THE REPORT TO BE 'NIL' IF THERE ARE NO DATA IN IT (I.E. IF
C     THERE ARE NO DATA AND NO CODING ERRORS)
C
      NIL2 = 1
      DO 503 I=25,KDEC(24)
      IF(KDEC(I) .EQ. MINDIC) GO TO 503
      NIL2 = 0
      GO TO 504
503   CONTINUE
C
504   CONTINUE
C
      IF(NIL2 .EQ. 1)
     C   THEN
            KDEC(20) = KDEC(20) .OR. 1
            GO TO 99800
         END IF
C
C
C     ----------------------------------------------------------------
C*          6. PRINTING OF ERRORS & REPORTS & KINT & KDEC.
C              --------------------------------------------
 600  CONTINUE
C
      IPRI = 0
      IPRIALL = 0
C
      IS1 = KINT(12) - 48
      IS2 = KINT(13) - 48
      IS3 = KINT(14) - 48
      IS4 = KINT(15) - 48
      IS5 = KINT(16) - 48
C
      IBLOK = 10*IS1 + IS2
      ISTA = 10000*IS1 + 1000*IS2 + 100*IS3 + 10*IS4 + IS5
C
      DO 601 I=1,10
      IF(IBLOK .EQ. IBLOCKS(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
601   CONTINUE
C
      DO 602 I=1,100
      IF(ISTA .EQ. ISTASA(I))
     C   THEN
            IPRI = 1
            IPRIALL = 1
         END IF
 602  CONTINUE
C
C     PRINT THE ERRONEUS SHIPS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERSHIP .GT. 0)
     C   THEN
            IF(KDEC(4) .GE. 36 .AND. KDEC(20) .GT. 1) IPRI = 1
         END IF
C
C     PRINT ALL ERRONEUS REPORTS WITHIN TIME LIMITS IF REQUIRED
C
      IF(IERALL .GT. 0)
     C   THEN
            IPRI = 1
         END IF
      IF(IERALLA .GT. 0) IPRI = 1
C
C
C
      IF(KDEC(2) .LT. ITIMES(1) .AND. KDEC(2) .GT. ITIMES(2))
     C   THEN
            IPRI = 0
            IPRIALL = 0
         END IF
C
C
C
      IF(IPRI .GT. 0)
     C   THEN
            DO 603 I=1,IPRLIM
C===        IF(KINT(4) .EQ. IDONEA(I)) GO TO 99800
 603        CONTINUE
            IPRNUM=IPRNUM+1
            IF(IPRNUM .LE. IPRLIM) IDONEA(IPRNUM) = KINT(4)
C
            IF(KDEC(20) .GT. 1)
     C         THEN
                  IF(NIL2 .EQ. 0) CALL PRTEMP(IROU)
                  WRITE(*,10000)
               ELSE
                  IF(IPRIALL .EQ. 1)
     C               THEN
                        WRITE(*,20000) IROU
                        CALL PRTBULL(IMI,IEQ)
                        CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
                     END IF
               END IF
         END IF
C
10000 FORMAT(///)
20000 FORMAT(//2X,' PART A  NUMBER =',I5,/)
30000 FORMAT(2X,' PART A  NUMBER =',I4,1X,2(I10,1X),5X,A5,
     C       2(I10,1X),2(A10,1X))
     
C
99800 CONTINUE
C
C      CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
      CALL TEMPEXP(1,IERR)
      CALL MRGTEM(IERR)
      CALL QCTEMP(KDEC(4),IERR)
      CALL BUFRENC(IERR)
C
99900 CONTINUE
C
C
      RETURN
      END
      
      SUBROUTINE USINT ( IHEAD,IERR )
C**** *USINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT TEMP REPORTS PART A FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *USINT(IHEAD,IERR)*
C
C          INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                     IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                               WRITTEN TO ERROR FILE.
C                           = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                     IERR NOT USED ON INPUT.
C
C          OUTPUT    : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                      DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION ).
C
C     METHOD.
C     -------
C
C         IF AN ERROR IS FOUND IN THE DATA, THE DECODING
C         IS PROCEEDED UNLESS THE ERROR IS FATAL I.E.
C         LAT/LONG OR TIME/DATE IS INCORRECT.
C         WHEN A NON-FATAL ERROR HAS BEEN DETECTED THE
C         ROUTINE TRIES TO FIND THE BEGINNING OF CORRECT
C         DATA.  IF CORRECT DATA ARE FOUND THE DECODING
C         THE NUMBER OF NON-FATAL ERRORS IS COUNTED AND
C         IF IT IS GREATER THAN LIMIT (5 FOR NOW) ALL THE
C         DATA AFTER THE FIRST ERROR ARE REMOVED (THIS
C         IS DONE TO ENSURE THAT TOTALLY CORRUPTED DATA
C         ARE NOT USED E.G. WRONG PART OF TEMP).
C         FOR THIS PURPOSE TWO VARIABLES ARE USED
C         NUMERR = NUMBER OF NON-FATAL ERRORS
C         IREMPOS= THE POINTER TO FIRST ERROR IN KINT.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION IPLEV(10)
C
      DATA IPLEV/
     1   92,85,70,50,40,30,25,20,15,10/
C
C
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . KEEP POINTER TO FIRST
C              --------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
 100  CONTINUE
C
C     POINTER TO FIRST CHARACTER.
C
      KEEP = IPT
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      KDEC(20) = 0
C
C     ERROR INDICATOR.
C
  101 KERR = 0
      NUMERR = 0
      IREMPOS = 17
C
C     CHECK FOR 'NIL' REPORT.
C
C
      NIL=0
C
      ILN = IEQ - IPT
      IF ( ILN.LE.26 )
     C   THEN
             KERR = 1
             NIL = 1
             CALL ERRSTA(3,0,IFIRST,NUMERR)
         END IF
C
C      SET AREA FOR DECODED REPORT TO MISSING DATA VALUE.
C
      DO 102 I=1,200
         KINT(I) = MINDIC
  102 CONTINUE
C
C     WORDS 12-16 SET 'XXX  ' . STATION/SHIP/AIRCRAFT IDENTIFIER
C     KEPT IN THESE WORDS IN CCITT 5 CHARACTERS.
C
      DO 103 I=12,14
         KINT(I) = 88
  103 CONTINUE
C
      KINT(15) = 32
      KINT(16) = 32
C
C     CLEAR DATA FOR PREVIOUS REPORT FROM DECODED REPORT HEADER AREA.
C
      DO 104 I=1,3
         KDEC(I) = MINDIC
  104 CONTINUE
C
      DO 105 I=5,9
         KDEC(I) = MINDIC
  105 CONTINUE
C
C    CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
      KDEC(15) = 0
C
      KDEC(17) = MINDIC
      KDEC(22) = MINDIC
C
C
C     ----------------------------------------------------------------
C*          2.  SECTION 1 (IDENTIFICATION AND POSITION,
C               ---------------------------------------
C               THIS IS DIFFERENT FOR LAND STATIONS AND
C               ---------------------------------------
C               SHIP/AIRCRAFT.REPORTS).
C               -----------------------
1000  CONTINUE
C
C               YY GG ID
C               -- -- --
C
 1011           CONTINUE
C
                CALL NEXSEP2(IPT,IEQ,*5000)
                CALL NEXPRT2(IPT,IEQ,*5000)
                IF(KCHAR(IPT).GE.65) THEN
                                        GO TO 1011
                                     END IF
C
C               FIRST FIGURE OF THE GROUP MUST BE 0-3
C               OR 5-8 IF WIND SPEED IS GIVEN IN KNOTS,
C               OTHERWISE YYGGID GROUP IS MISSING
C
                IF ((KCHAR(IPT) .GE. 48) .AND. (KCHAR(IPT) .NE. 52)
     1            .AND. (KCHAR(IPT) .LE. 56))
     2             CALL EXTGRP ( IPT,2,2,1,0,0,1,IRET )
C
                JPT = IPT
C
C
C
C
  700 IF ( KDEC(4).EQ.35 )
     C      THEN
C
C               LAND STATION
C
C               IIIII     -   RETAIN POINTER TO IDENTIFIER
C               -----
C
                CALL NEXPRT2(IPT,IEQ,*5000)
                KPT = IPT
                ID = 5
                CALL EXTINT ( IPT,5,4 )
C
C               EXTRACT STATION LAT/LONG ETC FROM WMO MASTER FILE.
C
                CALL LOCSTAT ( IWIND,IRET )
C
C               CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                IF(IRET .EQ. 0) THEN
                        IF(NIL .EQ. 1) THEN
                           KDEC(20)=1
                           RETURN
                        END IF
                    END IF
C
                IF ( IRET.EQ.1 ) THEN
C
C                       STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                       ENTRY , SO REPORT IS IGNORED.
C
                        KERR = 2
                        NOER(3,KERR) = NOER(3,KERR) + 1
C
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1               FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                        WRITE (55,9901) KINT(4)
                        CLOSE(55)
                        WRITE (*,9901) KINT(4)
 9901                   FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
c                        CALL PRTBULL(1,IGS)
C-----                  PRINT IIIII WITH NO MASTER FILE ENTRY
C
                        RETURN
                    END IF
C
                IF ( IRET.EQ.2 ) THEN
C
C                       CORRUPT NUMBER - FATAL DECODING ERROR
C
                        KPT = IABS(KPT)
                        KERR = 2
C
C                       RETURN IF REPORT CAN'T CONTAIN IDENT
C
                        IF( (KPT+5) .GE. IEQ) RETURN
C
                        CALL ERRSTA(3,2,IFIRST,NUMERR)
                        RETURN
                    END IF
C
C
                 IF(IRET .EQ. 3) THEN
C
C                      INVALID OBSERVATION TYPE
C
                       KERR = 3
                       NOER(3,KERR) = NOER(3,KERR) + 1
                       RETURN
                    END IF
C
                 IF ( IRET.EQ.4 ) THEN
C
C                   STATION NUMBER IN RANGE , BUT NO MASTER FILE
C                   ENTRY , FOR THAT OBSERVATION TYPE. 
C
c                   PRINT IIIII WITH NO MASTER FILE ENTRY
                        OPEN(UNIT=55,
     1               FILE='unknown_temp_station.dat',
     2                       ACCESS='APPEND',
     3                       CARRIAGECONTROL='LIST',
     4                       FORM='FORMATTED',
     5                        STATUS='UNKNOWN'        )
C                        
                    WRITE (55,9991) KINT(4)
                    CLOSE(55)
                    WRITE (*,9991) KINT(4)
 9991               FORMAT (1H ,'WRONG TYPE OF STATION  - ',I5)
c                    CALL PRTBULL(1,IGS)
C-----              PRINT IIIII WITH NO MASTER FILE ENTRY
                 end if 
C
            ELSE
C
C                TEMP SHIP OR TEMP DROP
C
                 IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137)
     1              THEN
C
                        KINT(4)=0
C
C                       RETAIN POINTER TO STATION IDENTIFIER .
C
                        KPT=IMI
C
C                       CHECK THE CALL SIGN
C
                        IBUOY = 0
                        K = IMI
                        J = K + 4
C
                        DO 750 I=K,J
                        IF ( KCHAR(I).GE.65.AND.KCHAR(I).LE.90 ) IBUOY=1
  750                   CONTINUE
C
C              IF A LETTER GROUP IS FOUND CHECK THAT THIS IS NOT
C              MIMIMJMJ GROUP 'UUAA'. IN THIS CASE THE SHIP CALL
C              SIGN GROUP IS PRESUMED MISSING.
C
               IF((KCHAR(K) .EQ. 85) .AND. (KCHAR(K+1) .EQ. 85) .AND.
     C            (KCHAR(K+2) .EQ. 65) .AND. (KCHAR(K+3) .EQ. 65))
     C                   THEN
                             IBUOY = 2
                        END IF
C
               IF((KCHAR(K) .EQ. 73) .AND. (KCHAR(K+1) .EQ. 73) .AND.
     C            (KCHAR(K+2) .EQ. 65) .AND. (KCHAR(K+3) .EQ. 65))
     C                   THEN
                             IBUOY = 2
                         END IF
C
               IF((KCHAR(K) .EQ. 88) .AND. (KCHAR(K+1) .EQ. 88) .AND.
     C            (KCHAR(K+2) .EQ. 65) .AND. (KCHAR(K+3) .EQ. 65))
     C                   THEN
                             IBUOY = 2
                         END IF
C
C
               IF ( IBUOY.NE.0 )
     C             THEN
C
C                      SHIP,RIG OR PLATFORM. IDENTIFIER NO. SET TO 0
C
                       KINT(4) = 0
                         ID=0
C
                       IF (IBUOY.EQ.1)
     C                    THEN
C
C                             MOVE POINTER PAST CALL SIGN . THE FIRST
C                             CHARACTER OF THE NEXT GROUP IS
C                             LOCATED AS SOME SHIPS USE THE FULL NAME
C                             ( WHICH CAN CONSIST OF 2 WORDS ) INSTEAD
C                             OF CALL SIGN. SO IF THE NEXT GROUP DOESN'T
C                             START WITH 'UU' (WHICH IS THE BEGINNING
C                             OF MIMIMJMJ GOUP) IT MUST BE PART OF THE
C                             SHIP'S NAME USED INSTEAD OF CALL SIGN.
C
                              IIPT=K
                              CALL NEXSEP2(IIPT,IEQ,*5000)
                              ID = IIPT - KPT
                              CALL NEXTLET (IIPT,IEQ)
C
                              IF(KCHAR(IIPT) .NE. 85 .OR. KCHAR(IIPT+1)
     C                           .NE. 85)
     C                                THEN
                                         CALL NEXSEP2(IIPT,IEQ,*5000)
                                         ID = IIPT-K
                                      END IF
C
                         END IF
                       IF(IBUOY.EQ.2)
     1                    THEN
C
C                            SHIP CALL SIGN FOLLOWS MIMIMJMJ
C
                             IIPT=K
C
C                            SKIP MIMIMJMJ GROUP
C
                             CALL NEXSEP2(IIPT,IEQ,*5000)
                             CALL NEXPRT2(IIPT,IEQ,*5000)
                           IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                        THEN
                                 K=IIPT
                                 KPT=K
                                 CALL NEXSEP2(IIPT,IEQ,*5000)
                                 ID=IIPT-K
C
C                               CHECK IF CALL SIGN IS SHIP NAME
C
                                 CALL NEXPRT2(IIPT,IEQ,*5000)
                            IF(KCHAR(IIPT).GE.65.AND.KCHAR(IIPT).LE.90)
     1                              THEN
                                       CALL NEXSEP2(IIPT,IEQ,*5000)
                                       ID=IIPT-K
                                    END IF
                              END IF
                          END IF
C
                             END IF
C
C                     99 LALALA
C                     -- ------
C
                      CALL NEXTPRT ( IPT,IEQ )
                      CALL EXTGRP ( IPT,2,3,0,0,0,5,IRET )
C
C                     CHECK VALIDITY OF LALALA
C
                      IF (KINT(6).LT.0.OR.KINT(6).GT.900)
     C                  THEN
C
C                          CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                           KERR = 4
                           CALL ERRSTA(3,1,IFIRST,NUMERR)
                           GO TO 5000
                        END IF
C
C                    QC LOLOLOLO
C                    -- --------
C
                     CALL NEXTPRT ( IPT,IEQ )
                     CALL EXTGRP ( IPT,1,4,0,0,0,7,IRET )
C
C                    CHECK VALIDITY OF LOLOLOLO
C
                     IF (KINT(7).NE.1.AND.KINT(7).NE.3.AND.
     C                   KINT(7).NE.5.AND.KINT(7).NE.7) IRET=1
                     IF (KINT(8).LT.0.OR.KINT(8).GT.1800)IRET=1
C
                     IF (IRET.NE.0)
     C                 THEN
C
C                         CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                          KERR = 4
                          CALL ERRSTA(3,1,IFIRST,NUMERR)
                          GO TO 5000
                       END IF
C
C                       MMM ULA ULO
C                       --- --- ---
C
                        CALL NEXTPRT(IPT,IEQ)
C
                        CALL EXTGRP(IPT,3,1,1,0,0,9,IRET)
C
C                       CHECK VALIDITY OF MMM
C
C
                        CALL IC3333(KINT(7),KINT(6),KINT(8),MINDIC,
     C                              KDEC(5),KDEC(6))
C
                        IF(KDEC(5).EQ.MINDIC) RETURN
                        IF(KDEC(6).EQ.MINDIC) RETURN   
C
                        CALL MARDSEN(KDEC(5),KDEC(6),KINT(9),IRET)
                        IF(IRET .NE. 0)
     C                     THEN
C
C                             CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                              KERR = 4
                              CALL ERRSTA(3,1,IFIRST,NUMERR)
                              GO TO 5000
                           END IF
C
C                       hohohohoim ( height of mobile platform)
C                       --------------------------------------
C                         HOHOHOHO - KINT(699)
C                         IM       - KINT(700)
C
                       IF(KDEC(4).EQ.137) THEN
                          CALL NEXTPRT(IPT,IEQ)
                          CALL EXTGRP(IPT,4,1,0,0,0,699,IRET)
                       END IF
C               
                    ELSE
C
C                       THIS IS NOT A TEMP REPORT
C
C
C                       CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                        KERR = 3
                        NOER(3,KERR) = NOER(3,KERR) + 1
                              GO TO 5000
                END IF
             END IF
C
C
C     RETAIN STATION IDENTIFIER IN CHARACTER FORM ( IF ANY EXISTS )
C
      IF ( ID.NE.0 )
     C    THEN
              IF (ID.GT.5) ID = 5
              J = KPT
              K = 12 + ID -1
              DO 800 I=12,K
C
C                  IF LETTER ENCOUNTERED FOR LAND STATION CONVERT
C                  IT TO FIGURE (NOT FOR SHIP'S CALL SIGN)
C
                   IF(KDEC(4) .EQ. 35) CALL LETFIG(KCHAR(J))
                   KINT(I) = KCHAR(J)
                   J = J + 1
  800         CONTINUE
          END IF
C
C
C     CHECK VALUES OF YY GG IW FOR SHIP REPORTS. IF AN ERROR
C     IS FOUND IN YY OR GG THE ERROR IS FATAL AS SHIP REPORTS
C     FREQUENTLY HAVE DIFFERENT TIMES FROM BULLETIN HEADER TIMES.
C
      IF ( KDEC(4).GE.35 )
     1     THEN
               IRET = 0
               IF ((KINT(1) .LT. 1) .OR. ((KINT(1) .GT. 31) .AND.
     2             (KINT(1) .LT. 51)) .OR. (KINT(1) .GT. 81))
     3             THEN
                       IRET = 2
                       KINT(1) = MINDIC
                   END IF
               IF (KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       IRET = 2
                       KINT(2) = MINDIC
                   END IF
C
               IF (IRET.NE.0)
     C             THEN
C
C     		   CHECK IF ALREADY KNOWN TO BE 'NIL'-REPORT
C
                              IF(NIL .EQ. 1) THEN
                                 KDEC(20)=1
                                 RETURN
                              END IF
C
                       KERR = 3
                       CALL ERRSTA(3,1,IFIRST,NUMERR)
                       GO TO 5000
C
                   END IF
           END IF

C     ---------------------------------------------------------------
C*          3. SECTION 2 (STANDARD ISOBARIC SURFACES) .
C              ----------------------------------------
2000  CONTINUE
C
C     'NIL'-REPORTS WILL NOT BE PROSESSED ANY FURTHER
C
      IF(NIL .EQ. 1) RETURN
C
C     GET THE POINTER TO THE FIRST LEVEL
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      LPT = IPT
C
C
      NOWIND = 0
      LEVPRE = -1
      LEVNUM = 0
C
C     99 P0P0P0
C     -- ------
C
      CALL NEXTPRT(IPT,IEQ)
      IF(IPT .GE. IEQ) GO TO 5000
C
C     CHECK VALIDITY OF 99
C
      IF(KCHAR(IPT) .EQ. 57)
     1       THEN
C
                CALL EXTGRP(IPT,2,3,0,0,0,17,IRET)
C
                IF(IRET .NE. 0)
     1             THEN
                      KERR = 5
                      CALL ERRSTA(3,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 17
                      CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                   END IF
C
C               T0T0 TA0 D0D0
C               ---- --- ----
C
                CALL NEXTPRT(IPT,IEQ)
                IF(IPT .GE. IEQ) GO TO 5000
                CALL EXTGRP(IPT,2,1,2,0,0,19,IRET)
C
                IF(IRET .NE. 0)
     1             THEN
                      KERR = 6
                      CALL ERRSTA(3,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = 19
                      CALL NEXSEP2(IPT,IEQ,*5000)
                   END IF
C
C               CHECK IF THIS IS WIND OR THE NEXT PRESSURE GROUP
C
                CALL NEXPRT2(IPT,IEQ,*5000)
                CALL EXTVAL(IPT,2,IVAL)
                IF(IVAL .GT. 36)
     C             THEN
                      NOWIND = NOWIND + 1
                     CALL NEXPRT2(IPT,IEQ,*5000)
                     CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                   END IF
C
                IF(KINT(3) .EQ. MINDIC)
     C             THEN
                      IF(IVAL .EQ. 0)
     C                   THEN
C
C                           CHECK THE NEXT GROUP, IF IT STARTS WITH
C                           00 THE THIS WAS WIND GROUP.
C
                            NPT = IPT
                            CALL NEXSEP2(NPT,IEQ,*5000)
                            CALL NEXPRT2(NPT,IEQ,*5000)
                            CALL EXTVAL(NPT,2,IVAL2)
                            IF(IVAL2 .NE. 0)
     C                         THEN
                                  NOWIND = NOWIND+1
                                  GO TO 2100
                               END IF
                         END IF
                   END IF
C
C               D0D0 F0F0F0
C               ---- ------
C
C
                CALL NEXTPRT(IPT,IEQ)
                IF(IPT .GE. IEQ) GO TO 5000
                CALL EXTGRP(IPT,2,3,0,0,0,22,IRET)
C
                IF(IRET .NE. 0 .OR. (KINT(22) .GT. 36 .AND.
     C             KINT(22) .NE. MINDIC))
     C             THEN
                      KERR = 7
                      CALL ERRSTA(3,1,IFIRST,NUMERR)
                       IF(NUMERR .EQ. 1) IREMPOS = 22
                      CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                   END IF
C
            END IF
C
C
2100  CONTINUE
C
      LEVNUM = LEVNUM + 1
      LEVOLD = LEVPRE
      NUMFIX = 0
C
C     PIPI HIHIHI
C     ---- ------
C
      CALL NEXTPRT(IPT,IEQ)
      IF(IPT .GE. IEQ) GO TO 5000
C
C
      ILEV1=KCHAR(IPT).AND.127
      ILEV2=KCHAR(IPT+1).AND.127
C
      ILEV1=ILEV1-48
      ILEV2=ILEV2-48
C
C     IF THE SECOND CHARACTER IS 'SPACE' IT MOST PROBABLY MEANS THAT
C     PREVIOUS GROUP WAS TOO LONG AND THAT LEVEL HAS TO BE DELETED
C
      IF(ILEV2.EQ.-16.AND.LEVPRE.GE.0)
     C   THEN
C
C           REJECT THE PREVIOUS LEVEL
C
            DO 2110 I = IPOS,IPOS+6
            KINT(I) = MINDIC
2110        CONTINUE
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
C     CHECK IF THESE CHARACTERS ARE NOT FIGURES
C
      IF(ILEV1 .LT. 0 .OR. ILEV1 .GT. 9 .OR.
     C   ILEV2 .LT. 0 .OR. ILEV2 .GT. 9 )
     C      THEN
               ILEVP = -1
               GO TO 2120
            END IF
C
C
C     CHECK IF THIS IS THE BEGINNING OF SECTION
C     3 OR 4 (88---,77---, OR 66---)
C
      ILEV = 10*ILEV1 + ILEV2
C
      IF(ILEV .EQ. 88) GO TO 3000
      IF(ILEV .EQ. 77) GO TO 4000
      IF(ILEV .EQ. 66) GO TO 4000
C
C     CHECK IF THIS IS /////-GROUP (E.G. GROUP OF 'MISSING WIND')
C
      IF((KCHAR(IPT  ) .EQ. 47) .AND. (KCHAR(IPT+1) .EQ. 47) .AND.
     C   (KCHAR(IPT+2) .EQ. 47) .AND. (KCHAR(IPT+3) .EQ. 47) .AND.
     C   (KCHAR(IPT+4) .EQ. 47))
     C      THEN
               CALL NEXSEP2(IPT,IEQ,*5000)
               GO TO 2100
            END IF
C
C     DETERMINE THE LEVEL
C
      CALL DETLEV(1,ILEV,ILEVP)
C
C     ILEVP IS USED AS AN LEVEL-INDICATOR OF THE PARTICULAR
C     LEVEL THIS TIME ROUND.
C
C           ILEVP = 0  FOR 1000MB
C                 = 1  FOR  925MB
C                 = 2  FOR  850MB
C           ---------------------
C                 = 10 FOR   10MB
C                 < 0  IF THIS WASNT A PRESSURE GROUP
C
C     LEVPRE IS USED AS AN INDICATOR OF THE LEVEL REACHED
C     SO FAR BEFORE THIS LEVEL.
C
C        IF LEVELS ARE OUT OF SEQUENCE OR THERE IS SOME OTHER
C        FORMAL CODING ERROR, SO THAT THE NEXT PRESSURE/HEIGHT
C        GROUP WAS NOT FOUND, THE DATA FOR THE PREVIOUS LEVEL
C        HAS TO BE DELETED.
C        IN THIS CASE THE BEGINING OF NEW 'CORRECT SEQUENCE'
C        WILL BE SEARCHED AND IF FOUND THE DECODING CONTINUES
C        FROM THAT POINT.
C
2120  CONTINUE
C
      MORE = 0
C
      IF(ILEVP .LE. LEVPRE .OR. ILEVP .LT. 0)
     1       THEN
                KERR = 8
C
C               TRY TO FIX THE PHASE ERROR
C
                NUMFIX = NUMFIX + 1
                IF(NUMFIX .GT. 3) GO TO 5000
C
C
               CALL FIXPHAS(LEVPRE,NOWIND,MORE,IFIX,LEVFIX,*3000,*4000)
C
               IF(IFIX .GT. 0)
     C            THEN
                     CALL ERRSTA(3,2,IFIRST,NUMERR)
                     IPOS = 24 + LEVFIX*7
                     KINT(IPOS) = IFIX
                     CALL EXTGRP(IPT,3,0,0,0,0,IPOS+1,IRET)
c
c                     fix in case ilevp = -1
c
                      ilevp=levfix
c                      
                     GO TO 2300
                  END IF
C
                 CALL ERRSTA(3,2,IFIRST,NUMERR)
C
                IF(NUMERR .EQ. 1)
     C             THEN
                      IF(LEVPRE .EQ. -1) IREMPOS = 24
                      IF(LEVPRE .NE. -1) IREMPOS = IPOS
                   END IF
C
                IF(MORE .GE. 2) GO TO 2100
C
C              IF NO FIX FOUND REJECT THE PREVIOUS LEVEL
C
               IF(LEVPRE .GE. 0 .AND. IPOS .GT. 24)
     C            THEN
                     DO 2150 J = IPOS , IPOS+6
                     KINT(J) = MINDIC
2150                 CONTINUE
                  END IF
C
                GO TO 5000
             END IF
C
C
C     QUITE COMMON ERROR IS TO USE P1P1=10 INSTEAD OF P1P1=00.
C     THEREFORE IF LEVNUM=1 AND THE TEMPERATURE IS POSITIVE FOR
C     P1P1=10 THIS LEVEL IS TAKEN AS 1000MB.
C
      IF(LEVNUM .EQ. 1)
     C   THEN
            IF(ILEVP .EQ. 9)
     C         THEN
                  JPT = IPT
                  CALL NEXSEP2(JPT,IEQ,*5000)
                  CALL NEXPRT2(JPT,IEQ,*5000)
                  ISIGN = (KCHAR(JPT+2) .AND. 127) - 48
                  ISIGN2 = 2 * ( ISIGN / 2)
                  IF(ISIGN .EQ. ISIGN2)
     C               THEN
C
C                       TEMPERATURE POSITIVE SO THIS IS 1000MB
C
                        ILEVP = 0
                     END IF
               END IF
         END IF
C
      IPOS=24+ILEVP*7
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
                IF(IRET .NE. 0)
     1             THEN
                      KERR = 5
                      CALL ERRSTA(3,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = IPOS
                      CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                   END IF
C
C     IF ILEVP WAS CHANGED TO POINT 1000MB LEVEL INSTEAD OF 100MB
C     CHANGE THE VALUE KINT(IPOS) AS WELL.
C
      IF(LEVNUM .EQ. 1 .AND. ILEVP .EQ. 0 .AND. KINT(IPOS) .EQ. 10)
     C   KINT(IPOS) = 0
C
2300  CONTINUE
C
C     TITI TAI DIDI
C     ---- --- ----
C
      CALL NEXTPRT(IPT,IEQ)
      IF(IPT .GE. IEQ) GO TO 5000
C
C     CHECK IF THE NEXT GROUP IS 88999, 77999 OR 66999
C
      CALL EXTVAL(IPT,5,IVAL)
      IF(IVAL .EQ. 88999 .OR. IVAL .EQ. 77999 .OR. IVAL .EQ. 66999)
     C   GO TO 2100
C
      CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
                IF(IRET .NE. 0)
     1             THEN
                      KERR = 6
                      CALL ERRSTA(3,1,IFIRST,NUMERR)
                      IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
                      DO 2250 I=IPOS,IPOS+6
                      KINT(I) = MINDIC
2250                  CONTINUE
                      CALL NEXSEP2(IPT,IEQ,*5000)
                      GO TO 2100
                  END IF
C
C
C     REJECT IF THE TEMPERATURE IS POSITIVE ABOVE 400 MB
C
      IF(IRET .EQ. 0)
     C   THEN
            IF(KINT(IPOS) .LE. 40 .AND. KINT(IPOS) .NE. 0)
     C         THEN
                  ISIGN = 2*(KINT(IPOS+3)/2)
                  IF(ISIGN .EQ. KINT(IPOS+3))
     C               THEN
                        KERR = 6
                        CALL ERRSTA(3,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS
                           DO 2350 I = IPOS+2,IPOS+4
                           KINT(I) = MINDIC
2350                       CONTINUE
                      END IF
               END IF
         END IF
C
      IF(NOWIND .GE. 2) GO TO 2380
C
C     DIDI FIFIFI
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*5000)
C
C     CHECK IF THE NEXT GROUP IS WIND OR PRESSURE/HEIGHT
C     OF NEXT LEVEL OR BEGINNING OF NEXT SECTION
C
      CALL WINDHEI(ILEVP,NOWIND,IWIND,ITROPO,MAXWIN,IEND)
C
      IF(IEND .EQ. 1) GO TO 5000
C
      IF(ITROPO .EQ. 1)
     1      THEN
C           ----- TROPOPAUSE SECTION FOUND  ----
               GO TO 3000
            END IF
C
      IF(MAXWIN .EQ. 1)
     1      THEN
C           ----- MAX.WIND SECTION FOUND  ----
               GO TO 4000
            END IF
C
      IF(NOWIND .GE. 2)
     C      THEN
               LEVPRE = ILEVP
               GO TO 2100
            END IF
C
      IF(IWIND .EQ. 1)
     1      THEN
               IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
               GO TO 2400
            END IF
C
      IF(IWIND .EQ. 0)
     1      THEN
C           ----- PRESSURE/HEIGHT GROUP FOUND  ----
               IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
               GO TO 2100
            END IF
C
      IF(IWIND .EQ. -1)
     1     THEN
C          -----CORRUPTED WIND GROUP FOUND  ----
              CALL NEXSEP2(IPT,IEQ,*5000)
              KERR = 7
              CALL ERRSTA(3,1,IFIRST,NUMERR)
              IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
              IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
              GO TO 2100
           END IF
C
C
      IF(IWIND .EQ. -2)
     1     THEN
C          ----- '/////' - WIND GROUP FOUND  ----
              CALL NEXSEP2(IPT,IEQ,*5000)
              IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
              GO TO 2100
           END IF
C
      IF(IWIND .EQ. -3)
     1     THEN
C          ----- FORMAL ERROR IN GROUP ----
              KERR=7
              CALL ERRSTA(3,1,IFIRST,NUMERR)
              IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
              DO 2370 I=IPOS,IPOS+6
              KINT(I) = MINDIC
2370          CONTINUE
              CALL NEXSEP2(IPT,IEQ,*5000)
              GO TO 2100
           END IF
C
2380  CONTINUE
C
      IF(KINT(IPOS) .NE. MINDIC) LEVPRE = ILEVP
      IF(NOWIND .GE. 2) GO TO 2100
C
2400  CONTINUE
C
C     EXTRACTING THE WIND GROUP
C
C     DONT EXTRACT IF PRESSURE GROUP WAS MISSING
C
      IF(KINT(IPOS) .EQ. MINDIC)
     C   THEN
            CALL NEXPRT2(IPT,IEQ,*5000)
            CALL NEXSEP2(IPT,IEQ,*5000)
            GO TO 2100
         END IF
C
      CALL EXTGRP(IPT,2,3,0,0,0,IPOS+5,IRET)
      NOWIND=0
C
      IF(IRET .NE. 0)
     C   THEN
            KERR = 7
            CALL ERRSTA(3,1,IFIRST,NUMERR)
            IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
            CALL NEXSEP2(IPT,IEQ,*5000)
         END IF
C
C     GO TO FIND THE NEXT LEVEL
C
      GO TO 2100

C      -----------------------------------------------------------------
C*          4. SECTION 3  (TROPOPAUSE LEVELS).
C              -------------------------------
3000  CONTINUE
C
C     THREE POSSIBLE TROPOPAUSES
C     ----- -------- -----------
C
      IPOS = 94
C
      DO 3500 I=1,3
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      IREMOVE = 0
      IPOS = IPOS + 7
C
3100  CONTINUE
C
C     CHECK IF THIS IS MAX WIND  (I.E. 77---, 66---)
C
      CALL EXTVAL(IPT,2,IVAL)
      IF(IVAL .EQ. 77 .OR. IVAL .EQ. 66) GO TO 4000
C
C
C     CHECK THAT THIS IS TROPOPAUSE  (I.E. 88---)
C
      IF(IVAL .EQ. 88)
     1   THEN
            CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
            IF(IRET .NE. 0)
     C         THEN
                  KERR = 9
                  CALL ERRSTA(3,1,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
                  CALL NEXSEP2(IPT,IEQ,*5000)
                  GO TO 3300
                END IF
C
C
C           CHECK THAT GROUP WAS NOT 88999  ( = "NO TROPOPAUSE")
C
            IF(KINT(IPOS+1) .NE. 999 .AND. KINT(IPOS+1) .NE. MINDIC)
     1         THEN
C
C                 REJECT IF PRESSURE > 900  (MOST PROPABLY THIS IS
C
                  IF(KINT(IPOS+1) .GE. 900)
     C               THEN
                        KERR = 9
                        CALL ERRSTA(3,1,IFIRST,NUMERR)
                        IF(NUMERR .EQ. 1) IREMPOS = IPOS
                        CALL NEXSEP2(IPT,IEQ,*5000)
                        GO TO 3300
                     END IF
C
C                  TTTT TAT DTDT
C                  ---- --- ----
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
C
C                   CHECK IF THE NEXT GROUP IS 88999, 77999 OR 66999
C
                    CALL EXTVAL(IPT,5,IVAL)
                    IF(IVAL .EQ. 88999 .OR. IVAL .EQ. 77999 .OR.
     C                 IVAL .EQ. 66999) GO TO 3500
C
                   CALL EXTGRP(IPT,2,1,2,0,0,IPOS+2,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 10
                         CALL ERRSTA(3,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 3300
                      END IF
C
C                  REJECT IF THE TEMPERATURE IS POSITIVE ABOVE 400 MB
C
                    IF(KINT(IPOS+1) .LE. 400)
     C                THEN
                         ISIGN = 2*(KINT(IPOS+3)/2)
                         IF(ISIGN .EQ. KINT(IPOS+3))
     C                      THEN
                               KERR = 10
                               CALL ERRSTA(3,1,IFIRST,NUMERR)
                               IF(NUMERR .EQ. 1) IREMPOS = IPOS
                  DO 3150 J = IPOS+2 , IPOS+4
                  KINT(J) = MINDIC
3150              CONTINUE
                            END IF
                      END IF
C
C                  DTDT FTFTFT
C                  ---- ------
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
C
C                  CHECK THAT THIS IS NOT 77--- OR 66--- GROUP
C
                   IF((KCHAR(IPT) .EQ. 55 .AND. KCHAR(IPT+1) .EQ. 55)
     1             .OR. (KCHAR(IPT) .EQ. 54 .AND. KCHAR(IPT+1) .EQ. 54))
     2                GO TO 4000
C
C                  CHECK THAT THIS IS NOT THE NEXT TROPOPAUSE
C
                   CALL EXTVAL(IPT,2,IVAL)
                   IF(IVAL .EQ. 88) GO TO 3500
C
                   CALL EXTGRP(IPT,2,3,0,0,0,IPOS+5,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 11
                         CALL ERRSTA(3,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 5
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 3300
                      END IF
C
                   IF(KINT(IPOS+5) .GT. 36 .AND.
     C                KINT(IPOS+5) .NE. MINDIC)
     1                    THEN
                             KERR=9
                             CALL ERRSTA(3,1,IFIRST,NUMERR)
                             CALL NEXSEP2(IPT,IEQ,*5000)
                             GO TO 3300
                          END IF
C
                   CALL NEXTPRT(IPT,IEQ)
                   IF(IPT .GE. IEQ) GO TO 5000
                   GO TO 3500
               ELSE
                   GO TO 3500
               END IF
         ELSE
C
           GO TO 3300
C
         END IF
C
C
3300        CONTINUE
C
C           ERROR IN DATA ---  REMOVE THE PREVIOUS TROPOPAUSE BECAUSE
C                              IT MIGHT HAVE BEEN CORRUPTED
C
                            DO 3400 J = IPOS,IPOS+6
                            KINT(J) = MINDIC
3400                        CONTINUE
                            KERR = 9
                            CALL EXTVAL(IPT,5,IVAL)
                            CALL ERRSTA(3,1,IFIRST,NUMERR)
C
C                           CHECK IF THIS IS INCORRECTLY USED
C                           REGIONAL SECTION, WHICH IS PRACTICE
C                           AT LEAST IN SOME STATIONS IN REGION 4
C
                            IF(IVAL .EQ. 51515 .OR. IVAL .EQ. 52525)
     C                         GO TO 5000
C
                            IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                            CALL NEXSEP2(IPT,IEQ,*5000)
                            CALL NEXPRT2(IPT,IEQ,*5000)
C
                            GO TO 3500
C
3500  CONTINUE
C
C
C     ----------------------------------------------------------------
C*          5. SECTION 4 (MAX WIND LEVELS AND VERTICAL WIND SHEAR).
C              -----------------------------------------------------
4000  CONTINUE
C
C     THREE POSSIBLE MAX WIND LEVELS
C     ----- -------- --- ---- ------
C
      IPOS = 115
C
      DO 4500 I=1,3
C
      CALL NEXPRT2(IPT,IEQ,*5000)
      IREMOVE = 0
      IPOS = IPOS + 7
C
C     CHECK THAT THIS IS MAX WIND (I.E. 77--- OR 66---)
C
4100  CONTINUE
C
      CALL EXTVAL(IPT,2,IVAL)
      IF(IVAL .EQ. 66 .OR. IVAL .EQ. 77)
     2     THEN
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS,IRET)
C
                   IF(IRET .NE. 0)
     C                THEN
                         KERR = 12
                         CALL ERRSTA(3,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 4300
                      END IF
C
C              CHECK THAT GROU IS NOT 77999 (='NO MAX WINDS)
C
               IF(KINT(IPOS+1) .EQ. 999) GO TO 5000
C
C              DMDM FMFMFM
C              ---- ------
C
               CALL NEXTPRT(IPT,IEQ)
               IF(IPT .GE. IEQ) GO TO 5000
               CALL EXTGRP(IPT,2,3,0,0,0,IPOS+2,IRET)
C
               IF(IRET .NE. 0 .OR. (KINT(IPOS+2) .GT. 36 .AND.
     C                              KINT(IPOS+2) .NE. MINDIC))
     C                THEN
                         KERR = 13
                         CALL ERRSTA(3,1,IFIRST,NUMERR)
                         IF(NUMERR .EQ. 1) IREMPOS = IPOS + 2
                         CALL NEXSEP2(IPT,IEQ,*5000)
                         GO TO 4300
                      END IF
C
               CALL NEXTPRT(IPT,IEQ)
               IF(IPT .GE. IEQ) GO TO 5000
C
C              4 VBVBVAVA
C              - --------
C
C              CHECK IF THIS IS WIND SHEAR GROUP  (I.E. 4----)
C
               IF(KCHAR(IPT) .EQ. 52)
     1            THEN
                      CALL EXTGRP(IPT,1,2,2,0,0,IPOS+4,IRET)
C
                      IF(IRET .NE. 0)
     C                   THEN
                           KERR = 14
                           CALL ERRSTA(3,1,IFIRST,NUMERR)
                           IF(NUMERR .EQ. 1) IREMPOS = IPOS + 4
                           CALL NEXSEP2(IPT,IEQ,*5000)
                           GO TO 4300
                         END IF
C
                      CALL NEXTPRT(IPT,IEQ)
                      IF(IPT .GE. IEQ) GO TO 5000
                      GO TO 4500
                  ELSE
C
C                     CHECK IF THIS IS THE BEGINNING
C                     OF NEXT MAX WIND
C
                      IF(((KCHAR(IPT)   .EQ. 54) .AND.
     1                    (KCHAR(IPT+1) .EQ. 54))
     2                  .OR.
     3                   ((KCHAR(IPT)   .NE. 55) .OR.
     4                    (KCHAR(IPT+1) .EQ. 55)))
     5                    GO TO 4500
                      GO TO 4300
                  END IF
          ELSE
C
C              CHECK IF THIS IS AN EXTRA (FOURTH) TROPOPAUSE
C
               IF(IVAL .EQ. 88)
     C            THEN
4200                 CONTINUE
                     CALL NEXSEP2(IPT,IEQ,*5000)
                     CALL NEXPRT2(IPT,IEQ,*5000)
                     CALL EXTVAL(IPT,2,IVAL)
                     IF(IVAL .EQ. 77 .OR. IVAL .EQ. 66) GO TO 4100
                     GO TO 4200
                  END IF
C
             GO TO 4300
C
          END IF
C
C
4300        CONTINUE
C
C           ERROR IN DATA ---  REMOVE THE PREVIOUS MAX WIND BECAUSE
C                              IT MIGHT HAVE BEEN CORRUPTED
C
C
C                           CHECK IF THIS IS INCORRECTLY USED
C                           REGIONAL SECTION, WHICH IS PRACTICE
C                           AT LEAST IN SOME STATIONS IN REGION 4
C
                            CALL EXTVAL(IPT,5,IVAL)
                            IF(IVAL .EQ. 51515 .OR. IVAL .EQ. 52525)
     C                         GO TO 5000
C
                            KERR = 12
                            CALL ERRSTA(3,1,IFIRST,NUMERR)
C
                            IF(NUMERR .EQ. 1) IREMPOS = IPOS
                            DO 4350 J = IPOS,IPOS+6
                            KINT(J) = MINDIC
4350                        CONTINUE
C
                            CALL NEXSEP2(IPT,IEQ,*5000)
                            CALL NEXPRT2(IPT,IEQ,*5000)
C
                            GO TO 4100
C
4500  CONTINUE
C
C
C
C     ERROR IF NOT END OF REPORT
C
5000  CONTINUE
C
C
C     ERROR CHECKING AND HANDLING
C
C     RETURN IF NO ERRORS IN REPORT
C
      IF(KERR .EQ. 0) RETURN
C
C
C     IF FIRST DECODING ATTEMPT, TRY TO CORRECT
C     THE ERROR AND DECODE AGAIN
C
      IF (IFIRST .EQ. 0) THEN
                             IPT=KEEP
                             CALL FIXUS
                             IFIRST=1
                             NUMRERR(3) = NUMRERR(3) + 1
                             GO TO 101
                          ELSE
                             CALL SAVREP(IHEAD,IERR)
C
C                            CLEAR PARITY BIT AFTER SAVING ERROR FILE
C
                             DO 25500 I=KEEP,IGS
                             KCHAR(I) = KCHAR(I) .AND. 127
25500                        CONTINUE
C
C                            ONLY REPORTS WITH ERROR IN DATA/TIME
C                            OR LAT/LONG ARE NOT PROSESSED ANY FURTHER
C
C                            IF THERE ARE MORE THAN 5 NON-FATAL ERRORS
C                            IN REPORT IT IS ONLY PROSESSED UNTIL THE
C                            FIRST ERROR
C
C
                             IF(NUMERR .GT. 5)
     C                          THEN
                                   DO 26000 I = IREMPOS,700
                                   KINT(I) = MINDIC
26000                              CONTINUE
                                END IF
C
C
c                            IF(KERR .GT. 4) KERR=0
                             if(kerr.gt.4) then
                               kerr = 0
c                              ierr = 0
                             end if
c
                          END IF
C
C
C
C
9000  CONTINUE
      RETURN
      END
      
      SUBROUTINE WINDHEI(ILEVP,NOWIND,IWIND,
     1                   ITROPOP,MAXWIND,IEND)
C**** *WINDHEI*
C
C
C     PURPOSE.
C     --------
C
C         CHECK THE NEXT GROUP IF IT IS WIND GROUP
C         OR PRESSURE/HEIGHT GROUP OF NEXT LEVEL.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *WINDHEI(ILEVP,NOWIND,IWIND,
C    1                   ITROPOP,MAXWIND,IEND)*
C
C          INPUT     : ILEVP  - INDICATOR OF THE PRESSURE LEVEL
C                      NOWIND - INDICATES IF THERE IS SUPPOSED
C                               TO BE WIND ON THIS LEVEL
C
C
C          OUTPUT    : NOWIND = 0 IF IT IS WIND GROUP
C                             = NOWIND+1 IF THIS IS NOT WIND GROUP,
C                             = 2 IF THERE CANT BE ANY MORE WINDS
C                      IWIND  = 1 IF WIND GROUP
C                             =-1 IF WIND GROUP BUT UNUSABLE
C                             =-2 IF WIND GROUP = /////
C                             =-3 IF GROUP IS CORRUPTED
C                             = 0 OTHERWISE
C                      ITROPOP= 1 IF BEGINNING OF TROPOPAUSE SECTION
C                             = 0 OTHERWISE
C                      MAXWIND= 1 IF BEGINNING OF MAX.WIND SECTION
C                             = 0 OTHERWISE
C                      IEND   = 1 IF END OF REPORT FOUND
C                             = 0 OTHERWISE
C
C
C     METHOD.
C     -------
C
C         THIS SUBROUTINE IS DESIGNED TO CATCH ALL THE ODDITIES
C         OF REPORTING WINDS IN TEMP PART A & C.
C         THE MAIN PROBLEM IS TO DECIDE IF THE GROUP IS WIND
C         OR PRESSURE/HEIGHT OF THE NEXT LEVEL.
C         THE TEST IS CARRIED OUT IN TWO SEPARATE PARTS
C         DEPENDING IF WIND-LEVEL INDICATOR ID (KINT(3)) IS
C         AVAILABLE OR NOT.
C         BEACUSE THIS ID IS SO FREQUENTLY INCORRECTLY USED WE
C         CANT SOLELY RELY ON IT, BUT WE HAVE TO CHECK THE
C         PRESENT GROUP AND THE NEXT GROUP TO SEE IF EITHER
C         OF THEM STARTS WITH PIPI = THE PRESSURE OF NEXT LEVEL
C         OR IF PIPI = THE PRESSURE OF SOME STANDARD LEVEL
C         HIGHER THAN THE PREVIOUS.
C
C     VARIABLES : IVAL1  = THE VALUE OF TWO FIRST FIGURES IN THIS GROUP
C     ---------   IVAL2  = THE VALUE OF TWO FIRST FIGURES IN NEXT GROUP
C                 IGROUP1= THE VALUE OF THE FIGURES IN THIS GROUP (5FIG)
C                 IGROUP2= THE VALUE OF THE FIGURES IN NEXT GROUP (5FIG)
C
C                 AT FIRST THE FOLLOWING CHECKS ARE MADE
C                 -  IVAL1 = 99 SO WIND WITH VARIABLE DIRECTION
C                 -  IVAL1 = 88 SO BEGINNING OF TROPOPAUSE SECTION
C                 -  IVAL1 = 66 OR 77 SO BEGINNING OF MAX. WIND SECTION
C                 -  IVAL2 = 66 OR 77 OR 88 SO THE NEXT GROUP IS
C                            BEGINNING OF MAX. WIND OR TROPOP. SECTION
C                            SO THIS IS WIND GROUP.
C
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.84
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION LEVSTAN(24)
C
      DATA LEVSTAN/
     1  92,85,70,50,40,30,25,20,15,10, 70,50,30,20,10,9,8,7,6,5,4,3,2,1/
C
C     ---------------------------------------------------------------
C           1. GET THE VALUE OF TWO FIRST FIGURES
C              ----------------------------------
C              IN THE NEXT TWO GROUPS .
C              ------------------------
 100  CONTINUE
C
      IWIND=0
      ITROPOP=0
      IEND=0
      MAXWIND=0
C
C     CHECK IF THIS IS MISSING WIND GROUP '/////'
C
      DO 101 I=IPT,IPT+4
      KAR = KCHAR(I) .AND. 127
      IF(KAR .NE. 47) GO TO 102
101   CONTINUE
C
C     THIS IS '/////' WIND GROUP
C
      IWIND = -2
      RETURN
C
102   CONTINUE
C
C
C*          1.1 GET THE VALUE OF THE BEGINNING OF NEXT THREE GROUPS.
C               ----------------------------------------------------
 110  CONTINUE
C
      CALL EXTVAL(IPT,2,IVAL1)
      CALL EXTVAL(IPT,5,IGROUP1)
C
      IPTX = IPT
      CALL NEXSEP2(IPTX,IEQ,*111)
      CALL NEXPRT2(IPTX,IEQ,*111)
      CALL EXTVAL(IPTX,5,IGROUP2)
      CALL EXTVAL(IPTX,2,IVAL2)
C
      CALL NEXSEP2(IPTX,IEQ,*112)
      CALL NEXPRT2(IPTX,IEQ,*112)
      CALL EXTVAL(IPTX,2,IVAL3)
C
      GO TO 112
C
111   CONTINUE
C
C     THIS IS THE LAST GROUP, SO IT'S WIND
C
      IWIND = 1
      IF(IVAL1 .GT. 36) IWIND = -1
      RETURN
C
112   CONTINUE
C
C
C     RETURN IF PRESENT GROUP IS CORRUPTED
C
      IF(IGROUP1 .EQ. MINDIC)
     C   THEN
            IWIND = -3
            RETURN
         END IF
C
C     CHECK IF 99, SO ITS WIND GROUP
C
      IF(IVAL1 .EQ. 99) THEN
                           IWIND=1
                           NOWIND=0
                           RETURN
                        END IF
C
C     CHECK IF BEGINNING OF SECTION 3 OR 4 (88 OR 77 OR 66)
C
      IF(IVAL1 .EQ. 88)
     1    THEN
             CALL NEXTPRT(IPT,IEQ)
             IF(IPT .GE. IEQ) RETURN
             ITROPOP=1
             NOWIND=2
             RETURN
          END IF
C
      IF(IVAL1 .EQ. 77 .OR. IVAL1 .EQ. 66)
     1    THEN
             CALL NEXTPRT(IPT,IEQ)
             IF(IPT .GE. IEQ) RETURN
             MAXWIND=1
             NOWIND=2
             RETURN
          END IF
C
C     CHECK IF ALREADY KNOWN THAT THERE ARE NO MORE WINDS
C
      IF(NOWIND .GE. 2) RETURN
C
C     SET THE VARIABLES FOR THE TEST OF WIND AGAINST PRESSURE/HEIGHT
C
      LEVBEG = MAX0(1,ILEVP)
      LEVEND = 10
      IF(KDEC(23) .EQ. 3)
     C   THEN
            LEVBEG = MAX0(11,ILEVP+11)
            LEVEND = 24
         END IF
C
      IF(KDEC(23) .EQ. 1)
     C   THEN
            IF(ILEVP .EQ. 0)
     C         THEN
                  INDWIN = 10    ! 11
               ELSE
                  INDWIN = LEVSTAN(ILEVP)/10  !11
               END IF
         END IF
C
      IF(KDEC(23) .EQ. 3)
     C   THEN
            IF(ILEVP .EQ. 0)
     C         THEN
                  INDWIN = 7
               ELSE
                  INDWIN = LEVSTAN(ILEVP+11)/10   ! 11)/11
               END IF
         END IF
C
      ID = KINT(3)
C
      LEVNEX = -1
      LEVNEX2 = -1
C
      IF(KDEC(23) .EQ. 1)
     C   THEN
            IF(ILEVP .LE. 9) LEVNEX  = LEVSTAN(ILEVP+1)
            IF(ILEVP .LE. 8) LEVNEX2 = LEVSTAN(ILEVP+2)
         END IF
C
      IF(KDEC(23) .EQ. 3)
     C   THEN
            IF(ILEVP .LE. 13) LEVNEX  = LEVSTAN(ILEVP+12)
            IF(ILEVP .LE. 12) LEVNEX2 = LEVSTAN(ILEVP+13)
         END IF
C
C     CHECK IF THE NEXT GROUP IS TROPOP OR MAX. WIND
C
      IF(IVAL2 .EQ. 66 .OR. IVAL2 .EQ. 77 .OR. IVAL2 .EQ. 88)
     C   THEN
C
C           IT MIGHT BE, IN WHICH CASE THIS ID WIND.  CHECK
C           IF THIS IS NOT THE NEXT LEVEL OR DD>36
C
            IF(IVAL1 .NE. LEVNEX .AND. IGROUP2 .NE. MINDIC .AND.
     C         IVAL1 .LE. 36)
     C            THEN
                     IWIND = 1
                     RETURN
                  END IF
         END IF
C
C
      IF(ID .EQ. MINDIC) GO TO 300
C
C
C
C     -----------------------------------------------------------------
C*          2.  CHECK WIND AGAINST PRESS/HEIGHT,
C               IF WIND-LEVEL IND. AVAILABLE.
 200  CONTINUE
C
C     ID-INDICATOR IS NOT USEFUL ABOVE 10MB, SO IT HAS TO BE CHANGED.
C
      IF(KDEC(23) .EQ. 3 .AND. LEVNEX .LT. 10 .AND. NOWIND .EQ. 0)
     1   INDWIN=1
C
C
      IF(ID .GT. INDWIN)
     C   THEN
C
C           SUPPOSED TO BE PRESSURE.  CHECK IF IT IS THE
C           NEXT STANDARD LEVEL.
C
            IF(IVAL1 .EQ. LEVNEX)
     C         THEN
C
C                 THIS IS THE PRESSURE
C
                  NOWIND = NOWIND + 1
                  IWIND = 0
                  RETURN
               ELSE
C
C                 CHECK IF THE NEXT GROUP IS THE NEXT STANDARD LEVEL
C                 OR TROPOPAUSE OR WIND SECTION.
C
                  IF(IVAL2 .EQ. LEVNEX .OR. IVAL2 .EQ. 88 .OR.
     C               IVAL2 .EQ. 77 .OR. IVAL2 .EQ. 66)
     C               THEN
C
C                       THE NEXT GROUP IS PRESSURE, SO THIS IS WIND
C
                        IF(IVAL1 .GT. 36)
     C                     THEN
C
C                             CORRUPTED WIND
C
                              IWIND = -1
                              RETURN
                           ELSE
                              IWIND = 1
                              RETURN
                           END IF
                     ELSE
C
C                       CHECK IF THIS IS ONE OF THE STANDARD LEVELS
C
                        DO 201 I = LEVBEG , LEVEND
                        IF(IVAL1 .EQ. LEVSTAN(I))
     C                     THEN
C
C                             THIS IS PRESSURE
C
                              IWIND = 0
                              NOWIND = NOWIND + 1
                           END IF
201                     CONTINUE
C
C                       CHECK IF THE NEXT IS ONE OF THE STANDARD LEVELS
C
                        DO 202 I = LEVBEG , LEVEND
                        IF(IVAL2 .EQ. LEVSTAN(I))
     C                     THEN
C
C                             THIS IS WIND
C
                              IF(IVAL1 .GT. 36)
     C                           THEN
                                    IWIND = -1
                                    RETURN
                                 ELSE
                                    IWIND = 1
                                    RETURN
                                 END IF
                           END IF
 202                    CONTINUE
C
C                       CHECK IF THE NEXT GROUP IS TROPOPAUSE
C                       OR MAX. WIND
C
                        IF(IVAL2 .EQ. 66 .OR. IVAL2 .EQ. 77 .OR.
     C                     IVAL2 .EQ. 88)
     C                        THEN
                                 IF(IVAL1 .LE. 36)
     C                              THEN
                                       IWIND = 1
                                       RETURN
                                    ELSE
                                       IWIND = -1
                                       RETURN
                                    END IF
                              END IF
C
C
                        IWIND = 0
                        NOWIND = NOWIND + 1
                        RETURN
                  END IF
             END IF
C
C
         ELSE
C
C           THIS IS SUPPOSED TO BE WIND
C
C           CHECK IF DIRECTION > 36
C
            IF(IVAL1 .GT. 36)
     C         THEN
C
C                 CHECK IF THE NEXT IS THE NEXT STANDARD LEVEL
C
                  IF(IVAL2 .EQ. LEVNEX)
     C               THEN
C
C                       NEXT LEVEL IS PRESSURE, SO THIS IS CORRUPT WIND
C
                        IWIND = -1
                        RETURN
                     ELSE
C
C                   CHECK IF THE NEXT GROUP IS TROPOPAUSE OR MAX. WIND
C
                    IF(IVAL2 .EQ. 66 .OR. IVAL2 .EQ. 77 .OR.
     C                 IVAL2 .EQ. 88)
     C                    THEN
                             IWIND = -1
                             RETURN
                       END IF
C
C                       CHECK IF THIS IS THE NEXT STANDARD LEVEL
C
                        IF(IVAL1 .EQ. LEVNEX)
     C                     THEN
                              IWIND = 0
                              NOWIND = NOWIND + 1
                              RETURN
                           ELSE
C
C                             CHECK IF THE NEXT GEOUP IS ONE OF
C                             THE STANDARD LEVELS.
C
                              DO 203 I = LEVBEG,LEVEND
                              IF(IVAL2 .EQ. LEVSTAN(I))
     C                           THEN
C
C                                   CORRUPTED WIND
C
                                    IWIND = -1
                                    RETURN
                                 END IF
 203                          CONTINUE
C
C                             CHECK IF THIS GEOUP IS ONE OF
C                             THE STANDARD LEVELS.
C
                              DO 204 I = LEVBEG,LEVEND
                              IF(IVAL1 .EQ. LEVSTAN(I))
     C                           THEN
C
C                                   PRESSURE/HEIGHT
C
                                    IWIND = 0
                                    NOWIND = NOWIND + 1
                                    RETURN
                                 END IF
 204                          CONTINUE
C
C                             THIS HAS TO BE CORRUPTED WIND ALTHOUGH
C                             THE NEXT IS NOT ANY STANDARD LEVEL.
C
                              IWIND = -1
                              RETURN
                           END IF
                     END IF
C
               ELSE
C
C              DIRECTION < 36, STILL CHECK FOR POSSIBILITY
C              OF BEING PRESSURE.
C
C                 CHECK IF THE NEXT IS THE NEXT STANDARD LEVEL
C
                  IF(IVAL2 .EQ. LEVNEX)
     C               THEN
                        IWIND = 1
                        RETURN
                     ELSE
C
C                       CHECK IF THE NEXT GROUP IS TROPOPAUSE
C                       OR MAX. WIND
C
                        IF(IVAL2 .EQ. 66 .OR. IVAL2 .EQ. 77 .OR.
     C                     IVAL2 .EQ. 88)
     C                        THEN
                                 IWIND = 1
                                 RETURN
                              END IF
C
C
C                       CHECK IF THE NEXT GROUP IS ONE OF
C                       THE STANDARD LEVELS.
C
                        DO 205 I = LEVBEG,LEVEND
                        IF(IVAL2 .EQ. LEVSTAN(I))
     C                     THEN
C
C                             THIS IS WIND
C
                              IWIND = 1
C
C                             CHECK IF THE NEXT GROUP IS TROPOPAUSE
C                             OR MAX. WIND
C
                              IF(IVAL2 .EQ. 88 .OR. IVAL2 .EQ. 77 .OR.
     C                           IVAL2 .EQ. 66)
     C                              THEN
C
C                                      THIS IS WIND
C
                                       IWIND = 1
                                       RETURN
                                    END IF
C
C
                              RETURN
                           END IF
 205                    CONTINUE
C
C                       CHECK IF THIS IS THE NEXT STANDARD LEVEL
C
                        IF(IVAL1 .EQ. LEVNEX)
     C                     THEN
                              IWIND = 0
                              NOWIND = NOWIND + 1
                              RETURN
                           ELSE
C
C                             CHECK IF THIS GROUP IS ONE OF
C                             THE STANDARD LEVELS.
C
                              DO 206 I = LEVBEG,LEVEND
                              IF(IVAL1 .EQ. LEVSTAN(I))
     C                           THEN
C
C                                   THIS IS PRESSURE
C
                                    IWIND = 0
                                    NOWIND = NOWIND + 1
                                    RETURN
                                 END IF
 206                          CONTINUE
C
C                             THIS HAS TO BE WIND ALTHOUGH THE
C                             NEXT IS NOT ANY STANDARD LEVEL.
C
                              IWIND = 1
                              RETURN
                        END IF
                  END IF
            END IF
       END IF

C     ---------------------------------------------------------------
C*          3. THIS PART IS USED IF WIND-LEVEL
C              INDICATOR IS NOT AVAILABLE.
 300  CONTINUE
C
C     CHECK THE FIRST GROUP
C
      IF(IVAL1 .EQ. LEVNEX)
     C   THEN
C
C           POSSIBLY  PRESSURE
C
            IF(IVAL1 .GT. 36)
     C         THEN
C
C                 PRESSURE
C
                  IWIND = 0
                  NOWIND = NOWIND + 1
                  RETURN
C
               ELSE
C
C                 CHECK IF THE NEXT GROUP IS THE NEXT STANDARD LEVEL
C
                  IF(IVAL2 .EQ. LEVNEX)
     C               THEN
C
C                       CHECK THE THIRD GROUP
C
                        IF(IVAL3 .EQ. LEVNEX2)
     C                     THEN
C                             THIRD GROUP IS PRESSURE SO IS ALSO FIRST
C
                              IWIND = 0
                              NOWIND = NOWIND + 1
                              RETURN
                           END IF
C===                          IWIND = 1
C===                          RETURN
C===                       END IF
                     ELSE
C
C                       SECOND GROUP IS NOT THE NEXT LEVEL SO FIRST IS
C
                        IWIND = 0
                        NOWIND = NOWIND + 1
                        RETURN
                    END IF
              END IF
        ELSE
C
C          FIRST GROUP IS NOT THE NEXT LEVEL, CHECK IF THE SECOND IS
C
           IF(IVAL2 .EQ. LEVNEX)
     C        THEN
C
C                THE SECOND IS PRESSURE SO THE FIRST IS WIND
C
                 IF(IVAL1 .GT. 36)
     C              THEN
                       IWIND = 1
                       RETURN
                    ELSE
                       IWIND = 1
                       RETURN
                    END IF
              ELSE
C
C                NEITHER FIRST OR SECOND IS THE NEXT LEVEL, SO CHECK
C                IF THEY ARE ANY OF THE NEXT LEVELS.
C
                 DO 301 I = LEVBEG,LEVEND
C
                 IF(IVAL1 .EQ. LEVSTAN(I))
     C              THEN
C
C                      POSSIBLY PRESSURE
C
                       IF(IVAL1 .GT. 36)
     C                    THEN
C
C                            PRESSURE
C
                             IWIND = 0
                             NOWIND = NOWIND + 1
                             RETURN
C
                          ELSE
C
                             IF(IVAL2 .EQ. LEVSTAN(I))
     C                          THEN
C
C                                  POSSIBLY CORRUPTED WIND,
C                                  CHECK NEXT GROUP
C
                                    IF(IVAL3 .EQ. LEVSTAN(I) .OR.
     C                                 IVAL3 .EQ. 88 .OR. IVAL3 .EQ. 77
     C                                 .OR. IVAL3 .EQ. 66)
     C                                THEN
C
C                                        THIRD IS PRESSURE SO IS FIRST
C
                                         IWIND = 0
                                         NOWIND = NOWIND + 1
                                         RETURN
C
                                      ELSE
C
                                         IWIND = 1
                                         RETURN
                                      END IF
                                ELSE
C
C                                  HAS TO BE PRESSURE
C
                                   IWIND = 0
                                   NOWIND = NOWIND + 1
                                   RETURN
                                END IF
                          END IF
                    END IF
 301             CONTINUE
C
              END IF
         END IF
C
C
      IF(IVAL2 .EQ. 88 .OR. IVAL2 .EQ. 77 .OR. IVAL2 .EQ. 66)
     C   THEN
            IWIND = 1
            IF(IVAL1 .GT. 36) IWIND = -1
            RETURN
         END IF
C
C
C     NO MATCH FOUND, SO THIS MUST ME WIND OR CORRUPT WIND
C
      IWIND = 1
      IF(IVAL1 .GT. 36) IWIND = -1
      RETURN
C
      END
      
      SUBROUTINE PRTEMP(NUMBER)
C**** *PRTEMP*
C
C
C     PURPOSE.
C     --------
C
C         PRINTS TEMP BULLETIN AND IT'S INTERMEDIATE
C         FORMAT ('KINT') AND DECODED FORMAT ('KDEC')
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTEMP(NUMBER)*
C
C          INPUT     : NUMBER - THE NUMBER OF THE REPORT
C                      KINT   - THE BULLETIN IN INTERMEDIATE FORMAT
C                      KDEC   - THE BULLETIN IN DECODED FORMAT
C                      KDEC(23) = 1 FOR PART A
C                               = 2 FOR PART B
C                               = 3 FOR PART C
C                               = 4 FOR PART D
C
C
C     AUTHOR.
C     -------
C
C     A.HOLOPAINEN  SEP.83
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION NERR(30)
      INTEGER LEN(4)
C
      DATA LEN / 200, 600, 200, 600/
C
C
C     ------------------------------------------------------------------
C*          1.  PRINT TEMP REPORT.
C                -----------------
 100  CONTINUE
C
      DO 101 I=1,30
      NERR(I)=0
 101  CONTINUE
C
C
            KK = KDEC(20)
C
              DO 102 I=30,1,-1
               K = KK - (2**(I-1)) * (KK/(2**(I-1)))
               IF(K .GE. KK) GO TO 102
               KK = K
               NERR(I) = 1
               IF(KK .EQ. 0) GO TO 103
 102           CONTINUE
C
 103        CONTINUE
C
            WRITE(*,10000)
            WRITE(*,20000)
            IF(KDEC(23) .EQ. 1) WRITE(*,30000) NUMBER
            IF(KDEC(23) .EQ. 2) WRITE(*,40000) NUMBER
            IF(KDEC(23) .EQ. 3) WRITE(*,50000) NUMBER
            IF(KDEC(23) .EQ. 4) WRITE(*,60000) NUMBER
            WRITE(*,70000)
C
              DO 104 I=1,30
               IF(NERR(I) .EQ. 1) WRITE(*,80000) I
 104           CONTINUE
C
            WRITE(*,20000)
C
10000       FORMAT(2X,///)
20000       FORMAT(2X,'=======================')
30000       FORMAT(2X,'=  PART A NUMBER',I4,'  =')
40000       FORMAT(2X,'=  PART B NUMBER',I4,'  =')
50000       FORMAT(2X,'=  PART C NUMBER',I4,'  =')
60000       FORMAT(2X,'=  PART D NUMBER',I4,'  =')
70000       FORMAT(2X,'=                     =')
80000       FORMAT(2X,'=  ERROR',I3,'           =')
C
            CALL PRTBULL(IMI,IEQ)
            CALL PRTKINT(KINT,1,LEN(KDEC(23)),MINDIC)
            CALL PRTKDEC(KDEC,1,KDEC(24),MINDIC)
C
      WRITE(*,90000)
90000 FORMAT(2X,116('='))
C
      RETURN
      END
      
      SUBROUTINE MARDSEN(LAT,LONG,M,IERROR)
C**** *MARDSEN*
C
C
C     PURPOSE.
C     --------
C
C         CHECK THE LAT&LONG AGAINST MARDSEN SQUARE
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *MARDSEN(LAT,LONG,M,IERROR)*
C
C          INPUT     : LATITUDE  IN HUNDREDTH'S OF DEGREE
C                      LONGITUDE IN HUNDREDTH'S OF DEGREE
C              M     - MARDSEN SQUARE VALUE GIVEN IN REPORT
C
C          OUTPUT   : IERROR  - ERROR INDICATOR
C
C
C     AUTHOR.
C     -------
C
C     A. HOLOPAINEN  JUNE -84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C     ------------------------------------------------------------------
C
C*          1.   CHECK POSITION.
C                ---------------
 100  CONTINUE
C
C
      IERROR = 0
      LOLO = LONG
C
C     DON'T CHECK IF POSITION ON THE LINE BETWEEN TWO (OR FOUR) SQUARES
C
      LAA = 1000*(LAT/1000)
      LOO = 1000*(LONG/1000)
C
      IF(LAA .EQ. LAT) RETURN
      IF(LOO .EQ. LONG) RETURN
C
      LAT = LAT /10
      LONG= LONG/10
C
C
      IF(LAT .GE. 0)
     C   THEN
            LO = IABS(LONG/100)+1
            IF(LOLO .GE. 0) LO = 37 - LO
C
            IF( LAT .LT. 800 )
     C         THEN
                  MMM = (LAT/100)*36 + LO
               ELSE
                  MMM = 900 + LO
               END IF
         END IF
C
C
      IF(LAT .LT. 0)
     C   THEN
            LO = IABS( LONG/100 )
            IF(LOLO .GE. 0) LO = 35 - LO
            MMM = 300 + IABS( LAT/100 )*36 +LO
         END IF
C
      IF(MMM .NE. M) IERROR = 1
C
      RETURN
C
      END
      
      SUBROUTINE IC3931(ITA,ITT,MINDIC,ITEMP)
C**** *IC3931*
C
C
C     PURPOSE.
C     --------
C
C         DECODE TEMPERARURE IN TENTHS OF DEGREE
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC3931(ITA,ITT,MINDIC,ITEMP)*
C
C          INPUT    :  ITA     - APPROXIMATE TENTHS VALUE AND SIGN BIT
C                   :  ITT     - TENS AND UNIT DIGITS OF TEMPERATURE
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  ITEMP   - DECODED TEMPERATURE
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.  CHECK MISSING VALUES.
C                --------------------
 100  CONTINUE
C
      IF(ITA .EQ. MINDIC .OR. ITT .EQ. MINDIC) RETURN
C
C     CHECK THE RANGE OF ITA
C
      IF(ITA .LT. 0 .OR. ITA .GT. 9) RETURN
C
C     POSITIVE TEMPERATURE
C
      IVA=2*(ITA/2)
      IF(IVA .EQ. ITA) THEN
                    ITEMP = 10 * ITT + ITA
                          RETURN
                       END IF
C
C     NEGATIVE TEMPERATURE
C
      ITEMP = -10 * ITT - ITA
      RETURN
      END
      
      SUBROUTINE IC3333(IQUADR,LAT,LONG,MINDIC,LAT2,LONG2)
C**** *IC3333*
C 
C    NAME     :  IC3333
C
C    FUNCTION :  DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C                99LALALA QCL0L0L0L0
C
C    INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C             :  LAT      LATITUDE IN TENTHS OF DEGREE
C             :  LONG     LONGITUDE IN TENTHS OF DEGREE
C             :  MINDIC   MISSING DATA VALUE
C
C
C    OUTPUT   :  LAT2   LATITUDE IN HUNDREDTHS OF DEGREE
C                       SOUTHERN LATITUDE NEGATIVE
C             :  LONG2: LONGITUDE IN HUNDREDTHS OF DEGREE
C                       WESTERN LONGITUDE NEGATIVE
C
C                LAT2 AND LONG2 ARE SET TO MISSING DATA VALUE IF
C                ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C
C
C
C
      DIMENSION LATSIGN(4),LONSIGN(4)
C
      DATA LATSIGN/ 1,-1,-1, 1/
      DATA LONSIGN/ 1, 1,-1,-1/
C
C*    SET LAT2 AND LONG2 TO MISSING DATA VALUE
C
      LAT2=MINDIC
      LONG2=MINDIC
C
C
C     THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C     LAT. AND LONG. ARE NEGATIVE OR POSITIVE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF(IQUADR .NE. 1 .AND. IQUADR .NE. 3 .AND. IQUADR .NE.
     1     5 .AND. IQUADR .NE. 7) RETURN
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(LAT .LT. 0 .OR. LAT .GT. 900) RETURN
C
      IF(LONG .LT. 0 .OR. LONG .GT. 1800) RETURN
C
C
      IQ=(IQUADR+1)/2
C
      LAT2=10*LAT*LATSIGN(IQ)
      LONG2=10*LONG*LONSIGN(IQ)
C
      RETURN

      END
      
      SUBROUTINE IC1600(INHEI,LOWEST,MINDIC,OUTHEI)
C**** *IC1600*
C
C    NAME     :  IC1600
C
C    FUNCTION :  DECODE THE HEIGHT OF LOWEST CLOUDS
C
C    INPUT    :  INHEI   - CODE FIGURE FOR THE HEIGHT
C                LOWEST  - INDICATOR FOR LOWEST CLOUD
C                          0 = LOW CLOUD
C                          1 = MEDIUM CLOUD
C                          2 = HIGH CLOUD
C                MINDIC  - MISSING DATA VALUE
C
C    OUTPUT   :  OUTHEI  - DECODED HEIGHT OF LOWEST CLOUDS IN METRES
C
C             OUTHEI SET TO MISSING VALUE
C             IF ANY ERRORS FOUND IN INHEI
C
C
C
      INTEGER OUTHEI
C
      DIMENSION IHEIGHT(12)
C
      DATA IHEIGHT/25,75,150,250,450,800,1250,1750,2250,2600,3500,8000/
C
C*     SET MISSING VALUE
C
      OUTHEI=MINDIC
C
C*     TEST THE VALIDITY OF THE CODE FIGURE
C
      IF(INHEI .EQ. MINDIC .OR. LOWEST .EQ. MINDIC) RETURN
C
      IF(INHEI .LT. 0 .OR. INHEI .GT. 9) RETURN
C
C
C     FOR N = 9 DEFAULT HEIGHTS ARE ALLOCATED DEPENDING ON
C     WHETHER LOWEST CLOUD IS LOW, MEDIUM OR HIGH.
C
      IF (INHEI.NE.9 ) LOWEST = 0
C
      IND=INHEI + 1 + LOWEST
      OUTHEI=IHEIGHT(IND)
      RETURN
      END
      
      SUBROUTINE IC0777(IDD,ITEMP,MINDIC,IDEWPT)
C**** *IC0777*
C
C    NAME     :  IC0777
C
C    FUNCTION :  DECODE DEW-POINT TEMPERATURE IN TENS OF DEGREE
C
C    INPUT    :  IDD     - DEW-POINT EPRESSION
C             :  ITEMP   - TEMPERATURE
C             :  MINDIC  - MISSING DATA VALUE
C
C    OUTPUT   :  IDEWPT  - DECODED DEW-POINT TEMPERATURE
C
C             IDEWPT IS SET TO MISSING VALUE IF
C             ANY ERRORS FOUND IN IDD
C
C   A.HOLOPAINEN  JAN.83
C

C*     CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC) RETURN
C
      IF(ITEMP .EQ. MINDIC) RETURN
C
C     CHECK THE RANGE OF IDD
C
      IF(IDD .LT. 0 .OR. IDD .GT. 99) RETURN
C
      IF(IDD .GT. 51 .AND. IDD .LE. 55) RETURN
C
C
      IDEW=IDD
      IF(IDD .GE. 56) IDEW=10 * (IDD - 50)
C
      IDEWPT=ITEMP - IDEW
C
      RETURN
      END
      
      SUBROUTINE STATION(IERR)
C**** *STATION*
C
C
C     PURPOSE.
C     --------
C         READ IN STATION LIST AND MAKE LIST OF IMPORTANT STATIONS.
C         ( WMO VOLUMEN A - LIST OF OBSERVING STATIONS)
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *STATION(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   READ IN STATION LIST.
C                ---------------------
 100  CONTINUE
C
      OPEN(UNIT=4,IOSTAT=IOS,ERR=300,
     1            FILE='station_list.dat',
     1            READONLY,
     1            FORM='UNFORMATTED',
     1            STATUS='OLD')
C
C
      READ(4) iparams,ipoints
C
c
      CLOSE(4)
C
C*           2.  FIND IMPORTANT STATIONS.
C                ------------------------
 200  CONTINUE
C
      CALL IMPSTAT
C
      RETURN
C
 300  CONTINUE
C
      WRITE(*,9901) IOS
 9901 FORMAT(1H ,' ERROR DURING OPENING  STATION FILE , ERROR=',I5)
C
C
      RETURN
      END
      
      SUBROUTINE IMPSTAT
C**** *IMPSTAT*
C
C
C     PURPOSE.
C     --------
C
C         DEFINES FROM WMO MASTER FILE THE SATION NUMBERS
C         FOR IMPORTANT STATIONS (ECMWF INTERNAL DEFINOTIONS)
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C             INPUT     : IPARAMS   STATION INFORMATION IN PACKED FORM
C                         IPOINTS   NUMBER OF STATION / WMO BLOCK
C
C             OUTPUT    : IMPSTA    THE NUMBERS OF IMPORTATNT SATIONS
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'parameter.h'
      include 'comwork.h'
      INCLUDE 'combuff.h'

C     ------------------------------------------------------------------
C*          1.   FIND IMPORTANT STATIONS.
C                ------------------------
C
      J = 0
      K = 1
C
            DO 300 I = 1,30000,3
C
            IF(IPARAMS(I) .EQ. MINDIC) GO TO 400
            IF(I .LT. IPOINTS(K+1)) GO TO 200
C
100         K = K + 1
            IF(K .GE. 99) GO TO 400
            IF(IPOINTS(K) .EQ. IPOINTS(K+1)) GO TO 100
C
200         CONTINUE
c
            CALL GBYTE(IPARAMS(I+2),ITEMP,28,1)
            CALL GBYTE(IPARAMS(I+2),IBIT ,25,1)
C
           IF(ITEMP .EQ. 1 .AND. IBIT .EQ. 1)
     C         THEN
                  CALL GBYTE(IPARAMS(I),III,0,10)
                  ISTA= 1000*K+ III
                  IF(J .NE. 0)
     C               THEN
                        DO 250 N=1,J
                        IF(ISTA .EQ. IMPSTA(N)) GO TO 300
250                     CONTINUE
                     END IF
                  J = J + 1
                  if(j.gt.2000) then
                     print*,'impsta dimension too small'
                     go to 400
                  end if
                  IMPSTA(J) = ISTA
               END IF
C
300        CONTINUE
C
C
400   CONTINUE
C
500   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE LOCSTAT ( IWIND,IRC )
C**** *LOCSTAT*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACT PARTICULARS OF WMO OBSERVING STATIONS AND
C         PUT IN DECODED REPORT HEADER.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LOCSTAT(IWIND,IRC)*
C
C          INPUT    : ARGUMENTS NOT USED ON INPUT .
C
C                     KINT(4) - WMO STATION NUMBER IN INTEGER.
C                     KDEC(4) - INTEGER DENOTING OBSERVATION TYPE.
C
C          OUTPUT   : KDEC(5) - LATITUDE IN HUNDREDTHS OF DEGREES ,
C                               NORTH + , SOUTH - .
C                     KDEC(6) - LONGITUDE IN HUNDREDTHS OF DEGREES ,
C                               EAST + , WEST - .
C                     KDEC(8) - STATION PRESSURE ELEVATION (H/P) OR IF
C                               NONE EXISTS STATION GROUND ELEVATION (H/A).
C                               IF NEITHER EXIST MINDIC IS RETURNED . VALUE
C                               IS INTEGER IN METRES.
C
C                     KDEC(15) - IMPORTANT STATION OR GOOD QUALITY STATION
C                                FLAG BITS SET IN THIS WORD.
C
C                     KDEC(16) - WMO COUNTRY NUMBER , EXCLUDING FIRST 2
C                                DIGITS ( REGION NUMBER ) . INTEGER.
C                     KDEC(17) - WMO REGION NUMBER , INTEGER.
C
C                     KDEC(23) - PRESSURE LEVEL INDICATOR , INTEGER.
C                            0 = SEA LEVEL
C                            1 = STATION LEVEL
C                            2 = 850 HPA
C                            3 = 700 HPA
C                            4 = 500 HPA
C                            5 = 1000 GPM
C                            6 = 2000 GPM
C                            7 = 3000 GPM
C                            8 = 4000 GPM
C                            9 = 900 HPA
C
C                     IRC - INTEGER RETURN CODE
C                            0 = NO ERROR
C                            1 = STATION NUMBER NOT IN DIRECTORY
C                            2 = INVALID STATION NUMBER
C                            3 = INVALID OBSERVATION TYPE
C                            4 = STATION NUMBER IN THE LIST BUT
C                                 NOT FOR THAT OBSERVATION TYPE 
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KBPT,KSI)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC
C
C     MODIFICATIONS.
C     --------------
C
c	none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   LOCATE STATION.                   .
C                ---------------
 100  CONTINUE
C
C     CLEAR ERROR RETURN INDICATOR
C
      IRC = 0
C
C     INITIALIZE TYPE OF STATION
C
      ITYPE = 0
C
C     'ITYPE' IS SET TO 4 FOR SYNOP , 2 FOR PILOT AND 1 FOR TEMP.
C
      IF ( KDEC(4).EQ.11.OR.KDEC(4).EQ.14 ) ITYPE = 4
      IF ( KDEC(4).EQ.32 ) ITYPE = 2
      IF ( KDEC(4).EQ.35 ) ITYPE = 1
C
      IF ( ITYPE.EQ.0 ) THEN
                            IRC = 3
                            RETURN
                        END IF
C
C     CHECK VALIDITY OF STATION NUMBER
C

      IF ( KINT(4).LE.1000.OR.KINT(4).GT.99999 )
     C                       THEN
                                 IRC = 2
                                 RETURN
                             END IF
C
C
C     LOCATE STARTING POINT IN ARRAY 'IPARAMS' OF THE WMO BLOCK
C     OF THE STATION.
C
C     EXTRACT WMO BLOCK NUMBER
C
      II = KINT(4) / 1000
C
C     WORD 'II' OF 'IPOINTS' SHOWS WHERE THE ENTRIES FOR BLOCK 'II'
C     START IN 'IPARAMS'.
C
      IND1 = IPOINTS(II)
      IND2 = IPOINTS(II+1)-3
C
C     STARTING AT THIS WORD A SEQUENTIAL SEARCH IS MADE FOR AN ENTRY
C     FOR THE REQUIRED STATION NUMBER ( III ) >
C
      III = KINT(4) - ( II * 1000 )
C
C     FOR ONE STATION ENTRY 3 WORDS ARE USED
C
      DO 101 I=IND1,IND2,3
         CALL GBYTE(IPARAMS(I),ISTN,0,10)
         IF(ISTN.EQ.III) GO TO 200
  101 CONTINUE
C
C     STATION NUMBER NOT FOUND
C
      IRC = 1
      RETURN
C
C
C     -----------------------------------------------------------------
C*             2.  EXTRACT REQUIRED PARAMETERS FROM 1st WORD ENTRY.
C                  -----------------------------------------------
 200  CONTINUE
C
C     PRESSURE LEVEL CODE FIGURE
C
      IF(ITYPE .EQ. 4)
     C   CALL GBYTE(IPARAMS(I),KDEC(23),16,4)
C
C
C     WIND SPEED UNIT INDICATOR
C
      CALL GBYTE(IPARAMS(I),IWIND,20,1)
C
C
C     STATION ELEVATION
C
      CALL GBYTE(IPARAMS(I),KDEC(8),24,14)
      IF ( KDEC(8).GT.9999 ) KDEC(8) = KDEC(8)-16383
      IF ( KDEC(8).EQ.9999 ) KDEC(8) = MINDIC
C
C     LONGITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(6),8,16)
      IF ( KDEC(6).EQ.65535 ) KDEC(6) = MINDIC
      IF ( KDEC(6).NE.MINDIC.AND.KDEC(6).GT.18000)
     C      KDEC(6) = KDEC(6) - 36000
C
C
C     LATITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(5),24,14)
      IF ( KDEC(5).EQ.16383 ) KDEC(5) = MINDIC
      CALL GBYTE(IPARAMS(I+2),ISGN,6,1)
      IF(ISGN.EQ.1.AND.KDEC(5).NE.MINDIC)
     C                KDEC(5) = - KDEC(5)
C
C
C     WMO REGION NUMBER
C
      CALL GBYTE(IPARAMS(I+2),KDEC(17),8,3)
      IF ( KDEC(17).EQ.0 ) KDEC(17) = 8
C
C
C     WMO COUNTRY NUMBER ( LAST 3 DIGITS )
C
      CALL GBYTE(IPARAMS(I+2),KDEC(16),11,10)
C
C
C     IMPORTANT STATION AND GOOD QUALITY FLAGS.
C
      CALL GBYTE(IPARAMS(I+2),ISGQ,24,2)
      KDEC(15) = KDEC(15).OR.ISGQ
C
C
C     CHECK THAT PARAMETERS ARE VALID FOR OBSERVATION TYPE REQUESTED.
C     SOME STATIONS HAVE MORE THAN 1 ENTRY , DEPENDING ON TYPE OF
C     OBSERVATION.
C
      IF(ITYPE.EQ.1) ISKIP=26
      IF(ITYPE.EQ.2) ISKIP=27
      IF(ITYPE.EQ.4) ISKIP=28
C
      CALL GBYTE(IPARAMS(I+2),ITP,ISKIP,1)
      IF (  ITP.NE.0 ) RETURN
C
C     PARAMETERS NOT CORRECT FOR CODE TYPE , SO USE NEXT ENTRY
C     IF IT EXIST
C
      I = I + 3
C
      CALL GBYTE(IPARAMS(I),ISTN,0,10)
      IF(ISTN.EQ.III) GO TO 200
C
C     RETAIN ALREADY EXTRACTED PARAMETERS
C     THAT MEAN THAT STATION TYPE DOES NOT CORRESPOND TO THE MESSAGE
C     RECEIVED. 
C     
      IRC=4
C
      RETURN
      END
      
      SUBROUTINE EXTVAL ( I,N,IVAL)
C
C**** *EXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN IVAL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTVAL(I,N,IVAL)*
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTE
C
C         OUTPUT    : IVAL - INTEGER VALUE
C
c
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES FROM KCHAR ARRAY.
C                -----------------------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
      DO 101 J=IA,IB
C
C
C     STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE
C
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C          CHECK FOR SPACE CHARACTER .
C
           IF ( KAR.EQ.32 ) THEN
                                      IVAL = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     IVAL = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR.LT.48.OR.KAR.GT.57 )
     C                      THEN
                                  DO 102 JA=1,11
                                       IF ( KAR.EQ.ILET(JA))
     C                                       KAR = IFIG(JA)
  102                             CONTINUE
                           END IF
C
           IF ( KAR.GE.48.AND.KAR.LE.57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      IVAL = MINDIC
                                      RETURN
                                   END IF

      KCHAR(J)=KTEMP
C
  101 CONTINUE
C
      IVAL = IAC / 10

      RETURN
      END
      
      SUBROUTINE PRESEP ( I,J,*)
C
C**** *PRESEP*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRESEP(I,J,*)
C
C                 INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                             J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C                 OUTPUT    : I - POSITION OF PREVIOUS 'CR' OR 'LF' OR 'S
C                                 IF NO CHARACTER FOUND THE CONTROL RETUR
C                                 ALTERNATIVE RETURN POINT *
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C                ---------------------------------------------
C                CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C                --------------------------------------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE LETFIG(K)
C
C***** *LETFIG*
C
C    NAME      : LETFIG
C
C    FUNCTION  : IF K IS NOT FIGURE CONVERT IT USING THE
C                CCITT NO.2 LETTER/FIGURE RELATION SHIP.
C
C    INPUT     : K - KHARACTER VALUE TO BE CONVERTED
C
C    OUTPUT    : K - CONVERTED TO FIGURE IF IT WAS EITHER
C                    E,O,P,Q,R,T,U,W,X,Y OR I, OTHERWISE
C                    K REMAINS UNCHANGED.
C

      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( K.LT.48.OR.K.GT.57 )
     C                      THEN
                                  DO 100 JA=1,11
                                       IF ( K.EQ.ILET(JA))
     C                                       K = IFIG(JA)
  100                             CONTINUE
                           END IF

      RETURN
      END
      
      SUBROUTINE FIXUS
C
C**** *FIXUS*
C
C
C     PURPOSE.
C     --------
C         TRY TO FIX ERROR ON TEMP DECODING.
C
c
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR PARITY BITS.
C                ------------------
 100  CONTINUE
C
      DO 101 I=IPT,IGS
         KCHAR(I) = KCHAR(I) .AND. 127
101   CONTINUE
C
C
      CALL REMEEE
C
      RETURN
      END
      
      SUBROUTINE FIXPHAS(LASTLEV,NOWIND,MORE,IFIX,LEVFIX,*,*)
C
C**** *FIXPHAS*
C
C
C     PURPOSE.
C     --------
C
C         TRIES TO FIND CORRECTLY CODED DATA AFTER
C         PHASE ERROR (WHERE THE PRESSURE LEVELS ARE
C         OUT OF ORDER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FIXPHAS(LASTLEV,NOWIND,MORE,IFIX,LEVFIX,*,*)*
C
C         INPUT     : LASTLEV - THE LEVEL NUMBER OF THE LAST CORRECT LEVEL
C                     NOWIND  - WIND INDICATOR (IS THERE SUPPOSED TO BE
C                               WIND AT THESE LEVELS)
C                     IFIX    - THE TWO DIGIT LEVEL INDICATOR IN CASE
C                               WHEN ONLY THIS INDICATOR WAS INCORRECT
C                               I.E. IF NINI=32 INSTEAD OF 30 SO IFIX=30
C                     LEVFIX  - THE ONE DIGIT LEVEL INDICATOR IN ABOVE
C                               MENTIONED ERROR CASE (SAME AS ILEVP IN
C                               SUBR. DETLEV).
C
C         OUTPUT    : MORE    - THE NUMBER OF CORRECT LEVELS FOUND AFTER
C                               THE CORRUPTION (IF MORE .GE. 2 RETURN TO
C                               THE MAIN SUBROUTINE)
C                     IPT     - POINTS TO THE BEGINNING OF FIRST CORRECT
C                               GROUP.
C
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  SEP.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION IPRES(11),JPRES(14)
C
      DATA IPRES/ 0, 92, 85, 70, 50, 40, 30, 25, 20, 15, 10/
      DATA JPRES/70, 50, 30, 20, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1/
C
C     ------------------------------------------------------------------
C
      ITRY = 0
      IFIX = 0
      LEVFIX = 0
      MORE=0
      LEVPRE=LASTLEV
      MPT=IPT
      NPT=IPT
C
100   CONTINUE
C
      ITRY = ITRY + 1
C
      IF(ITRY .GT. 5) THEN
                         MORE = 0
                         IFIX = 0
                         RETURN
                      END IF
C
      IF(MORE .EQ. 0) THEN
                         IPT = NPT
                         LEVPRE = LASTLEV
                      END IF
C
      IF(ITRY .GT. 1 .OR. LASTLEV .LT. 0)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*5000)
            CALL NEXPRT2(IPT,IEQ,*5000)
         END IF
C
      IF(MORE .EQ. 0) NPT = IPT
C
150   CONTINUE
C
C     JJPT HOLDS THE POINTER TO THE BEGINNING OF THE FIRST CORRECT GROUP
C
      IF(MORE .EQ. 0) JJPT = IPT
C
      KC1 = KCHAR(IPT) .AND. 127
      KC2 = KCHAR(IPT+1) .AND. 127
      ILEV1 = KC1 -48
      ILEV2 = KC2 -48
C
      IF(ILEV1 .LT. 0 .OR. ILEV1 .GT. 9 .OR.
     C   ILEV2 .LT. 0 .OR. ILEV2 .GT. 9 )
     C      THEN
               IFIX = 0
               MORE = 0
               GO TO 100
            END IF
C
C
C     IF THE SECOND CHARACTER IS 'SPACE' IT MOST PROBABLY MEANS THAT
C     PREVIOUS GROUP WAS TOO LONG AND THAT LEVEL HAS TO BE DELETED
C
C
C     CHECK IF THIS IS THE BEGINNING OF SECTION
C     3 OR 4 (88---,77---, OR 66---)
C
      ILEV = 10*ILEV1 + ILEV2
C
      IF((ILEV .EQ. 88) .OR. (ILEV .EQ. 77) .OR.
     C   (ILEV .EQ. 66))
     C      THEN
               MORE = 2
               IF(MORE .GE. 2) GO TO 5000
            END IF
C
C
C     CHECK IF THIS IS /////-GROUP (E.G. GROUP OF 'MISSING WIND')
C
      IF((KCHAR(IPT) .EQ. 47) .AND. (KCHAR(IPT+1) .EQ. 47)) GO TO 100
C
C
C     FIRST CHECK IF THE PRESSURE/HEIGHT GROUP IS ONLY CORRUPTED
C     IN THE PART OF INDICATOR, E.G. NINI = 32 INSTEAD OF 30. IN
C     THIS CASE THE TWO NEXT LEVELS ARE CHECKED IF THEY ARE CORRECT
C     AND THIS IS NOT THE FIRST LEVEL THIS LEVEL IS ACCEPTED.
C
C
C     fix 12.4.94-------
C
      IF(MORE .EQ. 0 .AND. ITRY .EQ. 1 .AND. LASTLEV .GE. 0) THEN
         ilastp2=lastlev+2
         if((ilastp2.le.9.and.kdec(23).eq.1).or.
     1      (ilastp2.le.12.and.kdec(23).eq.3)) then
            IF(KDEC(23) .EQ. 1) LEVTES = IPRES(LASTLEV+2)
            IF(KDEC(23) .EQ. 3) LEVTES = JPRES(LASTLEV+2)
            LEVT1 = LEVTES/10
            LEVT2 = LEVTES - 10*LEVT1
            IF(ILEV1 .EQ. LEVT1 .OR. ILEV2 .EQ. LEVT2)
     C         THEN
                  ILEV = LEVTES
                  IFIX = ILEV
               END IF
         end if
      END IF
C     ------------------
C     SEE IF THE GROUP IS CORRUPT
C
      CALL EXTVAL(IPT,5,IGROUP)
      IF(IGROUP .EQ. MINDIC)
     C   THEN
            IF(MORE.GT.0) GO TO 100
            IFIX = 0
            GO TO 100
         END IF
C
C
C     DETERMINE THE LEVEL
C
      CALL DETLEV(KDEC(23),ILEV,ILEVP)
C
C
      IF(ILEVP .LE. LEVPRE .OR. ILEVP .LT. 0)
     1       THEN
                MORE = 0
                GO TO 100
             END IF
C
C
      IF(ITRY .EQ. 1 .AND. IFIX .GT. 0) LEVFIX = ILEVP
C
C     TITI TAI DIDI
C     ---- --- ----
C
      CALL NEXSEP2(IPT,IEQ,*5000)
      CALL NEXPRT2(IPT,IEQ,*5000)
C
C     DIDI FIFIFI
C     ---- ------
C
      CALL NEXSEP2(IPT,IEQ,*5000)
      CALL NEXPRT2(IPT,IEQ,*5000)
C
C     CHECK IF THE NEXT GROUP IS WIND OR PRESSURE/HEIGHT
C     OF NEXT LEVEL OR BEGINNING OF NEXT SECTION
C
C
C     KEEP NOWIND INDICATOR (IT'S NOT USEFUL IN CASE CORRUTED LEVELS)
C
      KPWIND = NOWIND
C
      CALL WINDHEI(ILEVP,NOWIND,IWIND,ITROPO,MAXWIN,IEND)
C
      NOWIND = KPWIND
C
C
      IF(IEND .EQ. 1) GO TO 5000
C
      IF(ITROPO .EQ. 1)
     1      THEN
C           ----- TROPOPAUSE SECTION FOUND  ----
               MORE = 2
               LEVPRE = ILEVP
               GO TO 5000
            END IF
C
      IF(MAXWIN .EQ. 1)
     1      THEN
C           ----- MAX.WIND SECTION FOUND  ----
               MORE = 2
               LEVPRE = ILEVP
               GO TO 5000
            END IF
C
      IF(IWIND .EQ. -3)
     1   THEN
C        ----  CORRUPTED GROUP  ----
            MORE = 0
            GO TO 100
         END IF
C
      IF(NOWIND .GE. 2) THEN
                           MORE = MORE + 1
                           LEVPRE = ILEVP
                           IF(MORE .GE. 2) GO TO 5000
                           GO TO 150
                        END IF
C
      IF(IWIND .EQ. 1)
     1      THEN
C           ----- WIND GROUP FOUND  ----
               MORE = MORE + 1
               LEVPRE = ILEVP
               IF(MORE .GE. 2) GO TO 5000
               GO TO 100
            END IF
C
      IF(IWIND .EQ. 0)
     1      THEN
C           ----- PRESSURE/HEIGHT GROUP FOUND  ----
               MORE = MORE + 1
               LEVPRE = ILEVP
               IF(MORE .GE. 2) GO TO 5000
               GO TO 150
            END IF
C
      IF(IWIND .EQ. -1)
     1     THEN
C          -----CORRUPTED WIND GROUP FOUND  ----
              MORE = 0
              GO TO 100
           END IF
C
C
      IF(IWIND .EQ. -2)
     1     THEN
C          ----- '/////' - WIND GROUP FOUND  ----
               MORE = MORE + 1
               LEVPRE = ILEVP
               IF(MORE .GE. 2) GO TO 5000
               GO TO 100
           END IF
C
C
C
C
5000  CONTINUE
C
      IF(IPT .GE. IEQ)
     C   THEN
            MORE = 0
            IFIX = 0
            RETURN
         END IF
C
      IPT = MPT
      IF(MORE .GE. 2) IPT = JJPT
      IF(IFIX .GT. 0 .AND. MORE .GE. 2)
     C   THEN
            IPT = MPT + 2
         ELSE
            IFIX = 0
         END IF
C
      RETURN
      END
      
      SUBROUTINE LEVCHEC (LEVNUM,IPOS,ISTEP,LEVER,NEWSEC)
C
C**** *LEVCHEC*
C
C
C     PURPOSE.
C     --------
C
C         TRY TO FIND MORE CORRECT LEVELS IN TEMP PARTB AND
C         PART D AFTER AND ERROR OF PRESSURE HAS BEEN FOUND.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LEVCHEC (LEVNUM,IPOS,ISTEP,LEVER,NEWSEC)*
C
C          INPUT     : LEVNUM - THE LEVEL NUMBER (0,1,2,...)
C                    : IPOS   - POINTER OF THE LEVEL IN KINT
C                    : ISTEP  - THE STEP OF LEVELS IN KINT
C
C          OUTPUT    : LEVER  - THE INDICATOR OF DELETED LEVEL
C                      NEWSEC - THE INDICATOR OF POSSIBLE NEW SECTION
C                               (= 21212 FOR WIND SECTION ETC.)
C
C     METHOD.
C     -------
C
C         FOUR LEVELS, TWO BEFORE AND AND ONE AFTER THE ERROR,
C         WILL BE CHECKED, BECAUSE THE HEIGHT MIGHT BE WRONG
C         EITHER IN THE 'ERROR' GROUP,IF IT IS TOO BIG OR THE
C         PREVIOUS GROUP IF IT IS TOO SMALL.
C         IF THE ERROR IS ON THE SECOND LEVEL, ONLY THREE
C         LEVELS WILL BE CHECKED.
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN DEC.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION LEV(4)
C
      DATA LEV /4*-999999/
C
C     ------------------------------------------------------------------
C
C*          1.   LEVEL CHECK.
C                ------------
 100  CONTINUE
C
C
      LEVER = 0
      NEWSEC = 0
C
C     SEE IF THE WIND SECTION INICATOR HAS BEEN PASSED
C
      IF(ISTEP .NE. 5) GO TO 102
C
      IF(KINT(IPOS+1) .GE. 100) GO TO 102
C
      CALL PRE2121(IFOUND)
C
      IF(IFOUND .EQ. 1)
     C   THEN
            NEWSEC = 21212
            DO 101 I=IPOS,700
            KINT(I) = MINDIC
101         CONTINUE
            KINT(317) = 21212
            RETURN
         END IF
C
 102  CONTINUE
C
C
C*          1.1  SEE IF THE CLOUD SECTION, OR REGIONAL/NATIONAL
C                SECTION INDICAROR HAS BEEN PASSED
 110  CONTINUE
C
C===  CALL PRESEC(NEWSEC)
C===  IF(NEWSEC .GT. 0) RETURN
C
C     GET THE POINTER OF THE THREE LEVELS
C
C
C
      NPT = IPT
      IPO3 = NPT
      CALL PRESEP(NPT,LPT,*1000)
C
      NN = 4
      IF(LEVNUM .LE. 1) NN = 2
C
         DO 111 I=1,NN
         CALL PREPRT(NPT,IMI,*1000)
         CALL PRESEP(NPT,IMI,*1000)
         IF(I .EQ. 2) IPO2 = NPT
         IF(I .EQ. 4) IPO1 = NPT
 111     CONTINUE
C
         CALL NEXPRT2(IPO2,IEQ,*1000)
         IF(LEVNUM .GT. 1) CALL NEXPRT2(IPO1,IEQ,*1000)
C
C     THE LOOP TO GET THE LEVEL INDICTORS AND PRESSURES
C
112   CONTINUE
C
      IF(LEVNUM .GT. 1) CALL EXTVAL(IPO1+2,3,LEV(1))
      CALL EXTVAL(IPO2+2,3,LEV(2))
      CALL EXTVAL(IPO3+2,3,LEV(3))
C
      NPT = IPT
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
      N1 = (KCHAR(NPT)   .AND. 127)  - 48
      N2 = (KCHAR(NPT+1) .AND. 127) - 48
C
C
C     CHECK IF THIS IS CORECT BEGINNING OF SIGNIFICANT LEVEL (N1=N2)
C
      IF(N1 .NE. N2) THEN
C
C                       CHECK IF THIS IS THE BEGINNING
C                       OF SECTION 6, 8, 9 OR 10
C
                        CALL EXTVAL(IPT,5,IVAL)
C
                        IF(ISTEP .EQ. 5)
     C                     THEN
                              IF(IVAL .EQ. 21212)
     C                           THEN
                                    LEVER = 3
                                    IPT = NPT
                                    RETURN
                                  END IF
                            END IF
C
                        IF(IVAL .EQ. 41412)
     C                     THEN
                              LEVER = 3
                              IPT = NPT
                              RETURN
                           END IF
C
                        IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C                     (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C                     (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C                     (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C                     (IVAL .EQ. 59595) .OR. (IVAL .EQ. 51525))
     C                        THEN
                                 LEVER = 3
                                 IPT = NPT
                                 RETURN
                              END IF
C
C
                        IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C                     (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C                     (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C                     (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C                     (IVAL .EQ. 69696))
     C                        THEN
                                 LEVER = 3
                                 IPT = NPT
                                 RETURN
                              END IF
C
C
               LEVER = 3
               IPT = NPT
                       RETURN
C
                    END IF
C
      CALL EXTVAL(NPT+2,3,LEV(4))

1000  CONTINUE
C
      NN = 1
      IF(LEVNUM .LE. 1) NN = 2
C
      DO 113 I=NN,4
      IF(LEV(I) .EQ. -999999) RETURN
 113  CONTINUE
C
C     CHECK WHICH OF THE LEVELS IS OUT OF SEQUENCE
C
      IF(LEV(3) .LT. LEV(1) .OR. LEVNUM .LE. 1)
     C   THEN
            IF(LEV(4) .LT. LEV(2))
     C         THEN
C
C                 LEV(3) IS INCORRECT
C
                  IPT = NPT
                  LEVER = 3
                  RETURN
               ELSE
C
C                 LEV(2) IS INCORRECT
C
                  DO 114 I = IPOS , IPOS+ISTEP-1
                  KINT(I) = MINDIC
 114              CONTINUE
                  LEVER = 2
                  RETURN
               END IF
         ELSE
C
C           LEV(3) IS INCORRECT
C
            LEVER = 3
            IPT = NPT
            RETURN
         END IF
C
C
      END
      
      SUBROUTINE DUPLIGR(IFOUND)
C
C**** *DUPLIGR*
C
C
C     PURPOSE.
C     --------
C         FIND OUT IF TWO PREVIOUS GROUPS ARE DUPLICATES
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DUPLIGR(IFOUND)*
C
C          OUTPUT     IFOUND  = 1 IF DUPLICATE GROUPS FOUND
C                     IREMPOS   INDICATOR TO THE POINT OF THE FIRST ERROR
C                     IPT         POINTS TO THE BEGINNING OF THE SECOND
C                                 DUPLICATE.
C
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  JAN 84
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
       INCLUDE 'parameter.h'
       INCLUDE 'comwork.h'
       INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.   FIND DUPLICATED GROUPS.
C                -----------------------
 100  CONTINUE
C
      IFOUND = 0
      NPT = IPT
C
      CALL PRESEP(NPT,IMI,*1000)
      CALL PREPRT(NPT,IMI,*1000)
      CALL PRESEP(NPT,IMI,*1000)
      CALL PREPRT(NPT,IMI,*1000)
      CALL PRESEP(NPT,IMI,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
C     POINTER TO THE FIRST POSSIBLE DUPLICATE
C
      IPO1 = NPT
C
      CALL NEXSEP2(NPT,IEQ,*1000)
      CALL NEXPRT2(NPT,IEQ,*1000)
C
C     POINTER TO THE SECOND POSSIBLE DUPLICATE
C
      IPO2 = NPT
C
C     CHECK THE VALUES
C
      CALL EXTVAL(IPO1,5,IVAL1)
      CALL EXTVAL(IPO2,5,IVAL2)
C
      IF(IVAL1 .EQ. MINDIC .OR. IVAL2 .EQ. MINDIC) RETURN
C
      IF(IVAL1 .EQ. IVAL2)
     C   THEN
C
C           DUPLICATE GROUPS FOUND  --  SET THE POINTER IPT TO THE
C                                       BEGINNING OF THE DUPLICATE.
C                                       DUPLICATE.
C
            IPT = NPT
            IFOUND = 1
            RETURN
         END IF
C
1000  CONTINUE
      RETURN
C
      END
      
      SUBROUTINE NEXTNI(ISTEP,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
     C                  * , * , * , * , * , * , * , * )
C
C**** *NEXTNI*
C
C
C     PURPOSE.
C     --------
C
C
C         FIND THE NEXT PRESSURE LEVEL IN TEMP PART B & D
C
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTNI(ISTEP,IFIRST,LEVNUM,LEVPRE,IREMPOS,NUMERR,
C    C                  * , * , * , * , * , * , * , * )*
C          INPUT      ISTEP   = 5 FOR TEMPERATURE LEVELS
C                             = 4 FOR WIND LEVELS
C                     IFIRST  = 0 IF FIRST DECODING ATTEMPT
C                             = 1 OTHERWISE
C                     LEVNUM  = THE NUMBER OF THE LEVEL (RUNNING FROM 0 -)
C                     LEVPRE  = INDICATOR OF THE PREVIOUS LEVEL
C
C          OUTPUT     LEVNUM
C                     IREMPOS   INDICATOR TO THE POINT OF THE FIRST ERROR
C                               (USED AS POINTER OF DELETION IF THERE ARE
C                               TOO MANY ERRORS).
C
C
C     METHOD.
C     -------
C
C         MULTIPLE RETURN ADDRES
C         1.ST  IF THE BEGINNING OF WIND SECTION FOUND
C         2.ND  -- --- --------- -- CLOUD ------ -----
C         3.RD  -- --- --------- -- REGIONAL --- -----
C         4.TH  -- --- --------- -- NATIONAL --- -----
C         5.TH  -- --- END OF REPORT             -----
C         6.TH  --     NOTHING USEFUL            -----
C         7.TH  -- --- FOLLOWING LEVEL           -----
C
C
C
C     EXTERNALS.
C     ----------
C
C           SUBROUTINE CALLED
C           ERRSTA  -  TO REGISTER ERRORS
C           EXTVAL  -  TO EXTRACT A VALUE
C           LEVCHEC -  TO CHECK THE PRESSURE LEVELS
C           NEXPRT2 -  SCANNING ROUTINE
C           NEXSEP2 -  SCANNING ROUTINE
C
C
C
C     AUTHOR.
C     -------
C
C          A. HOLOPAINEN  DEC.83
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DATA N1N2PRE/-9999/
      DATA IFIX / 0 /
C
C     ------------------------------------------------------------------
C
C*          1.   FIND NEXT LEVEL IN THE B AND D PART OF TEMP REPORT.
C                ---------------------------------------------------
 100  CONTINUE
C
C
      ITRY = 0
      IDUP = 0
      IPART = 4
      IF(KDEC(23) .EQ. 4) IPART = 6
C
      IF(LEVNUM .LE. 0) N1N2PRE = -9999
      IF(LEVNUM .LE. 0) IFIX = 0
C
101   CONTINUE
C
C     NINI PIPIPI
C     ---- ------
C
      CALL NEXPRT2(IPT,IEQ,*9999)
C
C
      N1 = (KCHAR(IPT) .AND. 127) - 48
      N2 = (KCHAR(IPT+1) .AND. 127) - 48
      N1N2 = 10*N1 + N2
C
C
C     CHECK IF THIS IS CORRECT BEGINNING OF SIGNIFICANT LEVEL (N1=N2)
C
C     CHECK IF N1N2 = //
C
      IF(N1 .EQ. -1 .AND. N2 .EQ. -1)
     C   THEN
            CALL NEXSEP2(IPT,IEQ,*9999)
            GO TO 101
         END IF
C
C     CHECK IF THIS IS PART D AND NINI=00.  REJECT IT BEACUSE
C     SOME STATIONS INCLUDE INCORRECTLY STATION LEVEL IN PART D.
C
      IF(IPART .EQ. 6)
     C   THEN
            IF(N1N2 .EQ. 0)
     C         THEN
                  CALL NEXPRT2(IPT,IEQ,*9999)
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  CALL NEXPRT2(IPT,IEQ,*9999)
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
         END IF
C
      IPOS = 17
      IF(ISTEP .EQ. 4) IPOS = 318
C
      IF(LEVNUM .GT. 0)
     C   THEN
            IPOS = 17 + (LEVNUM-1)*5
            IF(ISTEP .EQ. 4) IPOS = 318 + (LEVNUM-1)*4
         END IF
C
C
C
      IF (N1 .NE. N2)
     C               THEN
C
C                       CHECK IF THIS IS THE BEGINNING
C                       OF SECTION 6,7,8,9,10
C
                        CALL EXTVAL(IPT,5,IVAL)
C
                        IF(ISTEP .EQ. 5)
     C                     THEN
                              IF(IVAL .EQ. 21212) RETURN 1
                           END IF
C
                        IF(IVAL.EQ.31313) RETURN 8
                        IF(IVAL .EQ. 41414) RETURN 2
C
                        IF((IVAL .EQ. 51515) .OR. (IVAL .EQ. 52525) .OR.
     C                     (IVAL .EQ. 53535) .OR. (IVAL .EQ. 54545) .OR.
     C                     (IVAL .EQ. 55555) .OR. (IVAL .EQ. 56565) .OR.
     C                     (IVAL .EQ. 57575) .OR. (IVAL .EQ. 58585) .OR.
     C                     (IVAL .EQ. 59595) .OR. (IVAL .EQ. 51525))
     C                     RETURN 3
C
                        IF((IVAL .EQ. 61616) .OR. (IVAL .EQ. 62626) .OR.
     C                     (IVAL .EQ. 63636) .OR. (IVAL .EQ. 64646) .OR.
     C                     (IVAL .EQ. 65656) .OR. (IVAL .EQ. 66666) .OR.
     C                     (IVAL .EQ. 67676) .OR. (IVAL .EQ. 68686) .OR.
     C                     (IVAL .EQ. 69696)) RETURN 4
C
C                       ERROR, IF NOT ANY SIGNIFICANT LEVEL OR OTHER
C                       SECTION. CHECK IF ONLY NINI IS ERRONEUSLY CODED.
C                       IF THE LEVL HAS TO BE REJECTED TRY TO FIND THE
C                       NEXT LEVEL.
C
                        NPT = IPT
                        CALL NEXSEP2(NPT,IEQ,*9999)
                        CALL NEXPRT2(NPT,IEQ,*9999)
C
                        IF(ITRY .EQ. 0 .AND. IFIX .EQ. 0)
     C                     THEN
                              KERR = 5
                               CALL ERRSTA(IPART,1,IFIRST,NUMERR)
                              IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
C
C                             CHECK IF THERE WERE DUPLICATE GROUPS
C                             ON PREVIOUS LEVEL
C
                              IDUP = 0
                              CALL DUPLIGR(IDUP)
C
                              IF(IDUP .EQ. 1)
     C                           THEN
                                    ITRY = ITRY + 1
                                    IFIX = IFIX + 1
                                    IFIXPOS = IPOS + ISTEP
                                    DO 150 I = IPOS,IPOS+4
                                    KINT(I) = MINDIC
150                                 CONTINUE
                                    GO TO 101
                                 END IF
C
C
C                             CHECK IF NINI GROUP IS ERRONEUS SO THAT
C                             ONE OF THE NI'S IS CORRECT.  IN THIS
C                             CASE CHECK THE 'NINI' OF THE NEXT LEVEL
C                             AND THE PRESSURE OF THIS LEVEL COMPARED
C                             TO THE PREVIOUS LEVEL.  ONLY IF ALL THESE
C                             CONDITIONS ARE FULLFILLED ACCEPT THIS
C                             THIS LEVEL.
C
                              NPT = IPT
                              CALL NEXSEP2(NPT,IEQ,*9999)
                              CALL NEXPRT2(NPT,IEQ,*9999)
                              CALL NEXSEP2(NPT,IEQ,*9999)
                              CALL NEXPRT2(NPT,IEQ,*9999)
                              IF(KCHAR(NPT) .EQ. KCHAR(NPT+1))
     C                           THEN
                                    N1PRE = N1N2PRE/10
                                    N2PRE = N1N2PRE - 10*N1PRE
                                    IF(LEVNUM .EQ. 0)
     C                                 THEN
                                          N1PRE = 0
                                          N2PRE = 0
                                       END IF
                                    N1NEW = N1PRE + 1
                                    N2NEW = N2PRE + 1
                                    IF(N1NEW .EQ. 10) N1NEW = 1
                                    IF(N2NEW .EQ. 10) N2NEW = 1
C
                                    IF(N1 .EQ. N1NEW)
     C                                 THEN
                                          N1N2 = 10*N1 + N1
                                          ITRY = ITRY + 1
                                          IFIX = IFIX + 1
                                          IFIXPOS = IPOS + ISTEP
                                          GO TO 300
                                       ELSE
                                          IF(N2 .EQ. N2NEW)
     C                                       THEN
                                                N1N2 = 10*N2 + N2
                                                ITRY = ITRY + 1
                                                IFIX = IFIX + 1
                                                IFIXPOS = IPOS + ISTEP
                                                GO TO 300
                                             END IF
                                       END IF
                                 END IF
C
C
                             ELSE
                                KERR=5
                                CALL ERRSTA(IPART,1,IFIRST,NUMERR)
                                 IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                             END IF
C
C
                          IF(LEVNUM .GE. 1 .AND. ITRY .GT. 1)
     C                       THEN
                                DO 200 I=IPOS,IPOS+4
                                KINT(I) = MINDIC
200                             CONTINUE
                             END IF
C
                          IF(IFIX .GE. 2)
     C                       THEN
                                DO 250 I=IFIXPOS,700
                                KINT(I) = MINDIC
250                             CONTINUE
                             END IF
C
                             ITRY = ITRY + 1
                             IF(ITRY .EQ. 1)
     C                          THEN
                                   IF(N2 .EQ. -16)
     C                                THEN
                                         NPT = IPT
                                         CALL PRESEP(NPT,IMI,*270)
                                         CALL PREPRT(NPT,IMI,*270)
                                         ILN = IPT - NPT + 1
                                        IF(ILN .NE. 5 .AND. ILN .NE. 10)
     C                                     THEN
                                              DO 260 I = IPOS,IPOS+6
                                              KINT(I) = MINDIC
260                                           CONTINUE
                                           END IF
                                      END IF
                                END IF
C
270   CONTINUE
                          CALL NEXSEP2(IPT,IEQ,*9999)
                          GO TO 101
                       END IF

300   CONTINUE
C
      CALL EXTVAL(IPT+2,3,IVAL2)
C
C
C
      IF(IVAL2 .EQ. MINDIC)
     C   THEN
            IF(KCHAR(IPT+2).EQ.47 .AND. KCHAR(IPT+3).EQ.47
     C        .AND. KCHAR(IPT+4).EQ.47 )
     C        THEN
                 CALL NEXSEP2(IPT,IEQ,*9999)
                 GO TO 101
              END IF
C
            IF(IPART .EQ. 4)
     C         THEN
                  KERR = 5
                  CALL ERRSTA(IPART,2,IFIRST,NUMERR)
                  IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
C
C           COMMON PRACTICE IN PART D IS TO REPLACE THE LAST DIGIT
C           OF PRESSURE WITH /.  THIS IS REPLACED WITH 0.
C
C
            IF(IPART .EQ. 6)
     C         THEN
                 IF( (KCHAR(IPT+2).GE.48 .AND. KCHAR(IPT+2).LE.57) .AND.
     C               (KCHAR(IPT+3).GE.48 .AND. KCHAR(IPT+3).LE.57) .AND.
     C               (KCHAR(IPT+4).EQ.47) )
     C              THEN
                       KCHAR(IPT+4) = 48
                       CALL EXTVAL(IPT+2,3,IVAL2)
                    ELSE
                       KERR = 5
                       CALL ERRSTA(IPART,2,IFIRST,NUMERR)
                       IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
                       CALL NEXSEP2(IPT,IEQ,*9999)
                       CALL NEXPRT2(IPT,IEQ,*9999)
                       CALL NEXSEP2(IPT,IEQ,*9999)
                       GO TO 101
                    END IF
                END IF
         END IF
C
C     CHECK IF THIS IS PART B AND PRESSURE IS < 100 MB
C
      IF(IPART .EQ. 4 .AND. LEVNUM .GT. 3 .AND. IVAL2 .LT. 100)
     C   THEN
C
C           SEE IF '21212' - INDICATOR WAS PASSED UNDETECTED
C
            IF(ISTEP .EQ. 5)
     C         THEN
                  CALL PRE2121(IFOUND)
                  IF(IFOUND .EQ. 1)
     C               THEN
                        NEWSEC = 21212
                        KINT(317) = 21212
                        RETURN 1
                     END IF
               END IF
C
            CALL NEXSEP2(IPT,IEQ,*9999)
            GO TO 101
         END IF
C
C
C     IF ERROR FOUND IN 'NINI' DONT ACCEPT NINI .LE. THE PREVIOUS
C
      IF(ITRY .GT. 0 .AND. IDUP .NE. 1)
     C   THEN
            IF(N1N2 .LE. N1N2PRE .AND. N1N2PRE .NE. 99)
     C         THEN
                  CALL NEXSEP2(IPT,IEQ,*9999)
                  GO TO 101
               END IF
         END IF
C
C     CHECK THE PRESSURE AGAINST THE PREVIOUS LEVEL.  IF IT
C     LOWER CHECK WHETHER THIS LEVEL IS INCORRECT OR IF IT
C     WAS THE PREVIOUS ONE. REJECT THE ERRONEUS LEVEL.
C     FOR PART B THIS TEST IS CARRIED OUT ONLY FROM THIRD LEVEL
C     ONWARDS, BECAUSE FIRST TWO (OR THREE) LEVELS MAY BE OVER
C     1000 HPA AND ONLY THREE LAST FIGURES ARE USED (I.E. 11030,
C     22020,....)
C
      IF(LEVPRE .EQ. MINDIC) GO TO 500
C
      IF(LEVNUM .GT. 2 .OR. IPART .EQ. 6)
     C   THEN
            IF(IVAL2 .GT. LEVPRE)
     C         THEN
                  IF(IPART .EQ. 4 .AND. LEVNUM .EQ. 3 .AND.
     C               LEVPRE .LT. 50) GO TO 500
C
C
C                 CHECK IF ALL THE PREVIOUS LEVELS WERE ABOVE 1000MB.
C
                  IF(IPART .EQ. 4 .AND. LEVPRE .LT. 50)
     C               THEN
                        DO 400 I = 1,LEVNUM
                        IND = 18 + (I-1)*5
                        IF(ISTEP .EQ. 4) IND = 319 + (I-1)*4
                        IF(KINT(IND) .GT. 50) GO TO 410
400                     CONTINUE
                        GO TO 500
                     END IF
C
410            CONTINUE
C
C
               KERR = 8
C
               IND = 18 + (LEVNUM-1)*5
               IF(ISTEP .EQ. 4) IND = 319 + (LEVNUM-1)*4
               IF(KINT(IND) .LT. 100 .AND. KINT(IND) .NE. MINDIC)
     C            THEN
                     DO 450 I = 1,ISTEP
                     J = IND+I-1
                     KINT(J) = MINDIC
450                  CONTINUE
                  END IF
C
               CALL ERRSTA(IPART,1,IFIRST,NUMERR)
               IF(NUMERR .EQ. 1) IREMPOS = IPOS
C
C                 CHECK WHICH LEVEL IS INCORRECT, OR IF
C                 THE BEGINNING OF NEXT SECTION HAS BEEN
C                 PASSED UNNOTICED (MAY HAPPEN IN CASE
C                 OF MISSING GROUP).
C
                  CALL LEVCHEC(LEVNUM,IPOS,ISTEP,LEVER,NEWSEC,NUMERR)
C
C
                  IF(NEWSEC .EQ. 21212) RETURN 1
                  IF(NEWSEC.EQ.31313) RETURN 8
                  IF(NEWSEC .EQ. 41414) RETURN 2
                  IF(NEWSEC .EQ. 51515) RETURN 3
                  IF(NEWSEC .EQ. 61616) RETURN 4
C
C
                  IF(LEVER .EQ. 2) GO TO 500
                  IF(LEVER .EQ. 3)
     C               THEN
                        ITRY = ITRY + 1
                        N1N2PRE = N1N2
                        GO TO 101
                     END IF
C
C
                 RETURN 6
              END IF
           END IF
C
C
500   CONTINUE
      N1N2PRE = N1N2
      RETURN 7
C
9999  CONTINUE
      RETURN 5
C
      END
      
      SUBROUTINE GEOPOTE(ILEV,IHH,MINDIC,IHEIGH)
C
C**** *GEOPOTE*
C
C
C     PURPOSE.
C     --------
C
C         DECODE THE GEOPOTENTIAL OF A LEVEL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GEOPOTE(ILEV,IHH,MINDIC,IHEIGH)*
C
C          INPUT    :  ILEV    - LEVEL INDICATOR (0,925,850,700,500,...)
C                   :  IHH     - THE HEIGHT FIGURE IN THREE DIGITS
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  IHEIGH  - DECODED GEOPOTENTIAL IN METERS
C
C
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION LEVELS(27)
C
      DATA LEVELS/
     1           0, 925, 850, 775, 700, 600, 500, 400, 300, 250,
     2         200, 150, 100,  70,  50,  30,  20,  10,   9,   8,
     3           7,   6,  5,  4,  3,  2,  1/
C
C
C     ------------------------------------------------------------------
C
C*          1.   CHECK FOR MISSING VALUES.
C                -------------------------
 100  CONTINUE
C
      IF(ILEV .EQ. MINDIC .OR. IHH .EQ. MINDIC) RETURN
C
C
      ICONST=0
C
C     RETAIN THE ORIGINAL IHH VALUE
C
      KEEPHH = IHH
C
C
      DO 111 I=1,27
      IF(ILEV .EQ. LEVELS(I)) GO TO 112
  111 CONTINUE
C
      IHEIGH=MINDIC
      RETURN
C
  112 CONTINUE
C
C
      GO TO( 1000, 925, 850, 775, 700, 600, 500, 500, 300, 300,
     1        200, 200, 200,  70,  50,  30,  30,  10,  10,  10,
     2         10,   6,   6,   4,   4,   2,   2) I
C
C
C     ---  1000MB  ---
C
 1000 CONTINUE
C
C
C     CHECK IF 1000MB IS BELOW SEA-LEVEL
C
      IF(IHH .GT. 500) IHH = 500 - IHH
C
      GO TO 5000
C
C
C     ---  925MB  ---
C
  925 CONTINUE
C
      IF(IHH .LT. 250) ICONST = 1000
      GO TO 5000
C
C     ---  850MB  ---
C
  850 CONTINUE
C
      IF(IHH .LT. 750) ICONST = 1000
      GO TO 5000
C
C
C     ---  775MB  ---
C
  775 CONTINUE
C
      ICONST = 2000
      IF(IHH .GT. 750) ICONST = 1000
      GO TO 5000
C
C
C     ---  700MB  ---
C
  700 CONTINUE
C
      ICONST=2000
      IF(IHH .LT. 300) ICONST = 3000
      GO TO 5000
C
C
C     ---  600MB  ---
C
  600 CONTINUE
C
      ICONST = 4000
      IF(IHH .GT. 750) ICONST = 3000
      GO TO 5000
C
C     ---  500MB OR 400MB  ---
C
  500 CONTINUE
C
      IHH = 10*IHH
      GO TO 5000
C
C
C     ---  300MB OR 250MB  ---
C
  300 CONTINUE
C
      IF(IHH .LT. 200) ICONST = 10000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  200MB OR 150MB OR 100MB  ---
C
  200 CONTINUE
C
      ICONST = 10000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  70MB ---
C
   70 CONTINUE
C
      ICONST = 10000
      IF(IHH .LE. 200) ICONST = 20000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  50MB ---
C
   50 CONTINUE
C
      ICONST = 20000
      IF(IHH .GE. 800) ICONST = 10000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  30MB OR 20MB ---
C
   30 CONTINUE
C
      ICONST = 20000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  10MB OR 9MB OR 8MB OR 7MB  ---
C
   10 CONTINUE
C
      ICONST = 30000
      IF(IHH .GE. 800) ICONST = 20000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  6MB OR 5MB  ---
C
    6 CONTINUE
C
      ICONST = 30000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  4MB OR 3MB  ---
C
    4 CONTINUE
C
      ICONST = 30000
      IF(IHH .LE. 200) ICONST = 40000
      IHH = 10 * IHH
      GO TO 5000
C
C
C     ---  2MB OR 1MB  ---
C
    2 CONTINUE
C
      ICONST = 40000
      IF(IHH .GE. 800) ICONST = 30000
      IHH = 10 * IHH
C
C
 5000 CONTINUE
C
      IHEIGH = ICONST + IHH
      IHH = KEEPHH
C
      RETURN
      END
      
      SUBROUTINE DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C**** *DDFFF*
C
C
C     PURPOSE.
C
C
C         DECODE WIND DIRECTION AND SPEED
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)*
C
C          INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C                   :  IFF     - WIND SPEEDIN METERS/SEC OR KNOTS
C                   :  IWW     - WIND SPEED INDICATOR (1 FOR KNOTS)
C                   :  ICOUNT  - COUNTRY NUMBER
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C                      ISPEED  - DECODED WIND SPEED
C
C              IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C              ANY ERRORS FOUND IN IDD, IFF OR IWW
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

C     ------------------------------------------------------------------
C*          1.   DECODE WIND DIRECTION AND SPEED.
C                --------------------------------
 100  CONTINUE
C
C      CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC .OR. IFF .EQ. MINDIC) RETURN
C
C     CHECK IF IDD ID FEASABLE
C
      IF(IDD .LT. 0 .OR. IDD .GT. 36) RETURN
C
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C
C
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
C
C
C
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      IF(ISPEED .GE. 500) THEN
                             ISPEED=ISPEED-500
                             IDIR=IDIR+5
                            END IF
C
C
C     IF SPEED IN KNOTS MODIFY IT TO M/S
C
      IF(IWW .EQ. 1) CALL KTOMPSI(ISPEED)
C
      RETURN
      END
      
      SUBROUTINE DETLEV ( IPART,ILEV,ILEVP)
C
C**** *DETLEV*
C
C
C     PURPOSE.
C     --------
C
C         DETERMINE THE PRESSURE LEVEL
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DETLEV ( IPART,ILEV,ILEVP)*
C
C          INPUT     : IPART  = 1 FOR TEMP PAR A
C                             = 3 FOR TEMP PAR C
C                      ILEV   = VALUE OF THE FIRST TWO FIGURES IN THE GROUP
C                               (I.E.  85,  70,  50, ...)
C
C          OUTPUT    : ILEVP  THE LEVEL NUMBER
C                       0  FOR 1000MB  )
C                       1  FOR  925MB  )
C                       2  FOR  850MB  ) FOR PART A
C                       -------------  )
C                       10  FOR  10MB  )
C
C                       0  FOR   70MB  )
C                       1  FOR   50MB  ) FOR PART C
C                       -------------  )
C                      13  FOR    1MB  )
C
C
C                      -1  IF NOT PRESSURE/HEIGHT GROUP
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ILEVINA(22),ILEVINC(28)
C
      DATA ILEVINA/
     C   0, 0,   92, 1,   85, 2,   70, 3,   50, 4,   40, 5,   30, 6,
     C  25, 7,   20, 8,   15, 9,   10, 10/
C
      DATA ILEVINC/
     C  70, 0,   50, 1,   30, 2,   20, 3,   10, 4,    9, 5,   8, 6,
     C   7, 7,    6, 8,    5, 9,    4,10,    3,11,    2,12,   1,13/
C
C     ------------------------------------------------------------------
C*          1.   DETERMINE THE PRESSURE LEVEL.
C                -----------------------------
 100  CONTINUE
C
      ILEVP=-1
C
C     CHECK VALIDITY OF ILEV1 AND ILEV2
C
C     CHECK VALIDITY OF LEV AND IPART
C
      IF((ILEV .LT. 0) .OR. (ILEV .GT. 92)) RETURN
      IF((IPART .NE. 1) .AND. (IPART .NE. 3)) RETURN
C
      IF(IPART .EQ. 1) THEN
                          DO 101 I=1,21,2
                             IF(ILEV .EQ. ILEVINA(I))
     C                          THEN
                                   ILEVP = ILEVINA(I+1)
                                   RETURN
                                END IF
101                       CONTINUE
                       END IF
C
      IF(IPART .EQ. 3) THEN
                          DO 102 I=1,27,2
                             IF(ILEV .EQ. ILEVINC(I))
     C                          THEN
                                   ILEVP = ILEVINC(I+1)
                                   RETURN
                                END IF
102                       CONTINUE
                       END IF
C
C
C
      RETURN
      END
      
      SUBROUTINE DETLEVC ( ILEV1,ILEV2,ILEVP)
C
C**** *DETLEVC*
C
C
C     PURPOSE.
C     --------
C
C         DETERMINE THE PRESSURE LEVEL IN TEMP PART C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DETLEVC ( ILEV1,ILEV2,ILEVP)*
C
C          INPUT     : ILEV1  VALUE OF THE FIRST FIGURE IN THE GROUP
C                      ILEV2  ----- -- --- SECOND ----- -- --- -----
C
C          OUTPUT    : ILEVP  THE LEVEL NUMBER
C                      0  FOR 70 MB
C                      1  FOR 50 MB
C                      -------------
C                      13  FOR  1 MB
C
C                      -1  IF NOT PRESSURE/HEIGHT GROUP
C
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

C     ------------------------------------------------------------------
C*          1. DETERMINE PRESSURE LEVEL, TEMP PART C.
C              --------------------------------------
 100  CONTINUE
C
      ILEVP=-1
C
C     CHECK VALIDITY OF ILEV1 AND ILEV2
C
      IF((ILEV1 .LT. 0) .OR. (ILEV1 .GT. 9) .OR.
     1   (ILEV2 .LT. 0) .OR. (ILEV2 .GT. 9)) RETURN
C
C
C     FORM THE LEVEL FIGURE
C
      ILEV=10*ILEV1 + ILEV2
C
      IF(ILEV .EQ. 70) THEN
         ILEVP=0
         RETURN
      END IF
C
      IF(ILEV .EQ. 50) THEN
         ILEVP=1
         RETURN
      END IF
C
C
      IF(ILEV .EQ. 30) THEN
         ILEVP=2
         RETURN
      END IF
C
      IF(ILEV .EQ. 20) THEN
         ILEVP=3
         RETURN
      END IF
C
      IF(ILEV .EQ. 10) THEN
         ILEVP=4
         RETURN
      END IF
C
      IF(ILEV .EQ. 9) THEN
         ILEVP=5
         RETURN
      END IF
C
      IF(ILEV .EQ. 8) THEN
         ILEVP=6
         RETURN
      END IF
C
      IF(ILEV .EQ. 7) THEN
         ILEVP=7
         RETURN
      END IF
C
      IF(ILEV .EQ. 6) THEN
         ILEVP=8
         RETURN
      END IF
C
C
      IF(ILEV .EQ. 5) THEN
         ILEVP=9
         RETURN
      END IF
C
      IF(ILEV .EQ. 4) THEN
         ILEVP=10
         RETURN
      END IF
C
      IF(ILEV .EQ. 3) THEN
         ILEVP=11
         RETURN
      END IF
C
      IF(ILEV .EQ. 2) THEN
         ILEVP=12
         RETURN
      END IF
C
      IF(ILEV .EQ. 1) THEN
         ILEVP=13
         RETURN
      END IF
C
      RETURN
      END
      
      SUBROUTINE PREPRT(I,J,*)
C
C**** *PREPRT*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR PREVIOUS CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PREPRT(I,J,*)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE PRE2121 (IFOUND)
C
C**** *PRE2121*
C
C
C     PURPOSE.
C     --------
C
C         SCANS THE REPORT BACKWARDS TRYING TO FIND
C         '21212'-GROUP OR CORRUPTED '21212'-GROUP, WHERE
C         ALL BUT ONE FIGURE MATCH WITH CORRECT GROUP.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRE2121 (IFOUND)*
C
C          INPUT     : IPT    -   POINTER TO THE BEGINNING OF SCANNING
C
C          OUTPUT    : IFOUND = 1  IF THE GROUP WAS FOUND
C                             = 0  OTHERWISE
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
      DIMENSION ICONST(5),KK(5)
C
      DATA ICONST / 20000 , 1000 , 200, 10 , 2 /
C     ------------------------------------------------------------------
C*          1.   TRY TO FIND 21212 GROUP.
C                ------------------------
 100  CONTINUE

      IFOUND = 0
      JPT = IPT
C
C     UP TO THREE PREVIOUS GROUPS ARE CHECKED
C
C
         DO 101 IROU=1,3
C
         CALL PRESEP(JPT,IMI,*10000)
         CALL PREPRT(JPT,IMI,*10000)
         CALL PRESEP(JPT,IMI,*10000)
         CALL NEXPRT2(JPT,IEQ,*10000)
C
C
C        SEE IF THIS IS COMPLETE '21212' - GROUP
C
         CALL EXTVAL(IPT,5,IVAL)
C
         IF(IVAL .EQ. 21212)
     C      THEN
               IFOUND = 1
               IPT = JPT
               RETURN
            END IF
C
            DO 102 I=1,5
            J = JPT+I-1
            KK(I) = KCHAR(J) .AND. 127
            KK(I) = KK(I) - 48
102         CONTINUE
C
C
            DO 103 I=1,5
            KCA = 0
               DO 104 J=1,5
               IF(J .EQ. I)
     C            THEN
                     KCA = KCA + ICONST(I)
                  ELSE
                     KCA = KCA + KK(J) * 10**(5-J)
                  END IF
104            CONTINUE
            IF(KCA .EQ. 21212)
     C         THEN
                  IFOUND = 1
                  IPT = JPT
                  RETURN
               END IF
103         CONTINUE
101      CONTINUE
C
10000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXSEP2 ( I,J,*)
C
C**** *NEXSEP2*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C         'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C                         IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                         ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXSEP2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  SCAN BULLETIN.                     .
C                -------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXPRT2(I,J,*)
C
C**** *NEXPRT2*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXPRT2(I,J,*)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXTEQ ( I,J )
C
C**** *NEXTEQ*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '=' CHARACTER.
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEQ(I,J)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
C     '=' IS 61 .
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 61) RETURN
  101 CONTINUE
C
      I=J
      RETURN
      END
      
      SUBROUTINE EXTINT ( I,N,K )
C
C**** *EXTINT*
C
C
C     PURPOSE.
C     --------
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN WORD K OF 'KINT' .
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTED.
C
C         OUTPUT    : I - POINTS TO CHARACTER AFTER THE LAST ONE EXTRACTED.
C                         MADE NEGATIVE IF A 'SEPARATOR' IS FOUND IN THE
C                         CHARACTERS BEING EXTRACTED.
C                         IF NEGATIVE , THE ABSOLUTE VALUE IS POSITION OF
C                         'SEPARATOR' ENCOUNTERED .
C                     K - INTEGER VALUE IN WORD K OF 'KINT'. MISSING DATA
C                         VALUE INSERTED IF '/' OR NON DIGIT ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTINT ( I,N,K )*
C
C     AUTHOR.
C     -------
C
C          J. HENNESSY
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES.
C                ------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
C*           1.1 STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE.
C                ------------------------------------------------------------
 110  CONTINUE
C
      DO 111 J=IA,IB
C
      KTEMP=KCHAR(J)
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C
C          CHECK FOR SPACE,LINE FEED AND CARRIAGE RETURN CHARACTER .
C
           IF ( KAR .EQ. 32 .OR. KAR .EQ. 10 .OR. KAR .EQ. 13)
     C                           THEN
                                      I = - J
                                      KINT(K) = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     I = IB + 1
                                     KINT(K) = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR .LT. 48 .OR. KAR .GT. 57 )
     C                      THEN
                                  DO 112 JA=1,11
                                       IF ( KAR .EQ. ILET(JA))
     C                                       KAR = IFIG(JA)
  112                             CONTINUE
                           END IF
C
           IF ( KAR .GE. 48 .AND. KAR .LE. 57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      KINT(K) = MINDIC
                                      I = IB + 1
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  111 CONTINUE
C
      KINT(K) = IAC / 10
      I = J
C
C
      RETURN
      END
      
      SUBROUTINE NEXTPRT ( I,J )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTSEP ( I,J )
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C                        'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTEND ( I,J )
C
C**** *NEXTEND*
C
C
C     PURPOSE.
C     --------
C         FUNCTION  : LOCATE NEXT OCCURRENCE OF EITHER 'CR' OR 'LF'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' CHARACTER.
C                     I > J INDICATES NO CHARACTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 .
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. 13 .OR. KAR .EQ. 10 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTBULL ( I,M )
C
C**** *PRTBULL*
C
C
C     PURPOSE.
C     --------
C         PRINTS BULLETIN IN ARRAY 'KCHAR'
C
C         INPUT      : BULLETIN IN 'KCHAR' .
C                      I - PRINT STARTS AT CHARACTER I
C                      M - PRINT ENDS AT CHARACTER M .
C
C         OUTPUT     : BULLETIN IS PRINTED . ARRAY 'KCHAR' AND POINTERS
C                      UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTBULL(I,M)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
C      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILINE(80)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BULLETIN.
C                ---------------
 100  CONTINUE
C
      IP = I
      J = M
      K = 80
C
C*          1.1  SET OUTPUT LINE TO ALL SPACES .
C                -------------------------------
 110  CONTINUE
C
      DO 111 N=1,K
             ILINE(N) = 32
  111 CONTINUE
C
C     LOCATE START AND END OF NEXT LINE OF CHARACTERS ( IF ANY ).
C
      CALL NEXTPRT ( IP,J )
      IF ( IP.GE.J ) RETURN
      JP = IP
      CALL NEXTEND ( JP,J )
      K = JP - IP
      IF(K.GT.80) K=80
C
C     INSERT IN OUTPUT LINE AND SUPPRESS PARITY BIT.
C
      DO 112 N =1,K
             ILINE(N) = KCHAR(IP).AND.127
             IP = IP + 1
  112 CONTINUE
C
      WRITE ( *,9900) (ILINE(N),N=1,K)
C
C     GET NEXT LINE
C
      GO TO 110
C
 9900 FORMAT (1H ,80A1)
C
      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER *10 IFA
      CHARACTER CUNIT*24,CVAL*9
C
      CHARACTER*8 YDATE
      CHARACTER*9 YSNAME
      CHARACTER*5 YTIME,YFAMILY,YTASK
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comsh.h'
      INCLUDE 'comshc.h'
      include 'comdate.h'
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE.
C
C
C
C
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING OF
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS ,
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'17777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                          '7777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CALL SETTAB( IERR )
C     --------------------------------------------------------------------
C*          9.   SET UP WMO STATION LIST AND IMPORTANT STATIONS.
C                -----------------------------------------------
 900  CONTINUE
C
      CALL STATION(IERR)
C
C     --------------------------------------------------------------------
C*          10.   SET UP date of observations.
C                -----------------------------------------------
 905  CONTINUE
C
      call datim (ny,nm,nd,nutc,nh,nmin,nsec,ncc)

      if (nm .lt. 0) nm = nm * -1     
c       print*,'initvar',ny,nm,nd          
C
C*          10.  READ IN LIST OF SHIP HEIGHTS.
C                -----------------------------
 1000 CONTINUE
C
      OPEN(88,IOSTAT=IOS,ERR=1010,
     1     FILE='ship_height.dat',
     2     FORM='FORMATTED',
     3     STATUS='OLD')
C
      I=0
      READ(88,'(A9,F3.0)',ERR=1020,END=1100) Y
C
 1030 CONTINUE
      I=I+1
      READ(88,'(A9,F3.0)',ERR=1020,END=1100) YSNAME(I),SHGT(I)
      GO TO 1030
C
 1020 CONTINUE
C
      PRINT*,'Error during read ship_height file'
      PRINT*,'Iostat=',ios
C
 1010 CONTINUE
C
      PRINT*,'Error opening ship_height file'
      PRINT*,'Iostat=',ios
C 
C
C*          11. GET SUPERVISOR DATE,TIME,FAMILY AND TASK.
C               -----------------------------------------
 1100 CONTINUE
C
      CLOSE(88)
C
      RETURN
      END
      
      SUBROUTINE NEXTFIG ( I,K )
C
C**** *NEXTFIG*
C
C
C     PURPOSE.
C     --------
C         LOCATE FIRST WORD CONTAINING A FIGURE IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO FIGURE FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTFIG(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT FIGURE.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 48 .AND. KAR .LE. 57 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTLET ( I,K )
C
C**** *NEXTLET*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE FIRST WORD CONTAINING A LETTER IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO LETTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTLET(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT LETTER.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 110 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 65 .AND. KAR .LE. 90 ) RETURN
  110 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    N1 - NUMBER OF CHARACTERS CONVERTED TO FIRST INTEGER
C                    N2 -    "    "     "          "     " SECOND   "
C                    N3 -    "    "     "          "     "  THIRD   "
C                    N4 -    "    "     "          "     "  FOURTH  "
C                    N5 =    "    "     "          "     "  FIFTH   "
C
C
C                    N - INDEX TO ARRAY 'KINT' , WHERE THE INSERTION OF
C                        INTEGER VALUES STARTS.
C                        VALUES ARE INSERTED IN CONSECUTIVE WORDS.
C
C                    IRET = 0 , ALL CONVERSIONS PERFORMED OK.
C                         = N , ERROR FOUND IN N TH INTEGER CONVERSION.
C
C                    I - POINTS TO CHARACTER AFTER LAST ONE EXTRACTED ,
C                        UNLESS A 'SEPARATOR' (= 'SPACE' , 'LINE FEED',
C                        'CARRIAGE RETURN') IS ENCOUNTERED IN FIGURES
C                        BEING EXTRACTED . IN THIS CASE I IS MADE NEGATIVE
C                        WITH THE ABSOLUTE VALUE OF 'I' POINTING TO THE
C                        'SEPARATOR' FOUND. IN THIS CASE ALSO THE WHOLE
C                        GROUP IS DELETED FROM 'KINT'.
C
C                        INTEGER VALUES EXTRACTED PUT IN WORDS N,N+1 ETC
C                        OF ARRAY 'KINT' .
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXTINT(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      NN(1) = N1
      NN(2) = N2
      NN(3) = N3
      NN(4) = N4
      NN(5) = N5
C
      IRET = 0
C
      K = N
C
C
C
C*          1.1  CONVERT GROUP .
C                ---------------
 110  CONTINUE
C
      DO 111 J=1,5
         IF ( NN(J).EQ.0 ) RETURN
         CALL EXTINT ( I,NN(J),K )
         IF ( I.LT.0 ) THEN
                            IRET = J
                               DO 50 JJ=1,5
                               IF(NN(JJ) .EQ. 0) RETURN
                               KINT(N+JJ-1) = MINDIC
50                             CONTINUE
                            RETURN
                       END IF
         K = K + 1
  111 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTVAL ( I,N,K )
C
C**** *NEXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE FIRST WORD CONTAINING THE VALUE 'N' IN
C         ARRAY 'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT    : 'KCHAR' CONTAINS ONE BULLETIN , ONE CHARACTER PER
C                    WORD.
C
C         OUTPUT   : I = REQUIRED LOCATION . I > K MEANS VALUE NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTVAL(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT VALUE.
C                --------------
 100  CONTINUE
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. N ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKEDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE
C
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ. 1)  WRITE(*,30000) I,(IA(ik),ik=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(ik),ik=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(ik),ik=I,I2)
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE
      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,KL,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     KL      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,KL,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,KL
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))
C
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE TEMPEXP(K,IERR )
C
C**** *TEMPEXP*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR TEMP DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *TEMPEXP(K,IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATUM(I,J,K)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*9 CVAL,CIDENT,YSNAME
      CHARACTER*24 CUNIT
C
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h'
      INCLUDE 'comsh.h'
      INCLUDE 'comshc.h'
C
      DIMENSION PRESL(11),PRESU(12)
C
      DATA PRESL/100000.,92500.,85000.,70000.,50000.,40000.,30000,
     1            25000.,20000.,15000.,10000./
      DATA PRESU/7000.,5000.,3000.,2000.,1000.,900.,800.,
     1            500., 400., 300., 200., 100./
C     ------------------------------------------------------------------
C*          1.   INCREASE COUNTEROF SUBSETS BY ONE.
C                ----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao
c     do compilador FORTRAN
C       N = NSUB
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------
      Ns  =NSUB  
      IREP=0
C
      do 101 i=1,jp22
      do 102 j=1,jp1
      values(i,j)=999999.
 102  continue
 101  continue
C
C*          1.1  GET CURRENT DATE (YEAR AND MONTH).
C                ----------------------------------
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C
C     ------------------------------------------------------------------
C*          2.   TEMP - LAND BASED STATION.
C                --------------------------
 200  CONTINUE
C
      IF(KDEC(4).EQ.35) THEN
C     -----------------------------------------------------------------
C*          2.1  TEMP PART A.
C                ------------
 210  CONTINUE
C
         IF(K.EQ.1) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=float(iyear)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            VALUES(16,NSUB)=999999.
            VALUES(17,NSUB)=999999.
            VALUES(18,NSUB)=999999.
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
            IREP=IREP+1
            VALUES(21,NSUB)=999999.
            IF(KDEC(25).NE.MINDIC) VALUES(21,NSUB)=KDEC(25)*10.
            VALUES(22,NSUB)=64.
            VALUES(23,NSUB)=999999.
            VALUES(24,NSUB)=999999.
            IF(KDEC(26).NE.MINDIC) VALUES(24,NSUB)=KDEC(26)/10.+273.16
            VALUES(25,NSUB)=999999.
            IF(KDEC(27).NE.MINDIC) VALUES(25,NSUB)=KDEC(27)/10.+273.16
            VALUES(26,NSUB)=999999.
            IF(KDEC(28).NE.MINDIC) VALUES(26,NSUB)=FLOAT(KDEC(28))
            VALUES(27,NSUB)=999999.
            IF(KDEC(29).NE.MINDIC) VALUES(27,NSUB)=FLOAT(KDEC(29))
C
            IP=28
            IPKD=30
C
            DO 211 I=1,11
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+5
                                        GO TO 211
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=PRESL(I)
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC)
     1         VALUES(IP+2,NSUB)=KDEC(IPKD)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
            IP=IP+7
            IPKD=IPKD+5
C
 211        CONTINUE
C
C           TROPOPAUSE LEVEL
C
            IPKD=100
C
            DO 212 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=16.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 214
               END IF
C
 212        CONTINUE
C
 214  CONTINUE
C
C           MAX. WIND LEVEL
C
            IPKD=115
            ISHEAR=0 
C
            DO 213 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  VALUES(IP+4,NSUB)=999999.
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 215
               END IF

C
 213        CONTINUE
C
 215  CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(20,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.1) THEN
               IERR=1
               RETURN
            END IF
C
C
C           WIND SHEAR AT MAX. WIND LEVEL
C
            IPKD=115
            ISHEAR=0 
            IPTSH=IP
            VALUES(IPTSH,NSUB)=0.0
C
            DO 216 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IF(KDEC(IPKD+3).NE.MINDIC) 
     1               THEN
                        ISHEAR=ISHEAR+1
                        VALUES(IPTSH,NSUB)=FLOAT(ISHEAR) 
                        VALUES(IP+1,NSUB)=KDEC(IPKD)*10.
                        VALUES(IP+2,NSUB)=8.
                        VALUES(IP+3,NSUB)=999999.
                        IF(KDEC(IPKD+3).NE.MINDIC)
     1                  VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                        VALUES(IP+4,NSUB)=999999.
                        IF(KDEC(IPKD+4).NE.MINDIC)
     1                  VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))    
C
                        IPKD=IPKD+5
                        IP=IP+4
                     ELSE
                        GO TO 217
                     END IF
C
               ELSE
                  GO TO 217
               END IF

C
 216        CONTINUE
C
 217  CONTINUE
C
C            UPDATE M TOTAL LENGTH OF REPORT.
C            --------------------------------
      IF(ISHEAR.NE.0) IP=IP+1
      M=IP-1
C 
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*          2.2  TEMP PART C.
C                ------------
 220  CONTINUE
C
         IF(K.EQ.3) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=FLOAT(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            VALUES(16,NSUB)=999999.
            VALUES(17,NSUB)=999999.
            VALUES(18,NSUB)=999999.
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
C
            IP=21
            IPKD=30
C
            DO 221 I=1,14
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+5
                                        GO TO 221
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=PRESU(I)
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC)
     1       VALUES(IP+2,NSUB)=KDEC(IPKD)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
            IP=IP+7
            IPKD=IPKD+5
C
 221        CONTINUE
C
C           TROPOPAUSE LEVEL
C
            IPKD=100
C
            DO 222 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=16.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 224
               END IF
C
 222        CONTINUE
C
 224  CONTINUE
C
C           MAX. WIND LEVEL
C
            IPKD=115
C
            DO 223 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  VALUES(IP+4,NSUB)=999999.
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 225
               END IF

C
 223        CONTINUE
C
 225  CONTINUE
C
            VALUES(20,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C
C           WIND SHEAR AT MAX. WIND LEVEL
C
            IPKD=115
            ISHEAR=0 
            IPTSH=IP
            VALUES(IPTSH,NSUB)=0.0
C
            DO 226 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IF(KDEC(IPKD+3).NE.MINDIC) 
     1               THEN
                        ISHEAR=ISHEAR+1
                        VALUES(IPTSH,NSUB)=FLOAT(ISHEAR) 
                        VALUES(IP+1,NSUB)=KDEC(IPKD)*10.
                        VALUES(IP+2,NSUB)=8.
                        VALUES(IP+3,NSUB)=999999.
                        IF(KDEC(IPKD+3).NE.MINDIC)
     1                  VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                        VALUES(IP+4,NSUB)=999999.
                        IF(KDEC(IPKD+4).NE.MINDIC)
     1                  VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))    
C
                        IPKD=IPKD+5
                        IP=IP+4
                     ELSE
                        GO TO 227
                     END IF
C
               ELSE
                  GO TO 227
               END IF

C
 226        CONTINUE
C
 227  CONTINUE
C
C     UPDATE M
C
      IF(ISHEAR.NE.0) IP=IP+1
      M=IP-1
C 
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*          2.3  TEMP PART B.
C                ------------
 230  CONTINUE
C
         IF(K.EQ.2) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            IF(KDEC(423).NE.MINDIC) VALUES( 3,NSUB)=KDEC(423)
            VALUES( 4,NSUB)=999999.
            IF(KDEC(422).NE.MINDIC) VALUES( 4,NSUB)=KDEC(422)
            VALUES( 5,NSUB)=FLOAT(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=1.
            VALUES(15,NSUB)=15.
            IF(KDEC(386).NE.MINDIC) VALUES(15,NSUB)=FLOAT(KDEC(386))
            VALUES(16,NSUB)=999999.
            IF(KDEC(388).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(388))
            VALUES(17,NSUB)=999999.
            IF(KDEC(387).NE.MINDIC) THEN
                                    CALL IC513(KDEC(387),KOUT)
                                    VALUES(17,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(18,NSUB)=999999.
            IF(KDEC(389).NE.MINDIC) THEN
                                    CALL IC515(KDEC(389),KOUT)
                                    VALUES(18,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(19,NSUB)=999999.
            IF(KDEC(390).NE.MINDIC) THEN
                                    CALL IC509(KDEC(390),KOUT)
                                    VALUES(19,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(20,NSUB)=999999.
C
C           TEMPERATURE SIGNIFICANCE
C
            IP=21
            IPKD=25
C
            DO 231 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 231
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            sign=4.
            if(ipkd.eq.25) sign=68.
            VALUES(IP+1,NSUB)=sign
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            VALUES(IP+6,NSUB)=999999.
C
            IP=IP+7
            IPKD=IPKD+3
C
 231        CONTINUE
C
C           WIND SIGNIFICANCE
C
C
            IPKD=206
C
            DO 232 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 232
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            sign=2.
            if(ipkd.eq.206) sign=66.
            VALUES(IP+1,NSUB)=sign
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            VALUES(IP+4,NSUB)=999999.
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+7
            IPKD=IPKD+3
C
 232        CONTINUE
C
            IPKD=392
C
            DO 233 I=1,4
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+6
                                        GO TO 233
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=6.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+2,NSUB)=KDEC(IPKD+1)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+3)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+4))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+5).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+5))
C
            IP=IP+7
            IPKD=IPKD+6
C
 233        CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(20,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*           2.4 TEMP PART D.
C                ------------
 240  CONTINUE
C
         IF(K.EQ.4) THEN
            VALUES( 1,NSUB)=(KINT(12)-48)*10+KINT(13)-48
            VALUES( 2,NSUB)=(KINT(14)-48)*100+(KINT(15)-48)*10
     1                      +KINT(16)-48
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=FLOAT(IYEAR)
            VALUES( 6,NSUB)=FLOAT(IMONTH)
            VALUES( 7,NSUB)=FLOAT(KDEC(1))
            VALUES( 8,NSUB)=FLOAT(KDEC(2))
            VALUES( 9,NSUB)=FLOAT(KDEC(9))
            VALUES(10,NSUB)=KDEC(5)/100.
            VALUES(11,NSUB)=KDEC(6)/100.
            VALUES(12,NSUB)=999999.
            IF(KDEC(8).NE.MINDIC) VALUES(12,NSUB)=FLOAT(KDEC(8))
            VALUES(13,NSUB)=999999.
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            VALUES(16,NSUB)=999999.
            VALUES(17,NSUB)=999999.
            VALUES(18,NSUB)=999999.
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
c
c           temperature significance
C
            IP=21
            IPKD=25
C
            DO 241 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 241
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=4.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            VALUES(IP+6,NSUB)=999999.
C
            IP=IP+7
            IPKD=IPKD+3
C
 241        CONTINUE
C
C           WIND SIGNIFICANCE
C
            IPKD=206
C
            DO 242 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 242
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            VALUES(IP+4,NSUB)=999999.
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+7
            IPKD=IPKD+3
C
 242        CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(20,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C
            RETURN
                    END IF
                  END IF
C     -----------------------------------------------------------------
C*          3.   TEMP - SHIP/DROP REPORTS.
C                -------------------------
 300  CONTINUE
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
C     -----------------------------------------------------------------
C*          3.1  TEMP PART A.
C                ------------
 310  CONTINUE
C
         IF(K.EQ.1) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(kint(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=999999.
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
            VALUES(13,NSUB)=999999.
            IF(KDEC(4).EQ.137) THEN
               IF(KDEC(8).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(8))
            ELSEIF(KDEC(4).EQ.36) THEN
               DO 291 I=1,100
               IF(YSNAME(I).EQ.CVAL(NSUB)) VALUES(13,NSUB)=SHGT(I)
 291           CONTINUE
            END IF
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            VALUES(16,NSUB)=999999.
            VALUES(17,NSUB)=999999.
            VALUES(18,NSUB)=999999.
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
            VALUES(21,NSUB)=999999.
            IREP=IREP+1
            VALUES(22,NSUB)=999999.
            IF(KDEC(25).NE.MINDIC) VALUES(22,NSUB)=KDEC(25)*10.
            VALUES(23,NSUB)=64.
            VALUES(24,NSUB)=999999.
            VALUES(25,NSUB)=999999.
            IF(KDEC(26).NE.MINDIC) VALUES(25,NSUB)=KDEC(26)/10.+273.16
            VALUES(26,NSUB)=999999.
            IF(KDEC(27).NE.MINDIC) VALUES(26,NSUB)=KDEC(27)/10.+273.16
            VALUES(27,NSUB)=999999.
            IF(KDEC(28).NE.MINDIC) VALUES(27,NSUB)=FLOAT(KDEC(28))
            VALUES(28,NSUB)=999999.
            IF(KDEC(29).NE.MINDIC) VALUES(28,NSUB)=FLOAT(KDEC(29))
C
            IP=29
            IPKD=30
C
            DO 311 I=1,11
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+5
                                        GO TO 311
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=PRESL(I)
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC) 
     1       VALUES(IP+2,NSUB)=KDEC(IPKD)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
            IP=IP+7
            IPKD=IPKD+5
C
 311        CONTINUE
C
C           TROPOPAUSE LEVEL
C
            IPKD=100
C
            DO 312 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=16.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 314
               END IF
C
 312        CONTINUE
C
 314  CONTINUE
C
C           MAX. WIND LEVEL
C
            IPKD=115
C
            DO 313 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  VALUES(IP+4,NSUB)=999999.
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 315
               END IF

C
 313        CONTINUE
C
 315  CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(21,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.1) THEN
               IERR=1
               RETURN
            END IF
C
C
C           WIND SHEAR AT MAX. WIND LEVEL
C
            IPKD=115
            ISHEAR=0 
            IPTSH=IP
            VALUES(IPTSH,NSUB)=0.0
C
            DO 316 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IF(KDEC(IPKD+3).NE.MINDIC) 
     1               THEN
                        ISHEAR=ISHEAR+1
                        VALUES(IPTSH,NSUB)=FLOAT(ISHEAR) 
                        VALUES(IP+1,NSUB)=KDEC(IPKD)*10.
                        VALUES(IP+2,NSUB)=8.
                        VALUES(IP+3,NSUB)=999999.
                        IF(KDEC(IPKD+3).NE.MINDIC)
     1                   VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                        VALUES(IP+4,NSUB)=999999.
                        IF(KDEC(IPKD+4).NE.MINDIC)
     1                  VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))    
C
                        IPKD=IPKD+5
                        IP=IP+5
                     ELSE
                        GO TO 317
                     END IF
C
               ELSE
                  GO TO 317
               END IF

C
 316        CONTINUE
C
 317  CONTINUE
C
C     UPDATE M TOTAL LENGTH OF REPORT
C
      M=IP-1
C 
C
            RETURN
                    END IF
C
C     -----------------------------------------------------------------
C*          3.2  TEMP PART C.
C                ------------
 320  CONTINUE
C
         IF(K.EQ.3) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(kint(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=999999.
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
            VALUES(13,NSUB)=999999.
            IF(KDEC(4).EQ.137) THEN
               IF(KDEC(8).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(8))
            ELSEIF(KDEC(4).EQ.36) THEN
               DO 292 I=1,100
               IF(YSNAME(I).EQ.CVAL(NSUB)) VALUES(13,NSUB)=SHGT(I)
 292           CONTINUE
            END IF
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=999999.
            VALUES(16,NSUB)=999999.
            VALUES(17,NSUB)=999999.
            VALUES(18,NSUB)=999999.
            VALUES(19,NSUB)=999999.
            VALUES(20,NSUB)=999999.
            VALUES(21,NSUB)=999999.
C
            IP=22
            IPKD=30
C
            DO 321 I=1,14
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+5
                                        GO TO 321
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=PRESU(I)
            VALUES(IP+1,NSUB)=32.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD).NE.MINDIC)
     1       VALUES(IP+2,NSUB)=KDEC(IPKD)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
            IP=IP+7
            IPKD=IPKD+5
C
 321        CONTINUE
C
C           TROPOPAUSE LEVEL
C
            IPKD=100
C
            DO 322 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=16.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
                  VALUES(IP+4,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+3).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+3))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+4).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+4))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 324
               END IF
C
 322        CONTINUE
C
 324  CONTINUE
C
C           MAX. WIND LEVEL
C
            IPKD=115
C
            DO 323 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IREP=IREP+1
                  VALUES(IP,NSUB)=KDEC(IPKD)*10.
                  VALUES(IP+1,NSUB)=8.
                  VALUES(IP+2,NSUB)=999999.
                  VALUES(IP+3,NSUB)=999999.
                  VALUES(IP+4,NSUB)=999999.
                  VALUES(IP+5,NSUB)=999999.
                  IF(KDEC(IPKD+1).NE.MINDIC)
     1               VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
                  VALUES(IP+6,NSUB)=999999.
                  IF(KDEC(IPKD+2).NE.MINDIC)
     1               VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
                  IPKD=IPKD+5
                  IP=IP+7
               ELSE
                  GO TO 325
               END IF

C
 323        CONTINUE
C
 325  CONTINUE
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(21,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C           WIND SHEAR AT MAX. WIND LEVEL
C
            IPKD=115
            ISHEAR=0 
            IPTSH=IP
            VALUES(IPTSH,NSUB)=0.0
C
            DO 326 I=1,3
C
            IF(KDEC(IPKD).NE.MINDIC)
     1         THEN
                  IF(KDEC(IPKD+3).NE.MINDIC) 
     1               THEN
                        ISHEAR=ISHEAR+1
                        VALUES(IPTSH,NSUB)=FLOAT(ISHEAR) 
                        VALUES(IP+1,NSUB)=KDEC(IPKD)*10.
                        VALUES(IP+2,NSUB)=8.
                        VALUES(IP+3,NSUB)=999999.
                        IF(KDEC(IPKD+3).NE.MINDIC)
     1                   VALUES(IP+3,NSUB)=FLOAT(KDEC(IPKD+3))
                        VALUES(IP+4,NSUB)=999999.
                        IF(KDEC(IPKD+4).NE.MINDIC)
     1                  VALUES(IP+4,NSUB)=FLOAT(KDEC(IPKD+4))    
C
                        IPKD=IPKD+5
                        IP=IP+5
                     ELSE
                        GO TO 327
                     END IF
C
               ELSE
                  GO TO 327
               END IF

C
 326        CONTINUE
C
 327  CONTINUE
C
C     UPDATE M
C
      M=IP-1
C 
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*          3.3  TEMP PART B.
C                ------------
 330  CONTINUE
C
         IF(K.EQ.2) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(kint(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            IF(KDEC(423).NE.MINDIC) VALUES(4,NSUB)=KDEC(423)
            VALUES( 5,NSUB)=999999.
            IF(KDEC(422).NE.MINDIC) VALUES(5,NSUB)=KDEC(422)
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
            VALUES(13,NSUB)=999999.
            IF(KDEC(4).EQ.137) THEN
               IF(KDEC(8).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(8))
            ELSEIF(KDEC(4).EQ.36) THEN
               DO 293 I=1,100
               IF(YSNAME(I).EQ.CVAL(NSUB)) VALUES(13,NSUB)=SHGT(I)
 293           CONTINUE
            END IF
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=1.
            VALUES(16,NSUB)=999999.
            IF(KDEC(386).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(386))
            VALUES(17,NSUB)=999999.
            IF(KDEC(388).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(388))
            VALUES(18,NSUB)=999999.
            IF(KDEC(387).NE.MINDIC) THEN
                                    CALL IC513(KDEC(387),KOUT)
                                    VALUES(18,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(19,NSUB)=999999.
            IF(KDEC(389).NE.MINDIC) THEN
                                    CALL IC515(KDEC(389),KOUT)
                                    VALUES(19,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(20,NSUB)=999999.
            IF(KDEC(390).NE.MINDIC) THEN
                                    CALL IC509(KDEC(390),KOUT)
                                    VALUES(20,NSUB)=FLOAT(KOUT)
                                    END IF
C
            VALUES(21,NSUB)=999999.
C
C           TEMPERATURE SIGNIFICANCE
C
            IP=22
            IPKD=25
C
            DO 331 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 331
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            sign=4.
            if(ipkd.eq.25) sign=68.
            VALUES(IP+1,NSUB)=sign
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            VALUES(IP+6,NSUB)=999999.
C
            IP=IP+7
            IPKD=IPKD+3
C
 331        CONTINUE
C
C           WIND SIGNIFICANCE
C
C
            IPKD=206
C
            DO 332 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 332
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            sign=2.
            if(ipkd.eq.206) sign=66.
            VALUES(IP+1,NSUB)=sign
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            VALUES(IP+4,NSUB)=999999.
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+7
            IPKD=IPKD+3
C
 332        CONTINUE
C
            IPKD=392
C
            DO 333 I=1,4
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+6
                                        GO TO 333
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=6.
            VALUES(IP+2,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+2,NSUB)=KDEC(IPKD+1)*9.8
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+3).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+3)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+4).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+4))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+5).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+5))
C
            IP=IP+7
            IPKD=IPKD+6
C
 333        CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(21,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C
            RETURN
                    END IF
C     -----------------------------------------------------------------
C*           3.4 TEMP PART D.
C                ------------
 340  CONTINUE
C
         IF(K.EQ.4) THEN
            VALUES( 1,NSUB)=1000*NSUB+9
            CVAL(NSUB)=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1                 CHAR(KINT(15))//CHAR(kint(16))//'    '
            VALUES( 2,NSUB)=999999.
            VALUES( 3,NSUB)=999999.
            VALUES( 4,NSUB)=999999.
            VALUES( 5,NSUB)=999999.
            VALUES( 6,NSUB)=FLOAT(IYEAR)
            VALUES( 7,NSUB)=FLOAT(IMONTH)
            VALUES( 8,NSUB)=FLOAT(KDEC(1))
            VALUES( 9,NSUB)=FLOAT(KDEC(2))
            VALUES(10,NSUB)=FLOAT(KDEC(9))
            VALUES(11,NSUB)=KDEC(5)/100.
            VALUES(12,NSUB)=KDEC(6)/100.
            VALUES(13,NSUB)=999999.
            IF(KDEC(4).EQ.137) THEN
               IF(KDEC(8).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(8))
            ELSEIF(KDEC(4).EQ.36) THEN
               DO 294 I=1,100
               IF(YSNAME(I).EQ.CVAL(NSUB)) VALUES(13,NSUB)=SHGT(I)
 294           CONTINUE
            ELSE
            END IF
            VALUES(14,NSUB)=999999.
            VALUES(15,NSUB)=1.
            VALUES(16,NSUB)=999999.
            IF(KDEC(386).NE.MINDIC) VALUES(16,NSUB)=FLOAT(KDEC(386))
            VALUES(17,NSUB)=999999.
            IF(KDEC(388).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(388))
            VALUES(18,NSUB)=999999.
            IF(KDEC(387).NE.MINDIC) THEN
                                    CALL IC513(KDEC(387),KOUT)
                                    VALUES(18,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(19,NSUB)=999999.
            IF(KDEC(389).NE.MINDIC) THEN
                                    CALL IC515(KDEC(389),KOUT)
                                    VALUES(19,NSUB)=FLOAT(KOUT)
                                    END IF
            VALUES(20,NSUB)=999999.
            IF(KDEC(390).NE.MINDIC) THEN
                                    CALL IC509(KDEC(390),KOUT)
                                    VALUES(20,NSUB)=FLOAT(KOUT)
                                    END IF
C
            VALUES(21,NSUB)=999999.
C
c
c           temperature significance
C
            IP=22
            IPKD=25
C
            DO 341 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 341
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=4.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+3,NSUB)=KDEC(IPKD+1)/10.+273.16
            VALUES(IP+4,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+4,NSUB)=KDEC(IPKD+2)/10.+273.16
            VALUES(IP+5,NSUB)=999999.
            VALUES(IP+6,NSUB)=999999.
C
            IP=IP+7
            IPKD=IPKD+3
C
 341        CONTINUE
C
C           WIND SIGNIFICANCE
C
            IPKD=206
C
            DO 342 I=1,60
C
            IF(KDEC(IPKD).EQ.MINDIC) THEN
                                        IPKD=IPKD+3
                                        GO TO 342
                                     END IF
            IREP=IREP+1
            VALUES(IP,NSUB)=KDEC(IPKD)*10.
            VALUES(IP+1,NSUB)=2.
            VALUES(IP+2,NSUB)=999999.
            VALUES(IP+3,NSUB)=999999.
            VALUES(IP+4,NSUB)=999999.
            VALUES(IP+5,NSUB)=999999.
            IF(KDEC(IPKD+1).NE.MINDIC)
     1         VALUES(IP+5,NSUB)=FLOAT(KDEC(IPKD+1))
            VALUES(IP+6,NSUB)=999999.
            IF(KDEC(IPKD+2).NE.MINDIC)
     1         VALUES(IP+6,NSUB)=FLOAT(KDEC(IPKD+2))
C
            IP=IP+7
            IPKD=IPKD+3
C
 342        CONTINUE
C
C
C           UPDATE REPLICATION FACTOR
C
            VALUES(21,NSUB)=FLOAT(IREP)
            M=IP-1
C
C           CHECK IF THERE ARE ANY USEFUL DATA
C
            IF(IREP.EQ.0) THEN
               IERR=1
               RETURN
            END IF
C
C
C
            RETURN
           END IF
          END IF
C
      RETURN
      END
      
      SUBROUTINE IC509(KN,KOUT)
C
C**** *IC509*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO MAKE CONVERSION OF CODE FIGURS
C         FROM CODE TABLE 509  TO *BUFR* CODE TABLE 020012.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC509(KN,KOUT)*
C
C                *KN*      - INPUT CODE FIGURE
C                *KOUT*    - CONVERTED CODE FIGURE ON OUTPUT
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION I509(10)
      DIMENSION I20012(10)

C
      DATA I509/0,1,2,3,4,5,6,7,8,9/
      DATA I20012/10,11,12,13,14,15,16,17,18,19/
C
C     ------------------------------------------------------------------
C
C*          1.   FIND CORRESPONDING CODE FIGURE OF 020012 CODE TABLE
C                ---- ------------- ---- ------ -- ------ ---- -----
 100  CONTINUE
C
      DO 101 J=1,10
C
      IF(I509(J).EQ.KN) THEN
                           KOUT=I20012(J)
                           RETURN
                        END IF
C
 101  CONTINUE
C
      KOUT=63
C
      RETURN
      END
      
      SUBROUTINE IC513(KN,KOUT)
C
C**** *IC513*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO MAKE CONVERSION OF CODE FIGURS
C         FROM CODE TABLE 513  TO *BUFR* CODE TABLE 020012.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC513(KN,KOUT)*
C
C                *KN*      - INPUT CODE FIGURE
C                *KOUT*    - CONVERTED CODE FIGURE ON OUTPUT
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION I513(10)
      DIMENSION I20012(10)
C
      DATA I513/0,1,2,3,4,5,6,7,8,9/
      DATA I20012/30,31,32,33,34,35,36,37,38,39/
C
C     ------------------------------------------------------------------
C
C*          1.   FIND CORRESPONDING CODE FIGURE OF 020012 CODE TABLE
C                ---- ------------- ---- ------ -- ------ ---- -----
 100  CONTINUE
C
      DO 101 J=1,10
C
      IF(I513(J).EQ.KN) THEN
                           KOUT=I20012(J)
                           RETURN
                        END IF
C
 101  CONTINUE
C
      KOUT=63
C
      RETURN
      END
      
      SUBROUTINE IC515(KN,KOUT)
C
C**** *IC515*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO MAKE CONVERSION OF CODE FIGURS
C         FROM CODE TABLE 515  TO *BUFR* CODE TABLE 020012.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC515(KN,KOUT)*
C
C                *KN*      - INPUT CODE FIGURE
C                *KOUT*    - CONVERTED CODE FIGURE ON OUTPUT
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION I515(10)
      DIMENSION I20012(10)
C
      DATA I515/0,1,2,3,4,5,6,7,8,9/
      DATA I20012/20,21,22,23,24,25,26,27,28,29/
C
C     ------------------------------------------------------------------
C
C*          1.   FIND CORRESPONDING CODE FIGURE OF 020012 CODE TABLE
C                ---- ------------- ---- ------ -- ------ ---- -----
 100  CONTINUE
C
      DO 101 J=1,10
C
      IF(I515(J).EQ.KN) THEN
                           KOUT=I20012(J)
                           RETURN
                        END IF
C
 101  CONTINUE
C
      KOUT=63
C
      RETURN
      END
      
      SUBROUTINE BUFRENC(IERR )
C
C**** *BUFRENC*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL TEMP
C         REPORT FROM FULLY EXPANDED BUFR FORMAT INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUFRENC(IERR)*
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SETWT(IERR)*   
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1(IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3(IERR)*
C         *CALL* *SEC4(IERR)*
C         *CALL* *SEC5(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C           1.1 SET WORKING TABLES AND BUFR SECTION DATA.
C               -----------------------------------------
 110  CONTINUE
C
      CALL SETWT( IERR )
      CALL SEC0 ( IERR )
      CALL SEC1 ( IERR )
      CALL SEC2 ( IERR )
      CALL SEC3 ( IERR )
      CALL SEC4 ( IERR )
      CALL SEC5 ( IERR )
C
      CALL PUTBUFR( IERR )
C     ------------------------------------------------------------------
C
      RETURN
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT,24)
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1( IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      RYEAR=VALUES(5,1) 
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) RYEAR=VALUES(6,1)
      IYEAR=RYEAR
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100.)
      if (iyear .eq. 0) iyear=100
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      IMONTH=VALUES(6,1)
      IF(KDEC(4).EQ.36.OR.
     1   KDEC(4).EQ.135.OR.KDEC(4).EQ.137) IMONTH=VALUES(7,1)
C
      CALL PACK(NBPW,MBUF(NWPT),IMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      IDAY=VALUES(7,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IDAY=VALUES(8,1)
C
      CALL PACK(NBPW,MBUF(NWPT),IDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      IHOUR=VALUES(8,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IHOUR=VALUES(9,1)
C
      CALL PACK(NBPW,MBUF(NWPT),IHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                -------------
 1400 CONTINUE
C
      IMIN=VALUES(9,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IMIN=VALUES(10,1)
C
      CALL PACK(NBPW,MBUF(NWPT),IMIN,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt = 0
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---- -------- -- --- -------- -- --- -------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY ( 48 BYTES ).
C                ----------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3(IERR )
C
C**** *SEC3*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),Ns,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS WHICH DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     TEMP- LAND STATION
C
      IF(KDEC(4).EQ.35) THEN
         CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),9,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
         IF(LSHEAR) THEN
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),61,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),62,NWPT,NBPT, 8)
         END IF
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 161 I=M+1,M+M
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161     CONTINUE
C
         IF(IBIT1.EQ.0) GO TO 175
C
         MQ=M+4
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2) 
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  7,NWPT,NBPT, 8)
C
 175     CONTINUE
C
C        CHECK IF SUBTITUTION PERFORMED.
C
         M2=M*2
         M3=M*3
         IBIT1=0
         DO 162 I=M2+1,M3
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 162     CONTINUE
C
         IF(IBIT1.EQ.0) GO TO 170
C
         MSS=M+8
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 23,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),000,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2) 
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 23,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),255,NWPT,NBPT, 8)
C
         GO TO 170
      END IF
C
C     TEMP - SHIP
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
         IF(KDEC(4).EQ.36) THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),9,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),196,NWPT,NBPT, 8)
         END IF
         IF(KDEC(4).EQ.135) THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),9,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),194,NWPT,NBPT, 8)
         END IF
         IF(KDEC(4).EQ.137) THEN
            CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),9,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),195,NWPT,NBPT, 8)
         END IF
         IF(LSHEAR) THEN
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),4,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),8,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),61,NWPT,NBPT, 8)
c
            CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
            CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
            CALL PACK(NBPW,MBUF(NWPT),62,NWPT,NBPT, 8)
         END IF
C
C        CHECK IF Q/C PERFORMED.
C
         IBIT1=0
         DO 163 I=M+1,M+M
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 163     CONTINUE
C
         IF(IBIT1.EQ.0) GO TO 176
C
         MQ=M+4
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 22,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
c
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 33,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  7,NWPT,NBPT, 8)
C
 176     CONTINUE
C
C
C        CHECK IF SUBTITUTION PERFORMED.
C
         M2=M*2
         M3=M*3
         IBIT1=0
         DO 164 I=M2+1,M3
            IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 164     CONTINUE
C
         IF(IBIT1.EQ.0) GO TO 170
C
         MSS=M+8
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 23,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),000,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2) 
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT),  1,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  0,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 31,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 8)
C
         CALL PACK(NBPW,MBUF(NWPT),  2,NWPT,NBPT, 2)
         CALL PACK(NBPW,MBUF(NWPT), 23,NWPT,NBPT, 6)
         CALL PACK(NBPW,MBUF(NWPT),255,NWPT,NBPT, 8)
C
      END IF
C
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC4( IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      DO 201 I=1,Ns
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
C
      IF(YUNIT.EQ.'CCITTIA5') THEN
         IST=NINT(VAL)/1000
         NCHAR=NINT(VAL)-IST*1000
         YVAL=CVAL(IST)
         DO 203 II=1,NCHAR
         IPACK=ICHAR(YVAL(II:II))
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203     CONTINUE
         GO TO 202
      END IF
C
      IF(VAL.EQ.999999.) THEN
         CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
      ELSE
         IF(ISCALE.LT.0) THEN
            ISCALE=IABS(ISCALE)
            IPACK=NINT(VAL/10.**ISCALE) - IREF
         ELSE
            IPACK=NINT(VAL*10.**ISCALE) - IREF
         END IF
C
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
      END IF
C
 202  CONTINUE
C
      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.031031) THEN
C 
c          set replication factor for bit presence indicator
c
           CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT,16)
C
C          SET BIT FLAG
C
           DO 215 JI=M+1,M+M
            IPACK=1
            IF(VALUES(JI,I).NE.999999.) IPACK=0
            CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
 215       CONTINUE
C           
        END IF
C
       IF(IREV.EQ.001031) THEN
          VAL=46.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10.**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10.**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
       IF(IREV.EQ.001032) THEN
          VAL=999999.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10.**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10.**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
       IF(IREV.EQ.001201) THEN
          VAL=1.
          IF(VAL.EQ.999999.) THEN
             CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
          ELSE
             IF(ISCALE.LT.0) THEN
                ISCALE=IABS(ISCALE)
                IPACK=NINT(VAL/10.**ISCALE) - IREF
             ELSE
                IPACK=NINT(VAL*10.**ISCALE) - IREF
             END IF
C
             CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.033007) THEN
C
C          SET REPLICATION FACTOR FOR % CONFIDENCE
C
C
           IBIT1=0
           DO 217 IK=M+1,M+M
            IF(VALUES(IK,I).NE.999999.) IBIT1=IBIT1+1
 217       CONTINUE
C
           CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT,16)
C
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10.**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10.**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 216       CONTINUE
C
        END IF
C
 210    CONTINUE
C
      END IF
C
C*            3. SUBSTITUTED VALUES.
C                -------------------
 300  CONTINUE
C
      I031002=0
      IF(M.LT.MSS) THEN
C
        DO 310 J=M+5,MSS      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
C       031002 IS EXTENDED DELAYED REPLICATION FACTOR
C
        IF(IREV.EQ.031002.AND.I031002.EQ.0) THEN
C 
           I031002=1
c          set replication factor for data present indicator
c          for substituted values
c
c
           CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT,IBDW)
C
C          SET BIT FLAG
C
           IBIT1=0
C
           M2=M*2
           M3=M*3
           DO 315 JI=M2+1,M3
            IPACK=1
            IF(VALUES(JI,I).NE.999999.) IPACK=0
            CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
 315       CONTINUE
C           
           GO TO 310
C
        END IF
        IF(IREV.EQ.001031) THEN
C 
C          SET GENERATING CENTER
C
           CALL PACK(NBPW,MBUF(NWPT),98,NWPT,NBPT,IBDW)
C
        END IF
        IF(IREV.EQ.001032.OR.IREV.EQ.001201) THEN
C 
C          SET GENERATING APPLICATION
C
C          255 - MISSING VALUE( ALL BITS SET TO ONE)
C
           CALL PACK(NBPW,MBUF(NWPT),10,NWPT,NBPT,IBDW)
C
        END IF
C
C       EXTENDED DELAYED REPLICATION FACTOR  FOR MARKER OPERATOR
C       223255
C
        IF(IREV.EQ.031002.AND.I031002.EQ.1) THEN
           IBIT1=0
           M2=M*2
           M3=M*3
           DO 417 IK=M2+1,M3
            IF(VALUES(IK,I).NE.999999.) IBIT1=IBIT1+1
 417       CONTINUE
C
           CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT,IBDW)
C
C          PACK SUBSTITUTED VALUES
C
           M2=M*2
           M3=M*3
           J1=0
           DO 418 JI=M2+1,M3
           J1=J1+1
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 418
C
           IREF  =IWTRV(J1)
           ISCALE=IWTS (J1)
           IBDW  =IWTDW(J1)
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10.**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10.**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 418       CONTINUE
C
        END IF
C
 310    CONTINUE
C
      END IF
C
 201  CONTINUE
C
C     ------------------------------------------------------------------
C*         12.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 1200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 1300 CONTINUE
C
      RETURN
      END
      SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         croot='./'
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
      
C
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
C      
      END

      SUBROUTINE SETWT(IERR)
C
C**** *SETWT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWT(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
C
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
C
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      
      DIMENSION ITBTRL(40),ITBTRS(41),ITBTRA(JP22)
C
      DATA ITBTRL/001001,001002,002011,002012,004001 
     1,           004002,004003,004004,004005,005001
     2,           006001,007001,020010,008002,020011 
     3,           020013,020012,020012,020012,031001
     4,           007004,008001,010003,012001,012003
     5,           011001,011002,031001,007004,008001
     6,           011061,011062,031031,001031,001201
     7,           033007,031002,001031,001201,031002/
      DATA ITBTRS/001011,001012,001013,002011,002012
     1,           004001,004002,004003,004004,004005
     2,           005002,006002,007001,020010,008002,020011 
     3,           020013,020012,020012,020012,031001
     4,           007004,008001,010003,012001,012003
     5,           011001,011002,031001,007004,008001
     6,           011061,011062,031031,001031,001201
     7,           033007,031002,001031,001201,031002/
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR TEMP DATA.
C                ------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      LSHEAR=.FALSE.
C
      IF(KDEC(4).EQ.35) THEN
            j=0
c
            DO 101 I=1,20
            j=j+1
            itbtra(j)=itbtrl(i)
 101        continue
c  
            jj=21
c
            irep=NINT(values(20,nsub))
c
            do 102 i=1,irep
c
            j=j+1
            itbtra(j)=itbtrl(jj  )
            j=j+1
            itbtra(j)=itbtrl(jj+1)
            j=j+1
            itbtra(j)=itbtrl(jj+2)
            j=j+1
            itbtra(j)=itbtrl(jj+3)
            j=j+1
            itbtra(j)=itbtrl(jj+4)
            j=j+1
            itbtra(j)=itbtrl(jj+5)
            j=j+1
            itbtra(j)=itbtrl(jj+6)
C
 102        continue
c
            is=irep*7+20
            if(is.lt.m)
     1         then
                  lshear=.true. 
                  j=j+1
                  itbtra(j)=itbtrl(28)
                  iptsh=is+1
                  ireps=NINT(values(iptsh,nsub))
c
                  jj=29
c
                  do 103 i=1,ireps
                  j=j+1
                  itbtra(j)=itbtrl(jj  )
                  j=j+1
                  itbtra(j)=itbtrl(jj+1)
                  j=j+1
                  itbtra(j)=itbtrl(jj+2)
                  j=j+1
                  itbtra(j)=itbtrl(jj+3)
 103              continue
c
               end if
C
C           ADD QUALETY CONTROL DECSCRIPTORS.
C
            J=J+1
            ITBTRA(J)=ITBTRL(33)
            J=J+1
            ITBTRA(J)=ITBTRL(34)
            J=J+1 
            ITBTRA(J)=ITBTRL(35)
            J=J+1 
            ITBTRA(J)=ITBTRL(36)
C
C           ADD SUBSTITUTED VALUES DECSRIPTOR
C
            J=J+1
            ITBTRA(J)=ITBTRL(37)
            J=J+1 
            ITBTRA(J)=ITBTRL(38)
            J=J+1 
            ITBTRA(J)=ITBTRL(39)
            J=J+1
            ITBTRA(J)=ITBTRL(40)
C
            GO TO 110
         END IF
C
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
            J=0
c
            DO 111 I=1,21
            j=j+1
            itbtra(j)=itbtrs(i)
 111        continue
c  
            jj=22
c
            irep=NINT(values(21,nsub))
c
            do 112 i=1,irep
c
            j=j+1
            itbtra(j)=itbtrs(jj  )
            j=j+1
            itbtra(j)=itbtrs(jj+1)
            j=j+1
            itbtra(j)=itbtrs(jj+2)
            j=j+1
            itbtra(j)=itbtrs(jj+3)
            j=j+1
            itbtra(j)=itbtrs(jj+4)
            j=j+1
            itbtra(j)=itbtrs(jj+5)
            j=j+1
            itbtra(j)=itbtrs(jj+6)
C
 112        continue
c
            is=irep*7+21
            if(is.lt.m)
     1         then
                  lshear=.true.
                  j=j+1
                  itbtra(j)=itbtrs(29)
                  iptsh=is+1
                  ireps=NINT(values(iptsh,nsub))
c
                  jj=30
c
                  do 113 i=1,ireps
                  j=j+1
                  itbtra(j)=itbtrs(jj  )
                  j=j+1
                  itbtra(j)=itbtrs(jj+1)
                  j=j+1
                  itbtra(j)=itbtrs(jj+2)
                  j=j+1
                  itbtra(j)=itbtrs(jj+3)
 113              continue
c
               end if
C
C           ADD QUALETY CONTROL DECSCRIPTORS.
C
            J=J+1
            ITBTRA(J)=ITBTRS(34)
            J=J+1
            ITBTRA(J)=ITBTRS(35)
            J=J+1 
            ITBTRA(J)=ITBTRS(36)
            J=J+1 
            ITBTRA(J)=ITBTRS(37)
C
C           ADD SUBSTITUTED VALUE DECSCRIPTORS.
C
            J=J+1
            ITBTRA(J)=ITBTRS(38)
            J=J+1 
            ITBTRA(J)=ITBTRS(39)
            J=J+1 
            ITBTRA(J)=ITBTRS(40)
            J=J+1
            ITBTRA(J)=ITBTRS(41)
C
         END IF
C
 110  CONTINUE
C
      IF(KDEC(4).EQ.135) ITBTRA(1)=001194
      IF(KDEC(4).EQ.137) ITBTRA(1)=001195
C
      DO 121 I=1,J
C
      ITR=ITBTRA(I)
c
      DO 122 II=1,JP2
C
      IF(ITR.EQ.NTABBTR(II)) THEN
                               IWTR (I)=NTABBTR(II)
                               IWTS (I)=NTABBS (II)
                               IWTDW(I)=NTABBDW(II)
                               IWTRV(I)=NTABBRV(II)
                               CUNIT(I)=CTABBU(II)
                               GO TO 121
                            END IF
C
 122  CONTINUE
C
      PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 121  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PUTBUFR( IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      parameter (idime=19)
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
      include 'comrec.h'
      include 'comdate.h'
C
c
      character*99 recwriten,records_writen(500)
      character*80 yfilename
      character*21 ysd
c
      common /comaux/ yfilename,ysd
      common /recwriten/ irecswriten
      common /repetida/ irepetida
c
      CHARACTER*15000 YOUT
      CHARACTER*9 CIDENT
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      CHARACTER*16 YTYPE,CFNAME
      CHARACTER*16 YTIME
      CHARACTER*29 YCFNAME
C
      character*11 ctabname
      character*17 ctstamp
      character*4  cstream
      character*6  cc
C
      dimension iflags(idime)
      DIMENSION IKEY(12),IKEYOLD(12)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)
c
      data iflags/1,1,1,1,1,1,2,2,2,2,9*0/
C     ------------------------------------------------------------------
C*          1. DEFINE RDB Empress table name.
C                ---------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      ierr=0
      
c      call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
       nmonth = nm
       nday = nd
       nhour = nh
       nminute = nmin
       nsecond = nsec
c      icen = ny*.01        
c      NY=NY - (icen *100) 
C
      WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101) 
     1      NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND

      ctabname='TEMP_'//ytime(1:8)
      GO TO 102
C
 101  CONTINUE
C
      PRINT*,'BAD DATE OR TIME. REPORT SKIPPED. IOS=',IOS
      RETURN
C
 102  CONTINUE
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)
c
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      YKEY(13:13)=CIDENT(1:1)
      YKEY(17:17)=CIDENT(5:5)
      YKEY(18:18)=CIDENT(4:4)
      YKEY(19:19)=CIDENT(3:3)
      YKEY(20:20)=CIDENT(2:2)
      YKEY(21:24)=' '
      YKEY(25:32)=' '
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
C
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN) 
                  END IF
C
c       CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc)
C
      iyyy=ny
      imo=nm
      idd=nd
      ihh=nh
      imm=nmin
      iss=nsec
C
c      print*,iyyy,imo,idd
c
C
C       SET LENGTH OF RECORD
C
      IW=9
      IBT=0
C
      CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)      
C
C        SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C       SET TIME BULLETIN WAS RECEIVED
C
c     read(ctstamp,'(4x,4i2)') nrday,nrhour,nrmin,nrsec
C
      CALL PACK(32,IKEY(IW),NRDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NRMIN,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRSEC,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(1),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(1),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(2),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(2),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(3),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(3),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORN(4),IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NPART(4),IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,IW,IBT,8)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,24)      
C
C
C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
c
C     WORD 8 BIT 16 (atencao meio de palavra 9)
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c      pass = 9
c      do 10 ii = 1,41,4
c        pass = pass + 1
c         do 20 jj = 1,4
c            yout(((pass*4+1)-jj):((pass*4+1)-jj)) =
c     *       ckey_aux(((ii-1)+jj):((ii-1)+jj))
c 20   continue  
c 10   continue
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c

      yout(84:84) = ckey(47:47)
      yout(83:83) = ckey(48:48)
      mbuf(1)=ilength
C
C
C*          3.  WRITE REPORT INTO RDB.
C               ----------------------        
 300  CONTINUE
C
      ila=11
      ilo=12
      if(nsbtype.eq.101) then
         ila=10
         ilo=11 
      end if

      ierr=0
C
C     -----------------------------------------------------------------
      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      kcount = irecswriten
      recwriten = yfilename // ysd
      do 11 i=1,irecswriten
         if(records_writen(i)(1:99).eq.recwriten(1:99)) then
            irecswriten = i
            go to 12
         end if
 11   continue
 12   irec = irecswriten
      if(irec.lt.kcount) then
        kcount = kcount - 1
        irecswriten = kcount
	irepetida = irepetida + 1
      else
        records_writen(irec)(1:99) = recwriten(1:99)
      end if
      if (ilength .gt. 2500) then
      print*, ilength
      
      else
      WRITE(99,'(a)',rec=irec,err=13,iostat=ierr) YOUT(5:ilength+4)
      endif
      go to 400
 13   print*,'Erro na gravacao do registro = ',ierr, ilength
C     -----------------------------------------------------------------
 400  CONTINUE
c
      RETURN
      END
      
      SUBROUTINE KTOMPSI(IA)
C
C**** *KTOMPSI*
C
C
C     PURPOSE.
C     --------
C
C         CONVERTS KNOTS TO METRES PER SECOND, ROUNDING
C         TO NEAREST METRE.
C
C         INPUT    :  IA WIND SPEED IN KNOTS (INTEGER)
C
C         OUTPUT   :  IA WIND SPEED IN M/S (INTEGER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KTOMPSI(IA)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.   CONVERT WIND IN KNOTS TO METER PER SECOND .
C                -------------------------------------------
 100  CONTINUE
C
C
      IA=INT(0.5148 * IA +0.5)
      RETURN
      END
      
      FUNCTION P(Z)
C
      DATA A/5.252368255329/, B/44330.769230769/
      DATA  C/0.000157583169442/
      DATA  PTRO/226.547172/, PO/1013.25/
C
      IF (Z.GT.11000.) GO TO 50
      Y = 1.-Z/B
      P = PO*(Y**A)
      RETURN
C
50    Y = -C*(Z-11000.)
      P = PTRO*EXP(Y)
      RETURN
      END
      
      SUBROUTINE SAVBULL ( IERR )
C
C**** *SAVBULL*
C
C
C     PURPOSE.
C     --------
C
C         WRITE COMPLETE BULLETIN TO ERROR FILE .
C
C         BULLETIN IN KCHAR(1)-KCHAR(IGS) IN CCITT 5.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVBULL(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
C
      CHARACTER*80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
      YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
c
      ierr = 1
c
C
      OTEMP=.FALSE.
      OIMPT=.FALSE.
C
      IF(KDEC(4).EQ.35.OR.KDEC(4).EQ.36.OR.
     1   KDEC(4).EQ.135.OR.KDEC(4).EQ.137) OTEMP=.TRUE.
C
      IF(OTEMP) THEN
         IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
            OIMPT=.TRUE. 
            GO TO 110
         ELSE
            DO 101 I=1,2000
            IF(KINT(4).NE.IMPSTA(I)) GO TO 101
            OIMPT=.TRUE.
            GO TO 110
 101        CONTINUE
C
            IF(KERR.GT.1.AND.KERR.GE.4) OIMPT=.TRUE.        
C
         END IF
      END IF
C
      YLINE=' '
      YLINEA=' '
C
      IUNIT=11
      IF(OIMPT) IUNIT=10
C
C
      IF(OIMPT) THEN
         OPEN(UNIT=IUNIT,IOSTAT=IOS,ERR=400,
     C     FILE='TEMP_IMPORTANT.error.dat',
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,
     C     RECL=80                      )
C
      ELSE
         OPEN(UNIT=IUNIT,IOSTAT=IOS,ERR=400,
     C     FILE='TEMP.error.dat',
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,
     C     RECL=80                      )
C
      END IF  
  
      IP = 1
      JP = IP
      J = IGS
C
C*          1.1  OUTPUT INITIAL CONTROL CHARACTERS.
C                ----------------------------------
 110  CONTINUE
C
      CALL NEXTPRT (JP,IGS)
      K = JP - IP
      N1 = 0
      DO 111 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
                                   YLINEA(N1:N1)=Y63
                                   ISIGN=1
                                   KCHAR(IP)=KCHAR(IP).AND.127
                                          END IF
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
  111 CONTINUE
C
      WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
      YLINE=' '
      YLINEA=' '
C
 120  CONTINUE
C
      CALL NEXTPRT (IP,J)
      IF (IP .GT. J) GO TO 400
      JP = IP
      CALL NEXTEND (JP,J)
      CALL NEXTPRT (JP,J)
      K = JP - IP
      N1 = 0
      DO 112 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127 )
     C                      THEN
                               YLINEA(N1:N1) = Y63
                               ISIGN= 1
                               KCHAR(IP) = KCHAR(IP).AND.127
                            END IF
C
      YLINE(N1:N1) = CHAR(KCHAR(IP))
      IP = IP + 1
C
  112 CONTINUE
C
      WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
C
      YLINE=' '
      YLINEA=' '
C
      GO TO 120
C
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS
 400  CONTINUE
C
      WRITE(IUNIT,'(A)') YGS
      CLOSE(IUNIT) 
C
C     REMOVE PARITY BIT
C
      DO 410 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 410  CONTINUE
C
      RETURN

      END
      
      SUBROUTINE SAVREP ( IHEAD,IERR)
C
C**** *SAVREP*
C
C
C     PURPOSE.
C     --------
C
C         WRITE REPORT IN ERROR TO THE ERROR FILE.
C
C                 IHEAD = 0 , WRITE BULLETIN HEADER AND ERROR REPORT
C                             TO ERROR FILE.
C                       = 1 , WRITE ERROR REPORT ONLY.
C                       = 2 , WRITE 'GS' CHARACTER AT END.
C
C                 IERR NOT USED.
C
C                 IHEAD SET TO 1 IF HEADER WRITTEN , OTHERWISE
C                       UNCHANGED.
C
C                 IERR SET TO -1 , IF ERROR IN WRITE , OTHERWISE
C                       UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVREP(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
      DIMENSION ISTART(4),IFIN(4)
C
      CHARACTER *80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS 
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
c
      ierr = 1
c
C
      OTEMP=.FALSE.
      OIMPT=.FALSE.
C
      IF(KDEC(4).EQ.35.OR.KDEC(4).EQ.36.OR.
     1   KDEC(4).EQ.135.OR.KDEC(4).EQ.137) OTEMP=.TRUE.
C
      IF(OTEMP) THEN
         IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.KDEC(4).EQ.137) THEN
            OIMPT=.TRUE. 
            GO TO 110
         ELSE
            DO 101 I=1,2000
            IF(KINT(4).NE.IMPSTA(I)) GO TO 101
            OIMPT=.TRUE.
            GO TO 110
 101        CONTINUE
C
            IF(KERR.GT.1.AND.KERR.GE.4) OIMPT=.TRUE.        
C
         END IF
      END IF
C
 110  CONTINUE
C
      YLINE=' '
      YLINEA=' '
C
      IF(OIMPT) THEN
         OPEN(UNIT=10,IOSTAT=IOS,ERR=400,
     C     FILE='TEMP_IMPORTANT.error.dat',
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,
     C     RECL=80                      )
C
      ELSE
         OPEN(UNIT=11,IOSTAT=IOS,ERR=400,
     C     FILE='TEMP.error.dat',
     C     ACCESS='APPEND', 
     C     STATUS='UNKNOWN',
     C     CARRIAGECONTROL='LIST',
     C     SHARED,
     C     RECL=80                      )
C
      END IF
C
      IUNIT=11
      IF(OIMPT) IUNIT=10 
C
C*          1.2  WRITE BULLETIN HEADER TO ERROR
C                ------------------------------
C                FILE IF NOT ALREADY DONE.
C                -------------------------
 120  CONTINUE
C
      IF ( IHEAD.NE.0 ) GO TO 130
C
C
      ISTART(1) = 1
      ISTART(2) = ISL
      ISTART(3) = IAH
      ISTART(4) = IMI
C
      IFIN(1) = ISL
      IFIN(2) = IAH
      IFIN(3) = JAH
      CALL NEXTEND(IFIN(3),IGS)
      CALL NEXTPRT(IFIN(3),IGS)
      IFIN(4) = JMI
      CALL NEXTEND(IFIN(4),IGS)
      CALL NEXTPRT(IFIN(4),IGS)
C
      IP = 0
      N2 = 0
C
      IHEAD = 1
C
      NN = 3
C
      DO 121 N=1,NN
         K = IFIN(N) - ISTART(N)
         if(k.gt.80) k=80
         DO 122 N1=1,K
            N2 = N2 + 1
            IP = IP + 1
            IF (KCHAR(IP).GT.127)
     C                      THEN
                                YLINEA(N2:N2) = Y63
                                ISIGN=1
                                KCHAR(IP)=KCHAR(IP).AND.127
                            END IF
C
            YLINE(N2:N2) = CHAR(KCHAR(IP))
C
  122    CONTINUE
C
c
         if(k.le.2) go to 18
c
C
      WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N2)
      IF(ISIGN.EQ.1) THEN
         WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N2)
         ISIGN=0
      END IF
C
 18   continue
c
         YLINE=' '
         YLINEA=' '
C
      N2 = 0
C
  121 CONTINUE
C
C
C*           1.3   WRITE ERROR REPORT , IF REQUIRED.
C                 ---------------------------------
 130  CONTINUE
C
      IF ( IHEAD.EQ.2 ) GO TO 140
C
C
C     AVOID WRITING REPORT TWICE IF MIMIMJMJ  LINE IS
C     MISSING.
C
      IF ( IAH.EQ.KPT ) RETURN
C
C     AVOID WRITING MIMIMJMJ TWICE ( CORRUPT MIMIMJMJ CAN BE TAKEN
C     AS STATION NUMBER )
C
      IF ( KPT.LT.IFIN(4) ) KPT = IFIN(4)
C
C
      IP = KPT
      IF(KDEC(4) .EQ. 35 .OR. KDEC(4) .EQ. 36) IP = IMI
      IF(KDEC(4) .EQ.135 .OR. KDEC(4) .EQ.137) IP = IMI
      IF(KDEC(4) .EQ. 32 .OR. KDEC(4) .EQ. 33) IP = IMI
      J = IEQ+ 3
      IF ( J.GT.IGS) J = IGS
C
  133 CALL NEXTPRT (IP,J)
      IF (IP.GT.J) THEN
         CLOSE(11)
         RETURN
      END IF
      JP = IP
      CALL NEXTEND(JP,J)
      CALL NEXTPRT(JP,J)
      K= JP - IP 
      if(k.gt.80) k=80
      N1 = 0
      DO 131 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
              YLINEA(N1:N1) = Y63
              ISIGN= 1
              KCHAR(IP) = KCHAR(IP).AND.127
         END IF
C
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
 131  CONTINUE
C
c
         if(k.le.2) go to 19
c
      WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
c
      YLINE=' '
      YLINEA=' '
C
C
      GO TO 133
C
C
C*              1.4 WRITE 'GS' AT END OF BULLETIN.
C                   ------------------------------
 140  CONTINUE
C
      YLINE(1:4)= YGS
C
      WRITE (IUNIT,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:4)
C
C
      CLOSE(IUNIT)
C  
      GO TO 400
C     ----------------------------------------------------------------
 300  CONTINUE
C
      IERR = -1
      PRINT*,'ERROR IN WRITING INTO ERROR FILE IOS=',IOS
C     ----------------------------------------------------------------
 400  CONTINUE
C
C     REMOVE PARITY BIT
C
      DO 500 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRSTA (IPART,IMARK,IFIRST,NUMBER)
C
C**** *ERRSTA*
C
C
C     PURPOSE.
C     --------
C
C         COUNTS THE NUMBER OF ERRORS IN THE REPORT
C         COUNTS THE NUMBER OF ERRORS IN THE DECODING JOB
C         MARKS THE ERROR BIT TO KDEC
C         ADDS ?-MARK TO KCHAR AT THE ERRONEUS GROUP
C
C         INPUT     : IPART    - INDICATOR OF NOER
C                                (IN TEMPS  3 = A, 4 = B, 5 = C, 6 = D)
C                     IMARK    = 1 IF ? IS TO BE ADDED TO ERRONEUS GROUP
C                     IFIRST   = O IF FIRST DECODING ATTEMPT OF THE REPORT
C                              = 1 OTHERWISE
C                     NUMBER   - NUMBER OF ERRORS IN THE REPORT SO FAR
C
C         OUTPUT    : NUMBER   - NEW NUMBER OF ERRORS
C                     NOER     - NUMBER OF ERRONEUS REPORT (INCREASED BY 1
C                                IF THE FIRST ERROR IN THE REPORT)
C                     KDEC(20) - ERROR BITS
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRSTA(IPART,IMARK,IFIRST,NUMBER)*
C
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  NOV.83
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
C     ------------------------------------------------------------------
C

 100  CONTINUE
C
      IF(NUMBER .GE. 0) NUMBER = NUMBER + 1
      IF ( IFIRST.EQ.0 )
     C   THEN
            IF(NUMBER .EQ. 1)
     C          NUMRERR(IPART)=NUMRERR(IPART) + 1
            NOER(IPART,KERR)=NOER(IPART,KERR) + 1
            KERBIT =ISHFT(KDEC(20),1-KERR) .AND. 1
            IF(KERBIT .EQ. 0) KDEC(20) = KDEC(20) + 2**(KERR-1)
         END IF
C
      IPT = IABS(IPT)
      IF(IMARK .EQ. 1) KCHAR(IPT) = KCHAR(IPT) .OR. 128
      IF(IMARK .EQ. 2)
     C   THEN
            NPT = IPT
            CALL NEXSEP2(NPT,IEQ,*200)
            CALL PREPRT(NPT,IMI,*200)
            KCHAR(NPT) = KCHAR(NPT) .OR. 128
         END IF
C
200   CONTINUE
C
      RETURN
      END
      
      SUBROUTINE REMEEE
C
C**** *REMEEE*
C
C
C     PURPOSE.
C     --------
C
C         HANDLE TYPING ERRORS CORRECTED BY THE 'E E E'
C         PROCEDURE AS SPECIFIED IN GTS MANUAL.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *REMEEE*
C
C         INPUT     : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                     1 CHARACTER PER WORD.
C
C         OUTPUT    : E'S , ERRONEUS CHARACTERS AND REPEATED GROUPS REPLACED
C                     BY SPACE CHARACTERS. THESE ARE IGNORED IN SCANNING
C                     ROUTINES.
C
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C*          1.  CHECK FOR 'E E E'. 'EEE' IS ACCEPTED EVEN
C               THOUGH THIS MAY BE  AMBIGUOUS WITH A SYNOP '333' GROUP IN
C               LETTER SHIFT. FREQUENTLY  ONLY 1 OR 2 'E'S MAY BE USED.
C               THESE ALSO CATERED FOR.
 100  CONTINUE
C
C     SKIP PAST SHIP'S CALL SIGN AND LOCATE 'E' IF ANY EXISTS.
C
      I = IPT + 4
      N = 69
      CALL NEXTVAL(I,N,IEQ)
      IF(I .GT. IEQ) RETURN
C
C     'E' CHARACTER FOUND. REPLACE 'E' AND ANY FOLLOWING 'E'S BY SPACES
C     E.G.  40118 7012EE 40118 70500  BECOMES
C           40118 7012   40118 70500 .
C
      K = I
      CALL NEXTFIG(K,IEQ)
      IF(K .GE. IEQ) RETURN
C
            DO 101 J=I,K-1
               IF((KCHAR(J) .NE. 10) .AND. (KCHAR(J) .NE. 13))
     1             KCHAR(J) = 32
101         CONTINUE
C
C     SET POINTER TO CHARACTER BEFORE THE 'E'. CHANGE
C     THIS CHARACTER TO A 'SPACE'.
C       E.G.  40118 7012   40118 70500  BECOMES
C             40118 701    40118 70500 .
C
      N = I - 1
      IF((KCHAR(N) .NE. 10) .AND. (KCHAR(N) .NE. 13))
     1    KCHAR(N) = 32
C
C     SCANNING BACKWARDS REPLACE CHARACTERS BY 'SPACE'
C     UNTIL A 'SPACE' CHARACTER IS ENCOUNTERED.
C        E.G.  40118 701    40118 70500  BECOMES
C              40118        40118 70500 .
C
      DO 102 I=N-1,IPT,-1
          IF(KCHAR(I) .EQ. 32) GO TO 300
          IF((KCHAR(I) .NE. 10) .AND. (KCHAR(I) .NE. 13))
     1        KCHAR(I) = 32
  102 CONTINUE
C
C     NO CHARACTER FOUND
C
      GO TO 100
C
C     ---------------------------------------------------------------------
C*           3. 'I' NOW POINTS TO THE 'SPACE' AFTER LAST FIGURE OF THE GROUP
C               BEFORE THE SERIES OF SPACES AND 'K' POINTS TO FIRST FIGURE
C               OF FOLLOWING GROUP. IF THESE GROUPS ARE THE SAME REMOVE
C               ONE GROUP (SECOND).
C               E.G.  40118        40118 70500  BECOMES
C                     40118              70500 .
C
 300  CONTINUE
C
      I = I - 5
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   N = K + 4
                   DO 301 I=K,N
                       KCHAR(I) = 32
  301              CONTINUE
               END IF
C
C
C*           4.  SOMETIMES MORE THAN 1 GROUP HAS TO BE DELETED
C                E.G.  40118 59623 7012EE 40118 70500 .
C                THIS WILL NOW HAVE BECOME
C                40118 59623        40118         AND POINTERS ARE
C                      I            K
C                40118 59623 NEED TO BE REMOVED.
 400  CONTINUE
C
      I = I - 6
      N = K - 1
      IF((KCHAR(I)   .EQ. KCHAR(K))   .AND.
     1   (KCHAR(I+1) .EQ. KCHAR(K+1)) .AND.
     2   (KCHAR(I+2) .EQ. KCHAR(K+2)) .AND.
     3   (KCHAR(I+3) .EQ. KCHAR(K+3)) .AND.
     4   (KCHAR(I+4) .EQ. KCHAR(K+4)))
     5         THEN
                   DO 401 J=I,N
                       KCHAR(J) = 32
  401              CONTINUE
               END IF
C
C     GO BACK TO BEGINNING OF SUBROUTINE TO FIND OUT
C     IF THERE ARE MORE 'E'-CORRECTIONS.
C
      GO TO 100
C
      END
      
      SUBROUTINE NEXTMI(I,J,II)
C
C**** *NEXTMI*
C
C
C     PURPOSE.
C     --------
C
C         TO FIND NEXT MIMIMJMJ GROUP IN THE BULLETIN.
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT GROUP OF
C         ('TTAA' OR 'TTBB' OR 'TTCC' OR 'TTDD' ETC.)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTMI(I,J,II)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C
C         OUTPUT    : II- POSITION OF THE FIRST CHARACTER
C                         IN REQUIRED GROUP
C                         IF CHARACTER NOT FOUND II = 99999
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c		none.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION MIMJ(26)
C
C
      DATA MIMJ /65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
     &           80,81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C*          1.   FIND NEXT MIMIMJMJ GROUP.
C                -------------------------
 100  CONTINUE
C
C
      II=9999
      K =IABS(I)
      M =IABS(I)
C
 101  CONTINUE
C
      CALL NEXSEP2(M,J,*1000)
      CALL NEXPRT2(M,J,*1000)
C
      IF(M.GE.J) RETURN
C
      K1= KCHAR(M  )
      K2= KCHAR(M+1)
      K3= KCHAR(M+2)
      K4= KCHAR(M+3)
C
      DO 102 n=1,26
C
      IF(K1.EQ.MIMJ(n).AND.K2.EQ.MIMJ(n))
     &   THEN
C
            DO 103 nn=1,26
C
            IF(K3.EQ.MIMJ(nn).AND.K4.EQ.MIMJ(nn))
     &         THEN
                  CALL PRESEP(M,K,*1000)
                  CALL PREPRT(M,K,*1000)
                  II= M+1
                  RETURN
               END IF
C
 103        CONTINUE
C
         END IF
C
 102  CONTINUE
C
       GO TO 101
C
 1000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATIM(YDATE)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'comdate.h'
      
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c       print*,iyear,imonth,iday,ihour,imin,isec
C
C
C
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      IF(IDAY.GE.IDD) THEN
                         IMM=IMONTH
                         IYY=IYEAR
                         ima=imonth
                         RETURN
                      END IF
C
      IF(IDAY.LT.IDD) THEN
                         IF(IMONTH.EQ.1) THEN
                                            IMM=12
                                            IYY=IYEAR-1
                                            RETURN
                                         END IF
                         IMM=IMONTH-1
                         IYY=IYEAR
                      END IF
C
      RETURN
      END
      
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C     
      include 'comdate.h'
      integer date_time (8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt. 1 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)
      else
c             PRINT*,'Passando a data'

             read(arg(1:4),'(i4.4)') ny
             read(arg(5:6),'(i2.2)') nm
             read(arg(7:8),'(i2.2)') nd
             read(arg(9:10),'(i2.2)') nh
             read(arg(11:12),'(i2.2)') nmin
             nutc = 0
             nsec = 0
             ncc = 0
             date_time(1) = ny
             date_time(2) = nm
             date_time(3) = nd
             date_time(4) = nutc
             date_time(5) = nh
             date_time(6) = nmin
             date_time(7) = nsec
             date_time(8) = ncc
            
      end if
c      print*,ny,nm,nd,nutc,NH,NMIN,NSEC,ncc
C----------------------------------------------------------------
      RETURN
      END      

      SUBROUTINE MRGTEM( IERR)
C
C**** *MRGTEM*
C
C
C     PURPOSE.
C     --------
C         MERGE TEPM PARTS A, B, C AND D INTO SINGLE OBSERVATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *MRGTEM( IERR )*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          Rosangela Cintra     *CPTEC*       11.2000
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h'
      INCLUDE 'comdate.h' 
C
      DIMENSION OCONT(4),VALUESA(1300),VALUESB(1300),VALUESC(1300)
      DIMENSION PRESS(600),INX(600),INXA(600)
      DIMENSION ITEML(1000),YSHNAM(300),cvala(10),IDM(12)
C
      CHARACTER CVAL*9,CVALA*9,CUNIT*24,YSHNAM*9,CIDENT*9
      CHARACTER*2 YMONTH,YDAY,YHOUR,YMIN
      character*4  year
      CHARACTER*80 YFILENAME
      character*3 cmonth(12)
      character*25 ct,current      
      CHARACTER*21 YSD
C
      DATA ITEML/1000*999999/,YSHNAM/300*'       '/
      DATA VALUESA/1300*0.0/,PRESS/600*0.0/,INX/600*0/,INXA/600*0/
      data valuesb/1300*0.0/,valuesc/1300*0.0/
      DATA LSHEAR/.FALSE./
      DATA IDM/31,28,31,30,31,30,31,31,30,31,30,31/
      data cmonth/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
c
      structure /merge/
         character*21 STATION_DATE
         logical*1 Oocont(4)
         integer*4 Nncorn(4)
         integer*4 Mma
         real      Vvaluesa(1300)
         integer*4 Iilenc
         character*9 Ccvala(10)
      end structure
c
      record /merge/ old_temp
c
      common /comaux/ yfilename,ysd
c
C     ------------------------------------------------------------------
C
C*          1.   SET UP RECORD NUMBER FOR DIRECT ACCESS.
C                ---------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C  
      IREPP=21
      IF(KDEC(4).EQ.35) IREPP=20
C
      IREPP1=IREPP+1
C
      ocont(1)=.false.
      ocont(2)=.false.
      ocont(3)=.false.
      ocont(4)=.false.
C
      NCORN(1)=0
      NCORN(2)=0
      NCORN(3)=0
      NCORN(4)=0
C
      NPART(1)=0
      NPART(2)=0
      NPART(3)=0
      NPART(4)=0
      nsub=1
c
C
C*          1.1  READ IN PREVIOUS REPORT IF ANY.
C                --------------------------------
 110  CONTINUE
C
C     DEFINE FILE NAME
C
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c      print*,'imonth',imonth
      write(current(1:2),'(i2.2)') iday
      current(3:3)='-'
      current(4:6)=cmonth(imonth)
      current(7:7)='-'
      write(current(8:11),'(i4)') iyear
      current(12:12)=' '
      write(current(13:14),'(i2.2)') ihour
      current(15:15)=':'
      write(current(16:17),'(i2.2)') imin
      current(18:18)=':'
      write(current(19:20),'(i2.2)') isec
      current(21:21)='.'
      write(current(22:24),'(i3.3)') imili
c      print *,'current= ',current
      
      IYEAR=VALUES(5,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) iyear=VALUES(6,1)
c      print*,'iyear ',kdec(4),iyear
c      icen = (iyear * .01)
c      IYEAR=iYEAR - (icen * 100.)      
      IMONTH=VALUES(6,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IMONTH=VALUES(7,NSUB)
      IDAY=VALUES(7,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IDAY=VALUES(8,NSUB)
      IHOUR=VALUES(8,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IHOUR=VALUES(9,NSUB)
      Imin=VALUES(9,1)
      IF(KDEC(4).EQ.36.OR.KDEC(4).EQ.135.OR.
     1   KDEC(4).EQ.137) IMIN=VALUES(10,NSUB)
c
      write(ct(1:2),'(i2.2)') iday
      ct(3:3)='-'
      ct(4:6)=cmonth(imonth)
      ct(7:7)='-'
      write(ct(8:11),'(i4)') iyear
      ct(12:12)=' '
      write(ct(13:14),'(i2.2)') ihour
      ct(15:15)=':'
      write(ct(16:17),'(i2.2)') imin
      ct(18:18)=':'
      write(ct(19:20),'(i2.2)') 0
      ct(21:21)='.'
      write(ct(22:23),'(i2.2)') 0
c      print*,'ct= ',ct
c
      
      call istime(current,nm1,iret)
      call istime(ct,nm0,iret)
c
      idf=nm1-nm0
c
      if(idf.le.0) then
         print*,' mrgtemp: data for future',ct
         ierr=1
         return
      end if
C
 115  CONTINUE
C
      WRITE(YEAR,'(I4.4)') IYEAR
      WRITE(YMONTH,'(I2.2)') IMONTH
      WRITE(YDAY,'(I2.2)') IDAY
      WRITE(YHOUR,'(I2.2)') IHOUR
      WRITE(YMIN,'(I2.2)') IMIN
C
      OLD_TEMP.STATION_DATE=' '
C
      IF(KDEC(4).EQ.35) THEN
       ISTNO=NINT(VALUES(1,NSUB))*1000+NINT(VALUES(2,NSUB))
       WRITE(OLD_TEMP.STATION_DATE(1:5),'(I5.5)') ISTNO
      ELSE
         OLD_TEMP.STATION_DATE(1:9)=CVAL(1)
      END IF
C
      OLD_TEMP.STATION_DATE(10:21)=YEAR//YMONTH//YDAY//YHOUR//YMIN
c      print*,OLD_TEMP.STATION_DATE(10:21)
      YSD(1:21)=OLD_TEMP.STATION_DATE
C
      YFILENAME='TEMP'//YEAR//YMONTH//YDAY//'MERGE'
C
      OPEN(UNIT=7,IOSTAT=IOS,ERR=120,FILE=YFILENAME,
     1            organization='relative',
     2            FORM='UNFORMATTED',
     4            RECL=1400,
     5            STATUS='UNKNOWN')
C
      ios = 0
      irderr = 0
      irecnum = 0
c      print*,'read1',old_temp.station_date
      call read_seq(7,irderr,ios,irecnum,old_temp.station_date,
     1             yfilename,old_temp)
      if (irderr.ne.0) go to 130
C
      DO 12 I=1,4
      OCONT(I)=OLD_TEMP.OOCONT(I)
      NCORN(I)=OLD_TEMP.NNCORN(I)
 12   CONTINUE
C
      MA=OLD_TEMP.MMA
C
      DO 13 I=1,1300
      VALUESA(I)=OLD_TEMP.VVALUESA(I)
 13   CONTINUE
C
      ILENC=OLD_TEMP.IILENC
C
      DO 14 I=1,10
      CVALA(I)=OLD_TEMP.CCVALA(I)
 14   CONTINUE
C
      GO TO 200
C
 120  CONTINUE
C
C     IF FILE DOES NOT EXIST CREATE ONE AND WRITE A RECORD
C
      print*,'Open error on ',yfilename,' is ',ios
c
      IF(IOS.EQ.127) THEN   
         OPEN(UNIT=7,IOSTAT=IOS,ERR=120,FILE=YFILENAME,
     1            organization='relative',
     2            FORM='UNFORMATTED',
     4            RECL=1400,
     5            STATUS='new')
C
         MA=M
         ILENC=1
         CVALA(1)=CVAL(1)
         DO 121 I=1,M
         VALUESA(I)=VALUES(I,NSUB)
 121     CONTINUE
C
         GO TO 200
      END IF
C
      PRINT*,'FILE NAME=',YFILENAME 
      WRITE(*,9901) IOS
      call exit(2)
C
 130  CONTINUE
C
C     IF RECORD DOES NOT EXIST WRITE THE RECORD
C
      IF(IOS.EQ.36) THEN
         MA=M
         ILENC=1
         CVALA(1)=CVAL(1)
         DO 131 I=1,M
         VALUESA(I)=VALUES(I,NSUB)
 131     CONTINUE
C
         GO TO 200
C
      END IF
C
      WRITE(*,9902) IOS
      IERR=1
      RETURN
C
C     ------------------------------------------------------------------
C*           2. MERGE NEW AND OLD REPORT.
C               -------------------------
 200  CONTINUE
C
      IF(KDEC(23).EQ.1.AND.OCONT(1).EQ..TRUE.) THEN
         IF(KDEC(21).LE.NCORN(1)) THEN
            GO TO 231
         ELSE
            NCORN(1)=KDEC(21)
            GO TO 230
         END IF 
      END IF
      IF(KDEC(23).EQ.1.AND.OCONT(1).EQ..FALSE.) THEN
         NCORN(1)=KDEC(21)
         OCONT(1)=.TRUE.
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.2.AND.OCONT(2).EQ..TRUE.) THEN
         IF(KDEC(21).LE.NCORN(2)) THEN
            GO TO 231
         ELSE
            NCORN(2)=KDEC(21)
            GO TO 230
         END IF 
      END IF
      IF(KDEC(23).EQ.2.AND.OCONT(2).EQ..FALSE.) THEN
         NCORN(2)=KDEC(21)
         OCONT(2)=.TRUE.
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.3.AND.OCONT(3).EQ..TRUE.) THEN
         IF(KDEC(21).LE.NCORN(3)) THEN
            GO TO 231
         ELSE
            NCORN(3)=KDEC(21)
            GO TO 230
         END IF 
      END IF
      IF(KDEC(23).EQ.3.AND.OCONT(3).EQ..FALSE.) THEN
         NCORN(3)=KDEC(21)
         OCONT(3)=.TRUE.
         GO TO 230
      END IF
C
      IF(KDEC(23).EQ.4.AND.OCONT(4).EQ..TRUE.) THEN
         IF(KDEC(21).LE.NCORN(4)) THEN
            GO TO 231
         ELSE
            NCORN(4)=KDEC(21)
            GO TO 230
         END IF 
      END IF
      IF(KDEC(23).EQ.4.AND.OCONT(4).EQ..FALSE.) THEN
         NCORN(4)=KDEC(21)
         OCONT(4)=.TRUE.
         GO TO 230
      END IF
C     -----------------------------------------------------------------
 231  CONTINUE
C
C     IN CASE OF BRAKEDOWN THAT ALLOWS TO RECOVER.
C
      MC=MA
      DO 232 ISS=1,MA
      VALUESC(ISS)=VALUESA(ISS)
 232  CONTINUE
      GO TO 400
C     -----------------------------------------------------------------
 230  CONTINUE
C
      MB=M+MA-IREPP
C
      is=0
      isa=0
      isb=0

      IF(VALUES(IREPP,NSUB).NE.999999.)
     .   IS=NINT(VALUES(IREPP,NSUB))*7+IREPP
      IF(VALUESa(IREPP).eq.999999.) print*,is
      IF(VALUESA(Irepp).NE.999999.)ISA=NINT(VALUESA(IREPP))*7+IREPP
C
C     COPY VALUESA INTO VALUESB
C
C     INSTRUMENTATION IS REPORTED ONLY IN PART B.
      DO 203 I=1,5
      IF(VALUESA(I).NE.999999.) VALUES(I,NSUB)=VALUESA(I)
      IF(VALUES(I,NSUB).NE.999999.) VALUESA(I)=VALUES(I,NSUB)
 203  CONTINUE
C
      J=0
      DO 201 I=1,ISA
      J=J+1
      VALUESB(J)=VALUESA(I)
 201  CONTINUE
C
C     COPY VALUES INTO VALUESB
C
      DO 202 I=IREPP1,IS
      J=J+1
      VALUESB(J)=VALUES(I,NSUB)
 202  CONTINUE

C
C     UPDATE NUMBER OF LEVELS
C
      IF(VALUESA(Irepp).NE.999999.)
     .   VALUESB(IREPP)=VALUES(IREPP,NSUB)+VALUESA(IREPP)
C
      IF(VALUESB(Irepp).NE.999999.)ISB=NINT(VALUESB(IREPP))*7+IREPP
C
C*           2.1 SORT PRESSURE LEVELS IN DESCENDING ORDER.
C                -----------------------------------------
 210  CONTINUE
C
      if (isb .gt. 1300) then
         print*,'isb= ', isb, 'irepp= ', irepp, irepp1
         print*,'values= ',VALUES(IREPP,NSUB),VALUESA(IREPP),
     .        VALUESB(IREPP)    
         print*,'j= ',j,'is ',is, 'isa ',isa
      endif 
      J=0
      DO 211 I=IREPP1,ISB,7
C
      J=J+1
      PRESS(J)=VALUESB(I)
      INX(J)=I
C
 211  CONTINUE
C
      JJ=0
      DO 212 II=1,J
C
      PMAX=PRESS(1)
      IMAX=1
C
      DO 213 I=1,J
     
      IF(PRESS(I).GT.PMAX)
     1   THEN
            PMAX=PRESS(I)
            IMAX=I
         END IF
 213  CONTINUE
C
      PRESS(IMAX)=0.0
      JJ=JJ+1
      INXA(JJ)=INX(IMAX)
 212  CONTINUE
C
C     COPY FIRST IREPP ELEMENTS OF VALUESB INTO VALUESC
C
      DO 214 I=1,IREPP
      VALUESC(I)=VALUESB(I)
 214  CONTINUE
C
C
      j1 = 0
      IJ=IREPP1
C
      DO 215 I=1,JJ
C
      J1=INXA(I)
C
      VALUESC(IJ)=VALUESB(J1)
      VALUESC(IJ+1)=VALUESB(J1+1)
      VALUESC(IJ+2)=VALUESB(J1+2)
      VALUESC(IJ+3)=VALUESB(J1+3)
      VALUESC(IJ+4)=VALUESB(J1+4)
      VALUESC(IJ+5)=VALUESB(J1+5)
      VALUESC(IJ+6)=VALUESB(J1+6)
C
      IJ=IJ+7
C
 215  CONTINUE
C
 220  CONTINUE
C
      ISC=ISB
C
C     DISCARD LEVELS WITH SAME PRESSURE
C
      ICOUN=1
      I=IREPP1
      K=15
      IF(KDEC(4).EQ.35) K=14
      IC=IREPP1
C
 250  CONTINUE
C
      K=K+7
      IF(K.GT.ISC) GO TO 260
C
      IF(VALUESC(I).EQ.VALUESC(K)) THEN
         IA=NINT(VALUESC(I+1))
         IB=NINT(VALUESC(K+1))
         IAIB=IA.OR.IB
C
         VALUESC(K +1)=FLOAT(IAIB)
         VALUESC(IC  )=VALUESC(K)
         VALUESC(IC+1)=FLOAT(IAIB)
         IF(VALUESC(K+2).NE.999999.) THEN 
            VALUESC(IC+2)=VALUESC(K+2)
         END IF
         IF(VALUESC(K+3).NE.999999.) THEN 
            VALUESC(IC+3)=VALUESC(K+3)
         END IF
         IF(VALUESC(K+4).NE.999999.) THEN 
            VALUESC(IC+4)=VALUESC(K+4)
         END IF
         IF(VALUESC(K+5).NE.999999.) THEN 
            VALUESC(IC+5)=VALUESC(K+5)
         END IF
         IF(VALUESC(K+6).NE.999999.) THEN 
            VALUESC(IC+6)=VALUESC(K+6)
         END IF
C
         I=K
         GO TO 250
C
      ELSE
C
         ICOUN=ICOUN+1
         IC=IC+7
C
         VALUESC(IC  )=VALUESC(K  )
         VALUESC(IC+1)=VALUESC(K+1)
         VALUESC(IC+2)=VALUESC(K+2)
         VALUESC(IC+3)=VALUESC(K+3)
         VALUESC(IC+4)=VALUESC(K+4)
         VALUESC(IC+5)=VALUESC(K+5)
         VALUESC(IC+6)=VALUESC(K+6)
C
         I=K
         GO TO 250
      END IF
C
 260  CONTINUE
C
C     UPDATE NUMBER OF LEVELS
C
      VALUESC(IREPP)=FLOAT(ICOUN)
      ISC=NINT(VALUESC(IREPP))*7+IREPP
      MC=ISC
C
C
 280  CONTINUE
C
C     -----------------------------------------------------------------
C*         3. ADD WIND SHEAR LEVELS IF ANY.
C             -----------------------------
 300  CONTINUE
C
      IF(IS.LT.M.OR.ISA.LT.MA)
     1   THEN
            J=ISC+1
            IF(IS.LT.M) THEN
                           IWLEVS=NINT(VALUES(IS+1,NSUB))
                           DO 262 I=IS+2,M
                           J=J+1
                           VALUESC(J)=VALUES(I,NSUB)
 262                       CONTINUE
                        END IF
C
            IF(ISA.LT.MA) THEN
                             IWLEVA=NINT(VALUESA(ISA+1))
                             DO 263 I=ISA+2,MA
                             J=J+1
                             VALUESC(J)=VALUESA(I)
 263                         CONTINUE
                          END IF
C
           IWLEVC=IWLEVS+IWLEVA
           VALUESC(ISC+1)=FLOAT(IWLEVC)
           MC=J
C
C*           3.1 SORT PRESSURE LEVELS IN DESCENDING ORDER.
C                -----------------------------------------
 310  CONTINUE
C
           J=0
           DO 311 I=ISC+2,MC,4
C
           J=J+1
           PRESS(J)=VALUESC(I)
           INX(J)=I
C
 311       CONTINUE
C
           JJ=0
           DO 312 II=1,J
C
           PMAX=PRESS(1)
           IMAX=1
C
           DO 313 I=1,J
           IF(PRESS(I).GT.PMAX)
     1        THEN
                 PMAX=PRESS(I)
                 IMAX=I
              END IF
 313       CONTINUE
C
           PRESS(IMAX)=0.0
           JJ=JJ+1
           INXA(JJ)=INX(IMAX)
 312       CONTINUE
C
           IJ=1
C
           DO 315 I=1,JJ
C
           J=INXA(I)
C
           VALUESB(IJ  )=VALUESC(J)
           VALUESB(IJ+1)=VALUESC(J+1)
           VALUESB(IJ+2)=VALUESC(J+2)
           VALUESB(IJ+3)=VALUESC(J+3)
C
           IJ=IJ+4
C
 315       CONTINUE
C
 320       CONTINUE
C
C     DISCARD LEVELS WITH SAME PRESSURE
C
           ICOUN=1
           I= 1
           K= -3
           IC=1
C
 350       CONTINUE
C
           K=K+4
           IF(K.GE.IJ) GO TO 360
C
           IF(VALUESB(I).EQ.VALUESB(K)) THEN
              IA=NINT(VALUESB(I+1))
              IB=NINT(VALUESB(K+1))
              IAIB=IA.OR.IB
C
              VALUESB(K +1)=FLOAT(IAIB)
              VALUESB(IC  )=VALUESB(K)
              VALUESB(IC+1)=FLOAT(IAIB)
              IF(VALUESB(K+2).NE.999999.) THEN 
                 VALUESB(IC+2)=VALUESB(K+2)
              END IF 
              IF(VALUESB(K+3).NE.999999.) THEN 
                 VALUESB(IC+3)=VALUESB(K+3)
              END IF
C 
              I=K
              GO TO 350
C
           ELSE
C
           ICOUN=ICOUN+1
           IC=IC+4
C
           VALUESB(IC  )=VALUESB(K  )
           VALUESB(IC+1)=VALUESB(K+1)
           VALUESB(IC+2)=VALUESB(K+2)
           VALUESB(IC+3)=VALUESB(K+3)
C
           I=K
           GO TO 350
C
        END IF
C
 360       CONTINUE
C
C     UPDATE NUMBER OF LEVELS
C
           VALUESC(ISC+1)=FLOAT(ICOUN)
           MC=NINT(VALUESC(ISC+1))*4+ISC+1
C
C
 380       CONTINUE
C
           JJ=ISC+1
C
           DO 362 II=1,I-1
           JJ=JJ+1
           VALUESC(JJ)=VALUESB(II)
 362       CONTINUE
C
      END IF
C
      ILENC=1
C
      CVALA(1)=CVAL(1)
C
C     ------------------------------------------------------------------
C*         4.  REWRITE  REPORT.
C              ----------------
 400  CONTINUE
C
      M=MC
      N=NSUB
C
      DO 401 I=1,MC
      VALUES(I,NSUB)=VALUESC(I)
 401  CONTINUE
C
      DO 402 I=1,4
      IF(OCONT(I)) then
      NPART(I)=1
      else
      npart(i)=0
      endif
 402  CONTINUE
C
                          
      OLD_TEMP.STATION_DATE=YSD
      DO 711 I=1,4
      OLD_TEMP.OOCONT(I)=OCONT(I)
      OLD_TEMP.NNCORN(I)=NCORN(I)
 711  CONTINUE
      OLD_TEMP.MMA=MC
      DO 712 I=1,1160
      OLD_TEMP.VVALUESA(I)=VALUESC(I)
 712  CONTINUE
      OLD_TEMP.IILENC=ILENC
      DO 713 I=1,10
      OLD_TEMP.CCVALA(I)=CVALA(I)
 713  CONTINUE
C
      write(7,rec=irecnum) old_temp
      close(7)

C            SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C            ----------------------------------------------
C
      NBUFTYPE=2      !   VERTICAL SOUNDINGS OTHER THEN SATELLITE 
      NTYPE=5                           ! TEMPERATURE PROFILE
      IF(KDEC(4).EQ. 35) NSBTYPE=101    ! TEMP LAND
      IF(KDEC(4).EQ. 36) NSBTYPE=102    ! TEMP SHIP
      IF(KDEC(4).EQ.135) NSBTYPE=103    ! TEMP DROP
      IF(KDEC(4).EQ.137) NSBTYPE=106    ! TEMP MOBILE
C
      IPO=5
      IF(KDEC(4).NE.35) IPO=6
      NYEAR =NINT(VALUES(IPO,1))
      NMONTH=NINT(VALUES(IPO+1,1))
      NDAY  =NINT(VALUES(IPO+2,1))
      NHOUR =NINT(VALUES(IPO+3,1))
      NMINUTE=NINT(VALUES(IPO+4,1))
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      IF(KDEC(4).EQ.35) THEN
         NLAT1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLAT
         NLON1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLON
      ELSE
         NLAT1=NINT(VALUES(11,NSUB)*10.**JSCALE)-JREFLAT
         NLON1=NINT(VALUES(12,NSUB)*10.**JSCALE)-JREFLON
      END IF 
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT=CHAR(KINT(12))//CHAR(KINT(13))//CHAR(KINT(14))//
     1       CHAR(KINT(15))//CHAR(KINT(16))//'    '
C 
      NRECR=1
C 
      RETURN
C
C
 9901 FORMAT(1H ,' ERROR DURING OPENING UNIT 7',I5)
 9902 FORMAT(1H ,' ERROR DURING READING UNIT 7',I5)

      END
      
      SUBROUTINE GETNEXT(IERR )
C
C**** *GETNEXT*
C
C
C     PURPOSE.
C     --------
C         GET NEXT MESSAGE FROM MDB.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GETNEXT(IERR )*
c
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comdate.h'
C
      character*15000 ychar
      character*25 ytime
      CHARACTER*17 CTSTAMP
      character*4 cstream
      character*78 cstr
c
      data cstr/'                   temp decoding'/
C
      DATA NSKIP/0/
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR=0
      NWPT=2
      NBPT=0
      NSUB=0
      ilenby=0 
      ychar=' '
C
c                write last time stamp processed.
c
      if(ostream) then
         nmonth = nm
         nday = nd
         nhour = nh
         nminute = nmin
         nsecond = nsec
c         call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
         WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=410)
     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
         print*,'ytime=',ytime
         WRITE(17,9906,IOSTAT=IOS,ERR=410)
     1      CSTR,CSTREAM,CTSTAMP,YTIME
C
         REWIND(17)
c
      end if
      go to 110
c
 410  continue
c
      print*,' Error writing time stamp.'
C
 9906 FORMAT(1h ,A,
     1     //1h ,'stream             ',A,
     1      /1h ,'time stamp         ',a,
     1     //1h ,'last time updated  ',a  )
c
c     call ebexit(2)
C
C           1.1  GET NEXT MESSAGE.
C                -----------------
 110  CONTINUE

      ostream=.true.
      ILEN=ILENBY
      print*,'Current time stamp is ',ctstamp(1:16)
C
 115  CONTINUE
C
      NUMBULL=NUMBULL+1 

C           1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C       WRITE(*,9902) NUMBULL
C
C           1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.EQ.NSKIP) GO TO 110
C
C
C           1.4  TRANSFER BULLETIN TO 'KCHAR' ONE CHARACTER PER WORD.
C                ----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
C      
      RETURN
C
C     -----------------------------------------------------------------
 400  CONTINUE
C
c 9902 FORMAT(1H ,' BULLETIN NUMBER = ',I9)
C
      END
      
      SUBROUTINE ISTIME(CTIME,ITM,IRET)
C
C**** *ISTIME*
C
C
C     PURPOSE.
C     --------
C         CALCULATE TIME IN MINUTES SINCE 1/1/1978,
C         GIVEN INPUT AS DD-MMM-YYYY HH:MM:SS.CC
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ISTIME(CTIME,ITM,IRET)*
C
C          INPUT :  CTIME (ASCII TIME)
C
C          OUTPUT:  ITM  ( TIME IN MINUTES SINCE 1/1/1978.)
C                   IRET ( RETURN CODE)            
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       21/10/89.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) CTIME
      CHARACTER*3 CM(12)
      character*3 month
C
      DIMENSION IDM(13)
C
      DATA IDM/0,31,28,31,30,31,30,31,31,30,31,30,31/  
      DATA CM /'Jan','Feb','Mar','Apr','May','Jun',
     1         'Jul','Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C*          1.   SET MONTH.
C                ----------
 100  CONTINUE
C
      idays=0
c
      DO 101 I=1,12
       IF(CTIME(4:6).EQ.CM(I)) THEN
          IM=I
          IM=IM+1
          GO TO  110
       END IF
 101  CONTINUE 
C  
C
C*          1.1  SET MINUTES.
C                ------------
 110  CONTINUE
C

      READ (CTIME,'(I2,5X,I4,1X,I2,1X,I2)',err=1111) ID,IY,IH,IMIN
c      READ (CTIME,'(I2,5X,I4,1X,I2,1X,I2)') ID,IY,IH,IMIN
C
      DO 111 I=1978,IY-1
       IDAYS=IDAYS+365
       IF(MOD(I,4).EQ.0) IDAYS=IDAYS+1
 111  CONTINUE
C
      DO 112 I=1,IM-1
       IDAYS=IDAYS+IDM(I) 
       IF(I.EQ.3) THEN
          IF(MOD(IY,4).EQ.0) IDAYS=IDAYS+1
       END IF
 112  CONTINUE
C
      IDAYS=IDAYS+ID-1
C
      ITM=IDAYS*1440+IH*60+IMIN

      RETURN
1111  print*,'error in read ctime= ', ctime     
      END 
C
      
      SUBROUTINE read_seq(iunit,ierr,ios,irecnum,key,yfilename,rec)
c
      integer iunit,ierr,ios,irecnum
      character*21 key
      character*21 yfilename
c
      structure /merge/
      character*21 station_date
      logical*1 oocont(4)
      integer*4 nncorn(4)
      integer*4 nma
      real      vvaluesa(1300)
      integer*4 iilenc
      character*9 ccvala(10)
      end structure
c
      record /merge/ rec
c
      character*21 key_table(2000)
      character*21 key_table1
c
      common /keytable/ key_table
      common /com_krecords/ krecords ! p/ contornar erro oriundo do
                                     ! enderecamento de variavel
                                     ! local na area de dados.
C
      krecords = krecords + 1

      do 11 i=1,krecords
c      print*,'keytable ',i,key_table(i)
c      print*,'key ',key
         if(key_table(i).eq.key) then
            irec = i
            go to 12
         end if
 11   continue
      irec = krecords
 12   irecnum = irec
      if(irec.lt.krecords) then
        krecords = krecords - 1
      end if
      key_table(irec)=key
c
c       nao sei porque a "key" muda de valor apos a leitura
c        key_table1
      key_table1=key
c
      ios = 0
 10   read(unit=iunit,iostat=ios,rec=irec) rec
c      print*,'ios ',ios,'irec ',irec
c      print*,'rec.station_date ',rec.station_date
c      print*,'keytable',key_table1
      if(ios .eq. 0 ) then        
        if(key_table1.eq.rec.station_date(1:21)) then
          ierr = 0
          return
        else
         key_table(irec)(1:21) = rec.station_date(1:21)
         irec = irec + 1
         irecnum = irec
c         key_table(irec) = key_table1
         go to 10
        endif 
      endif
      if (ios .eq. 36) then
         key_table(irec) = key_table1
         key = key_table(irecnum)
         krecords = irecnum
c         print*,'grava irec',irecnum,key_table(irec)(1:21)
         ierr = 1
         return
      endif
      if (ios .ne.0) go to 200
      
 200  write(6,220) iunit,ios
 220  format(' ********** ERROR DURING READING FILE ',i3,
     1       ' IOSTATUS = ',i3)
      ierr = -1
      return
      END
      
